// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(_) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function Xe(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Ke(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function Z(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = Z(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function ge(e, n, t) {
        if (t) for (var i in e) {
            if (ln(e, i) && !ln(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (ln(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (ln(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Qe() {}
    function Ze() {
        return false;
    }
    function en() {
        return true;
    }
    function nn() {
        return this;
    }
    function tn() {
        return null;
    }
    var rn = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === a) continue;
                if (r instanceof o) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function an(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function on(e, i) {
        return e.replace(/\{([^}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof dn ? t.print_to_string() : t;
        });
    }
    function sn(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function fn(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function un(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function cn() {
        this._values = Object.create(null);
        this._size = 0;
    }
    cn.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new cn();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    cn.fromObject = function(e) {
        var n = new cn();
        n._size = t(n._values, e);
        return n;
    };
    function ln(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function pn(e, n, t) {
        var i = e.parent(-1);
        for (var r = 0, a; a = e.parent(r++); i = a) {
            if (In(a)) {
                return n && a.value === i;
            } else if (a instanceof Yt) {
                if (a.left === i) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === i) continue;
            } else if (a instanceof Rt) {
                if (a.condition === i) continue;
            } else if (a instanceof At) {
                return t;
            } else if (a instanceof Mt) {
                if (a.expression === i) continue;
            } else if (a instanceof Ct) {
                if (a.expressions[0] === i) continue;
            } else if (a instanceof bn) {
                return true;
            } else if (a instanceof yi) {
                if (a.tag === i) continue;
            } else if (a instanceof Ht) {
                if (a.expression === i) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = dn;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var a = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(i && i.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (i) {
            s.BASE = i;
            i.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        for (var f in t) if (ln(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof _ !== "undefined") _["AST_" + e] = s;
        return s;
    }
    var ee = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var dn = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Fi(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Mi(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(on("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (dn.log_function = function(n, e) {
        if (typeof n != "function") {
            dn.info = dn.warn = Qe;
            return;
        }
        var t = Object.create(null);
        dn.info = e ? function(e, n) {
            i("INFO: " + on(e, n));
        } : Qe;
        dn.warn = function(e, n) {
            i("WARN: " + on(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    dn.enable_validation = function() {
        dn.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!ln(n.prototype, "transform")) return;
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof dn) {
                    t.validate();
                } else if (!(t === null || n && rn.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = i;
            });
        })(this);
    };
    dn.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var vn = i("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var hn = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, vn);
    var mn = i("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, vn);
    var _n = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, vn);
    function gn(e) {
        return e instanceof vn && !(e instanceof tt) && !(e instanceof Nn);
    }
    function o(e, n, t, i, r) {
        t = t ? "contain" : "be";
        if (!(e instanceof dn)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof $t) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof Wt) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Oi && !r) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof Pt && !i) throw new Error(n + " cannot " + t + " AST_Spread");
        if (gn(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof ri) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function s(e, n) {
        o(e[n], n);
    }
    var bn = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "body");
        }
    }, vn);
    var yn = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof yn)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof Mn)) throw new Error("must be contained within AST_Scope");
        }
    }, vn);
    function wn(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var xn = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                wn(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!gn(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, yn);
    var kn = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, xn);
    var P = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!gn(this.body)) throw new Error("body must be AST_Statement");
        }
    }, yn);
    var En = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new Mi(function(e) {
                    if (e instanceof ct) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof Mn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Ee)) throw new Error("label must be AST_Label");
        }
    }, P);
    var Sn = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, P);
    var Tn = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            s(this, "condition");
        }
    }, Sn);
    var An = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, Tn);
    var Dn = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, Tn);
    var On = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof dn)) throw new Error("init must be AST_Node");
                if (gn(this.init) && !(this.init instanceof wt)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) s(this, "condition");
            if (this.step != null) s(this, "step");
        }
    }, Sn);
    var $n = i("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof wt) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof Mt || e instanceof vi)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            s(this, "object");
        }
    }, Sn);
    var zn = i("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, $n);
    var be = i("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, $n);
    var qn = i("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, be);
    var Cn = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, P);
    var Mn = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: nn,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, xn);
    var Fn = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return Yi([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Fi(function(e) {
                if (e instanceof mn && e.value == "$ORIG") {
                    return rn.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return Yi([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Fi(function(e) {
                if (e instanceof mn && e.value == "$ORIG") {
                    return rn.splice(t);
                }
            }));
        }
    }, Mn);
    var jn = i("Lambda", "argnames length_read rest uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Mi(function(e) {
                if (e instanceof $t) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof Jt) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof ui) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                wn(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof ui)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof ui)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, Mn);
    var Pn = i("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, jn);
    var Nn = i("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, jn);
    function In(e) {
        return e instanceof Bn || e instanceof Ln;
    }
    function Hn(e) {
        return e instanceof Ln || e instanceof Xn || e instanceof Un || e instanceof Kn || e instanceof Vn;
    }
    function Yn(e) {
        return e instanceof Kn || e instanceof Vn || e instanceof Zn || e instanceof Gn;
    }
    function Rn(e, n) {
        if (In(e) && e.value) {
            e.value.walk(n);
        } else {
            wn(e, n);
        }
    }
    var Bn = i("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    wn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, Nn);
    var Ln = i("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    wn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, Nn);
    var Un = i("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof li)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Nn);
    var Vn = i("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof li)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Nn);
    var Wn = i("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof li)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Nn);
    var Gn = i("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof li)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Nn);
    var Jn = i("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof ci)) throw new Error("name must be AST_SymbolDefun");
        }
    }, jn);
    var Xn = i("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, Jn);
    var Kn = i("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, Jn);
    var Qn = i("Defun", null, {
        $documentation: "A function definition"
    }, Jn);
    var Zn = i("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, Jn);
    var et = i("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) s(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof it)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, yn);
    var nt = i("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof ke)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, et);
    var tt = i("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof pi)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, et);
    var it = i("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node] property name (AST_Node for computed property)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof dn) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof dn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof dn)) throw new Error("value must be AST_Node");
            }
        }
    });
    var rt = i("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, it);
    var ye = i("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof Pn)) throw new Error("value must be AST_Accessor");
        }
    }, it);
    var we = i("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof Pn)) throw new Error("value must be AST_Accessor");
        }
    }, it);
    var at = i("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof Nn)) throw new Error("value must be AST_LambdaExpression");
            if (In(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, it);
    var ot = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, vn);
    var st = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, ot);
    var ft = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, st);
    var ut = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            s(this, "value");
        }
    }, st);
    var ct = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Se)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, ot);
    var lt = i("Break", null, {
        $documentation: "A `break` statement"
    }, ct);
    var pt = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, ct);
    var dt = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            if (this.alternative != null) {
                if (!gn(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, P);
    var vt = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                wn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof ht)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, xn);
    var ht = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, xn);
    var mt = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, ht);
    var _t = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                wn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, ht);
    var gt = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                wn(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof bt)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof yt)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, xn);
    var bt = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                wn(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof di)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, xn);
    var yt = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, xn);
    var wt = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, vn);
    var xt = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof St)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof ai)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, wt);
    var kt = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof St)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof si)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, wt);
    var Et = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof St)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof fi)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, wt);
    var St = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    });
    var Tt = i("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof nt || this.body instanceof wt || this.body instanceof Jn)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, vn);
    var At = i("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof nt || this.body instanceof Jn)) {
                s(this, "body");
            }
        }
    }, vn);
    var xe = i("ExportForeign", "aliases keys path quote", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[string*] array of aliases to export",
            keys: "[string*] array of keys to import",
            path: "[string] the path to import module",
            quote: "[string?] the original quote character"
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (typeof e != "string") throw new Error("aliases must contain string");
            });
            this.keys.forEach(function(e) {
                if (typeof e != "string") throw new Error("keys must contain string");
            });
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, vn);
    var Dt = i("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof hi)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, vn);
    var Ot = i("Import", "all default path properties quote", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[string] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified",
            quote: "[string?] the original quote character"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof oi)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof oi)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key !== "") throw new Error("invalid default key: " + this.default.key);
            }
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof oi)) throw new Error("properties must contain AST_SymbolImport");
            });
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, vn);
    var $t = i("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            s(this, "value");
        }
    });
    function f(e, n, t, i) {
        e[n].forEach(function(e) {
            o(e, n, true, t, i);
        });
    }
    var zt = i("Call", "args expression optional pure", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[string/S] marker for side-effect-free call expression"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "expression");
            f(this, "args", true);
        }
    });
    var qt = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
        }
    }, zt);
    var Ct = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    var Mt = i("PropAccess", "expression optional property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof wi) return e.value;
            if (e instanceof It && e.operator == "void" && e.expression instanceof wi) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            s(this, "expression");
        }
    });
    var Ft = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Mt);
    var jt = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            s(this, "property");
        }
    }, Mt);
    var Pt = i("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Nt = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "expression");
        }
    });
    var It = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Nt);
    var Ht = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Nt);
    var Yt = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Bt)) s(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "right");
        }
    });
    var Rt = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            s(this, "consequent");
            s(this, "alternative");
        }
    });
    var Bt = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Wt) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof Mt || e instanceof vi)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            }
        }
    }, Yt);
    var Lt = i("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Ut = i("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                s(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var Vt = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var Wt = i("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function u(e, n, t) {
        if (e instanceof $t && t) return u(e.name, n);
        if (e instanceof Wt) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof Gt) return e.elements.forEach(function(e) {
                if (!(e instanceof Oi)) u(e, n, true);
            });
            if (e instanceof Xt) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var Gt = i("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, Wt);
    var Jt = i("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof dn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof dn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof dn)) throw new Error("value must be AST_Node");
        }
    });
    var Xt = i("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Jt)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Wt);
    var Kt = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Qt || e instanceof Pt)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var Qt = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof dn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof dn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof dn)) throw new Error("value must be AST_Node");
        }
    });
    var Zt = i("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            s(this, "value");
        }
    }, Qt);
    var ei = i("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof Nn)) throw new Error("value must be AST_LambdaExpression");
            if (In(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, Zt);
    var ni = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof Pn)) throw new Error("value must be AST_Accessor");
        }
    }, Qt);
    var ti = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof Pn)) throw new Error("value must be AST_Accessor");
        }
    }, Qt);
    var ii = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var ri = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, ii);
    var ai = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, ri);
    var oi = i("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[string] the original `export` name"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
        }
    }, ai);
    var si = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, ri);
    var fi = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, ri);
    var ui = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, fi);
    var ci = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, ri);
    var li = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, ri);
    var ke = i("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, ai);
    var pi = i("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, ai);
    var di = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, ri);
    var Ee = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, ii);
    var vi = i("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, ii);
    var hi = i("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[string] the `export` alias"
        },
        _validate: function() {
            if (typeof this.alias != "string") throw new Error("alias must be string");
        }
    }, vi);
    var Se = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, ii);
    var mi = i("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, ii);
    var _i = i("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, mi);
    var gi = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, mi);
    var bi = i("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, gi);
    var yi = i("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) s(this, "tag");
        }
    });
    var wi = i("Constant", null, {
        $documentation: "Base class for all constants",
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var xi = i("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, wi);
    var ki = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, wi);
    var Ei = i("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, wi);
    var Si = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, wi);
    var g = i("Atom", null, {
        $documentation: "Base class for atoms",
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, wi);
    var Ti = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, g);
    var Ai = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, g);
    var Di = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, g);
    var Oi = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, g);
    var $i = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, g);
    var zi = i("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, g);
    var qi = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, zi);
    var Ci = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, zi);
    function Mi(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Mi.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Qe);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof jn) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof mn && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof jn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Mn) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof mn)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof En && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Sn || e instanceof lt && i instanceof vt) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof Rt && t.condition === e || t instanceof Tn && t.condition === e || t instanceof On && t.condition === e || t instanceof dt && t.condition === e || t instanceof ft && t.in_bool || t instanceof Ct && t.tail_node() !== e || t instanceof bn || t instanceof It && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof Yt && (t.operator == "&&" || t.operator == "||") || t instanceof Rt || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof ft) {
                    for (var i, r = t; i = this.parent(++n); r = i) {
                        if (i.TYPE == "Call") {
                            if (!(r instanceof jn) || r.name) return false;
                        } else if (r instanceof jn) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Fi(e, n) {
        Mi.call(this);
        this.before = e;
        this.after = n;
    }
    Fi.prototype = new Mi();
    (function(e) {
        function t(e, n) {
            return rn(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(dn, Qe);
        e(En, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(bn, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(xn, function(e, n) {
            e.body = t(e.body, n);
        });
        e(An, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(Dn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(On, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e($n, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Cn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(st, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(ct, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(dt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(vt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(_t, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(gt, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(bt, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(wt, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(St, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e($t, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(jn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(Bn, n);
        e(Ln, n);
        e(et, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(it, function(e, n) {
            if (e.key instanceof dn) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(zt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Ct, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(Lt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Ut, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(Ft, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(jt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Pt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Nt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Yt, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Rt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Vt, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Gt, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(Jt, function(e, n) {
            if (e.key instanceof dn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(Xt, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(Kt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Qt, function(e, n) {
            if (e.key instanceof dn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(Tt, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(At, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Dt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Ot, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(yi, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Te = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof let new return switch throw try typeof var void while with";
    var C = "false null true";
    var N = [ "abstract async await boolean byte char double enum export final float goto implements import int interface long native package private protected public short static super synchronized this throws transient volatile yield", C, Te ].join(" ");
    var M = "return new delete throw else case";
    Te = fn(Te);
    N = fn(N);
    M = fn(M);
    C = fn(C);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var F = fn([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var j = "\n\r\u2028\u2029";
    var I = "+-*&%=<>!?|~^";
    var d = "[{(";
    var v = ",;:";
    var h = ")}]";
    var Ae = v + h;
    var H = d + v;
    var Y = H + "`" + h;
    var R = j + "  \t\f\v​             　\ufeff";
    var B = fn(e("./'\"#" + I + Y + R));
    j = fn(e(j));
    I = fn(e(I));
    Ae = fn(e(Ae));
    H = fn(e(H));
    Y = fn(e(Y));
    R = fn(e(R));
    function ne(e) {
        return e >= 55296 && e <= 56319;
    }
    function te(e) {
        return e >= 56320 && e <= 57343;
    }
    function L(e) {
        return e >= 48 && e <= 57;
    }
    function ie(e) {
        return !B[e];
    }
    function ji(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Pi(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Ni(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Ni.prototype = Object.create(Error.prototype);
    Ni.prototype.constructor = Ni;
    Ni.prototype.name = "SyntaxError";
    n(Ni);
    function De(e, n, t, i, r) {
        throw new Ni(e, n, t, i, r);
    }
    function Oe(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function $e(r, a, o, s) {
        var f = {
            text: r,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: [],
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = l(true, true);
                    switch (t) {
                      case "\\":
                        t += l(true, true);
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            f.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw V;
            if (j[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function v() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (j[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function h() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !Ii[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new ee(i);
        }
        function _() {
            while (R[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t, n)) n += l();
            return n;
        }
        function b(e) {
            De(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function w(e) {
            var t = false, i = false, r = false, a = e == ".";
            var n = g(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return r ? false : r = true;

                  case "e":
                  case "E":
                    return r ? true : t ? false : t = i = true;

                  case "+":
                  case "-":
                    return i;

                  case i = false, ".":
                    return a || t || r || y(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (y(n)) {
                if (q.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(r ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function x(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return k(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var i = Pi(n);
            if (typeof i != "string") b("Invalid escape sequence: \\" + n);
            return i;
        }
        function k(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && q.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = x(true); else if (j[i]) b("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = m("string", t);
            r.quote = e;
            return r;
        });
        function S(e) {
            var n = f.regex_allowed;
            var t = v(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, i, true));
            f.regex_allowed = n;
            return q;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return q;
        });
        function T() {
            var e = false, n, t = false, i = c() == "#" ? l() : "";
            while (n = c()) {
                if (!e) {
                    if (n == "\\") t = e = true, l(); else if (ie(n)) i += l(); else break;
                } else {
                    if (n != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = x();
                    if (!ie(n)) b("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    i += n;
                    e = false;
                }
            }
            if (Te[i] && t) {
                var r = i.charCodeAt(0).toString(16).toUpperCase();
                i = "\\u" + "0000".substr(r.length) + r + i.slice(1);
            }
            return i;
        }
        var A = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (j[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = T();
            try {
                var a = new RegExp(e, r);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return S("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? A("") : D("/");
        }
        function $() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return m("operator", n);
            }
            return L(e.charCodeAt(0)) ? w(".") : m("punc", ".");
        }
        function z() {
            var e = T();
            if (u) return m("name", e);
            return C[e] ? m("atom", e) : !Te[e] ? m("name", e) : F[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) b(n); else throw e;
                }
            };
        }
        function q(e) {
            if (e != null) return A(e);
            if (s && f.pos == 0 && d("#!")) {
                h();
                p(2);
                S("comment5");
            }
            for (;;) {
                _();
                h();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        S("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        S("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return $();

                  case 47:
                    var i = O();
                    if (i === q) continue;
                    return i;
                }
                if (L(t)) return w();
                if (Y[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (I[n]) return D();
                if (t == 35 || t == 92 || !B[n]) return z();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        q.context = function(e) {
            if (e) f = e;
            return f;
        };
        q.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        q.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        q.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        q.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return q;
    }
    var ze = fn("typeof void delete -- ++ ! ~ - +");
    var Ii = fn("-- ++");
    var qe = fn("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var Hi = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Ce = fn("atom bigint num regexp string");
    function Yi(e, l) {
        l = ge(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof e == "string" ? $e(e, l.filename, l.html5_comments, l.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return Oe(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function o(e, n, t, i) {
            var r = _.input.context();
            De(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function s(e, n) {
            o(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            s(e, "Unexpected token: " + t(e.type, e.value));
        }
        function f(e, n) {
            if (g(e, n)) return b();
            s(_.token, "Unexpected token: " + t(_.token.type, _.token.value) + ", expected: " + t(e, n));
        }
        function x(e) {
            return f("punc", e);
        }
        function u(e) {
            return e.nlb || !un(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || u(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = he();
            x(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = _.token;
                var n = i.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function E() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var v = n(function() {
            E();
            switch (_.token.type) {
              case "string":
                var e = _.in_directives;
                var n = he();
                if (e) {
                    if (n instanceof xi) {
                        var t = n.start.raw.slice(1, -1);
                        _.input.add_directive(t);
                        n.value = t;
                    } else {
                        _.in_directives = e = false;
                    }
                }
                k();
                return e ? new mn(n) : new bn({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return m();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if (Oe(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return z(Xn);
                        b();
                        return z(Kn);
                    }
                    break;

                  case "await":
                    if (_.in_async) return m();
                    break;

                  case "export":
                    b();
                    return M();

                  case "import":
                    var i = p();
                    if (!(i.type == "punc" && /^[(.]$/.test(i.value))) {
                        b();
                        return P();
                    }

                  case "yield":
                    if (_.in_generator) return m();
                    break;
                }
                return Oe(p(), "punc", ":") ? h() : m();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new kn({
                        start: _.token,
                        body: N(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return m();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new _n();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return S(lt);

                  case "class":
                    b();
                    return A(nt);

                  case "const":
                    b();
                    var r = R();
                    k();
                    return r;

                  case "continue":
                    b();
                    return S(pt);

                  case "debugger":
                    b();
                    k();
                    return new hn();

                  case "do":
                    b();
                    var n = me(v);
                    f("keyword", "while");
                    var a = d();
                    k(true);
                    return new An({
                        body: n,
                        condition: a
                    });

                  case "while":
                    b();
                    return new Dn({
                        condition: d(),
                        body: me(v)
                    });

                  case "for":
                    b();
                    return D();

                  case "function":
                    b();
                    if (!g("operator", "*")) return z(Qn);
                    b();
                    return z(Zn);

                  case "if":
                    b();
                    return q();

                  case "let":
                    b();
                    var r = B();
                    k();
                    return r;

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) o("'return' outside of function");
                    b();
                    var t = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        t = he();
                        k();
                    }
                    return new ft({
                        value: t
                    });

                  case "switch":
                    b();
                    return new vt({
                        expression: d(),
                        body: me(I)
                    });

                  case "throw":
                    b();
                    if (u(_.token)) o("Illegal newline after 'throw'");
                    var t = he();
                    k();
                    return new ut({
                        value: t
                    });

                  case "try":
                    b();
                    return H();

                  case "var":
                    b();
                    var r = L();
                    k();
                    return r;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        o("Strict mode may not include a with statement");
                    }
                    b();
                    return new Cn({
                        expression: d(),
                        body: v()
                    });
                }
            }
            w();
        });
        function h() {
            var n = te(Ee);
            if (!un(_.labels, function(e) {
                return e.name != n.name;
            })) {
                o("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = v();
            _.labels.pop();
            if (!(e instanceof Sn)) {
                n.references.forEach(function(e) {
                    if (e instanceof pt) {
                        s(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new En({
                body: e,
                label: n
            });
        }
        function m() {
            var e = he();
            k();
            return new bn({
                body: e
            });
        }
        function S(e) {
            var n = null, t;
            if (!c()) {
                n = te(Se, true);
            }
            if (n != null) {
                t = Ke(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) s(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) o(e.TYPE + " not inside a loop or switch");
            k();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function T(e) {
            if (!g("name", e)) return;
            var n = p();
            if (!n) return;
            if (Oe(n, "operator", "=")) return;
            if (n.type == "punc" && /^[(;}]$/.test(n.value)) return;
            if (u(n)) return;
            return b();
        }
        function A(e) {
            var n = _.in_async;
            var t = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var i;
            if (e === nt) {
                i = te(ke);
            } else {
                i = te(pi, true);
            }
            var r = null;
            if (g("keyword", "extends")) {
                b();
                E();
                r = W(true);
            }
            x("{");
            var a = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var o = _.token;
                var s = !!T("static");
                var f = T("async");
                if (g("operator", "*")) {
                    b();
                    var u = g("name") && /^#/.test(_.token.value);
                    var c = Q();
                    var l = _.token;
                    var p = z(f ? Vn : Gn);
                    p.start = l;
                    p.end = y();
                    a.push(new at({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: p,
                        end: y()
                    }));
                    continue;
                }
                var u = g("name") && /^#/.test(_.token.value);
                var c = Q();
                if (g("punc", "(")) {
                    var d = _.token;
                    var v = z(f ? Un : Wn);
                    v.start = d;
                    v.end = y();
                    a.push(new at({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: v,
                        end: y()
                    }));
                    continue;
                }
                if (f) w(f);
                var h = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    h = ve();
                    _.in_generator = t;
                    _.in_async = n;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var m = null;
                    switch (c) {
                      case "get":
                        m = ye;
                        break;

                      case "set":
                        m = we;
                        break;
                    }
                    if (m) {
                        a.push(new m({
                            start: o,
                            static: s,
                            private: g("name") && /^#/.test(_.token.value),
                            key: Q(),
                            value: X(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                a.push(new rt({
                    start: o,
                    static: s,
                    private: u,
                    key: c,
                    value: h,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = t;
            _.in_async = n;
            return new e({
                extends: r,
                name: i,
                properties: a
            });
        }
        function D() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), R(true)) : g("keyword", "let") ? (b(), B(true)) : g("keyword", "var") ? (b(), 
                L(true)) : he(true);
                var t;
                if (e) {
                    f("name", "of");
                    t = qn;
                } else if (g("operator", "in")) {
                    b();
                    t = zn;
                } else if (g("name", "of")) {
                    b();
                    t = be;
                }
                if (t) {
                    if (n instanceof wt) {
                        if (n.definitions.length > 1) {
                            s(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== zn && n.definitions[0].value) {
                            s(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(pe(n) || (n = de(n)) instanceof Wt)) {
                        s(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return r(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : he();
            x(";");
            var t = g("punc", ")") ? null : he();
            x(")");
            return new On({
                init: e,
                condition: n,
                step: t,
                body: me(v)
            });
        }
        function r(e, n) {
            E();
            var t = he();
            x(")");
            return new e({
                init: n,
                object: t,
                body: me(v)
            });
        }
        function O(e) {
            if (e instanceof Vt) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Pt) {
                    n = O(e.elements.pop().expression);
                }
                return new Gt({
                    start: e.start,
                    elements: e.elements.map(O),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Bt) return new $t({
                start: e.start,
                name: O(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof $t) {
                e.name = O(e.name);
                return e;
            }
            if (e instanceof Gt) {
                e.elements = e.elements.map(O);
                if (e.rest) e.rest = O(e.rest);
                return e;
            }
            if (e instanceof Xt) {
                e.properties.forEach(function(e) {
                    e.value = O(e.value);
                });
                if (e.rest) e.rest = O(e.rest);
                return e;
            }
            if (e instanceof Oi) return e;
            if (e instanceof Kt) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof Pt) {
                    n = O(e.properties.pop().expression);
                }
                return new Xt({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof Zt)) s(e.start, "Invalid destructuring assignment");
                        return new Jt({
                            start: e.start,
                            key: e.key,
                            value: O(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof ui) return e;
            if (e instanceof vi) return new ui(e);
            s(e.start, "Invalid arrow parameter");
        }
        function $(e, n, t) {
            var i = _.in_async;
            var r = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var o = e.map(O);
            var s = e.rest || null;
            if (s) s = O(s);
            _.in_funarg = a;
            x("=>");
            var f, u;
            var c = _.in_loop;
            var l = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                f = N();
                u = null;
            } else {
                f = [];
                E();
                u = ve();
            }
            var p = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = c;
            _.labels = l;
            _.in_generator = r;
            _.in_async = i;
            var d = new (t ? Ln : Bn)({
                start: n,
                argnames: o,
                rest: s,
                body: f,
                value: u,
                end: y()
            });
            if (p) d.each_argname(ne);
            return d;
        }
        var z = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var i;
            if (/Defun$/.test(e.TYPE)) {
                i = te(ci);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                i = te(li, true);
            }
            if (i && e !== Pn && !(i instanceof ri)) w(y());
            x("(");
            var r = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = G(")", !l.strict, false, function() {
                return re(ui);
            });
            _.in_funarg = r;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = N();
            var u = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var c = new e({
                name: i,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (u) {
                if (i) ne(i);
                c.each_argname(ne);
            }
            return c;
        };
        function q() {
            var e = d(), n = v(), t = null;
            if (g("keyword", "else")) {
                b();
                t = v();
            }
            return new dt({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function C() {
            return g("name") || ji(_.token.value);
        }
        function M() {
            if (g("operator", "*")) {
                b();
                var e = "*";
                if (g("name", "as")) {
                    b();
                    if (!C()) f("name");
                    e = _.token.value;
                    b();
                }
                f("name", "from");
                var n = _.token;
                f("string");
                k();
                return new xe({
                    aliases: [ e ],
                    keys: [ "*" ],
                    path: n.value,
                    quote: n.quote
                });
            }
            if (g("punc", "{")) {
                b();
                var i = [];
                var t = [];
                while (C()) {
                    var r = _.token;
                    b();
                    t.push(r);
                    if (g("name", "as")) {
                        b();
                        if (!C()) f("name");
                        i.push(_.token.value);
                        b();
                    } else {
                        i.push(r.value);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    var n = _.token;
                    f("string");
                    k();
                    return new xe({
                        aliases: i,
                        keys: t.map(function(e) {
                            return e.value;
                        }),
                        path: n.value,
                        quote: n.quote
                    });
                }
                k();
                return new Dt({
                    properties: t.map(function(e, n) {
                        if (!Oe(e, "name")) s(e, "Name expected");
                        var t = ee(hi, e);
                        t.alias = i[n];
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var a = _.token;
                var o = F();
                if (o) {
                    o.start = a;
                    o.end = y();
                } else {
                    E();
                    o = he();
                    k();
                }
                return new At({
                    body: o
                });
            }
            return new Tt({
                body: j()
            });
        }
        function a(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === nt ? ke : ci)(n.name);
            }
            return n;
        }
        function F() {
            if (g("name", "async")) {
                if (!Oe(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return a(Xn, z(Un));
                b();
                return a(Kn, z(Vn));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return a(nt, A(tt));

              case "function":
                b();
                if (!g("operator", "*")) return a(Qn, z(Wn));
                b();
                return a(Zn, z(Gn));
            }
        }
        var j = n(function() {
            if (g("name", "async")) {
                b();
                f("keyword", "function");
                if (!g("operator", "*")) return z(Xn);
                b();
                return z(Kn);
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return A(nt);

              case "const":
                b();
                var e = R();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return z(Qn);
                b();
                return z(Zn);

              case "let":
                b();
                var e = B();
                k();
                return e;

              case "var":
                b();
                var e = L();
                k();
                return e;
            }
            w();
        });
        function P() {
            var e = null;
            var n = te(oi, true);
            var t = null;
            if (n ? (n.key = "", g("punc", ",") && b()) : !g("string")) {
                if (g("operator", "*")) {
                    b();
                    f("name", "as");
                    e = te(oi);
                    e.key = "*";
                } else {
                    x("{");
                    t = [];
                    while (C()) {
                        var i;
                        if (Oe(p(), "name", "as")) {
                            var r = _.token.value;
                            b();
                            b();
                            i = te(oi);
                            i.key = r;
                        } else {
                            i = te(oi);
                            i.key = i.name;
                        }
                        t.push(i);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) f("name", "from");
            var a = _.token;
            f("string");
            k();
            return new Ot({
                all: e,
                default: n,
                path: a.value,
                properties: t,
                quote: a.quote
            });
        }
        function N() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(v());
            }
            b();
            return e;
        }
        function I() {
            x("{");
            var e = [], n, t, i, r;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new _t({
                        start: (r = _.token, b(), r),
                        expression: he(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (i) o("More than one default clause in switch statement");
                    t = [];
                    n = new mt({
                        start: (r = _.token, b(), x(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) w();
                    t.push(v());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function H() {
            var e = N(), n = null, t = null;
            if (g("keyword", "catch")) {
                var i = _.token;
                b();
                var r = null;
                if (g("punc", "(")) {
                    b();
                    r = ie(di);
                    x(")");
                }
                n = new bt({
                    start: i,
                    argname: r,
                    body: N(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var i = _.token;
                b();
                t = new yt({
                    start: i,
                    body: N(),
                    end: y()
                });
            }
            if (!n && !t) o("Missing catch/finally blocks");
            return new gt({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function Y(e, n) {
            var t = [];
            for (;;) {
                var i = _.token;
                var r = ie(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = ve(n);
                } else if (!n && (e === ai || r instanceof Wt)) {
                    o("Missing initializer in declaration");
                }
                t.push(new St({
                    start: i,
                    name: r,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        var R = function(e) {
            return new xt({
                start: y(),
                definitions: Y(ai, e),
                end: y()
            });
        };
        var B = function(e) {
            return new kt({
                start: y(),
                definitions: Y(si, e),
                end: y()
            });
        };
        var L = function(e) {
            return new Et({
                start: y(),
                definitions: Y(fi, e),
                end: y()
            });
        };
        var U = function(e) {
            var n = _.token;
            f("operator", "new");
            var t;
            if (g("punc", ".") && Oe(p(), "name", "target")) {
                b();
                b();
                t = new bi();
            } else {
                var i = W(false), r;
                if (g("punc", "(")) {
                    b();
                    r = G(")", !l.strict);
                } else {
                    r = [];
                }
                t = new qt({
                    expression: i,
                    args: r
                });
            }
            t.start = n;
            t.end = y();
            return oe(t, e);
        };
        function V() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new ki({
                        value: t
                    });
                } else {
                    e = new $i();
                    if (t < 0) e = new It({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new Ei({
                    value: t
                });
                break;

              case "string":
                e = new xi({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new Si({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new qi();
                    break;

                  case "true":
                    e = new Ci();
                    break;

                  case "null":
                    e = new Ti();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var W = function(e) {
            if (g("operator", "new")) {
                return U(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    var t = ae(null);
                    t.start = n;
                    t.end = y();
                    return oe(t, e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return $([], n);
                    }
                    var i = he(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(i.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = i.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var a = n.comments_before[0];
                        if (!a.nlb) {
                            a.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = i.start.comments_after;
                    i.start = n;
                    x(")");
                    var o = y();
                    o.comments_before = i.end.comments_before;
                    o.comments_after.forEach(function(e) {
                        i.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    o.comments_after.length = 0;
                    o.comments_after = i.end.comments_after;
                    i.end = o;
                    if (g("punc", "=>")) return $(i instanceof Ct ? i.expressions : [ i ], n);
                    return oe(i, e);

                  case "[":
                    return oe(J(), e);

                  case "{":
                    return oe(K(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var s = A(tt);
                s.start = n;
                s.end = y();
                return oe(s, e);

              case "function":
                b();
                var f;
                if (g("operator", "*")) {
                    b();
                    f = z(Gn);
                } else {
                    f = z(Wn);
                }
                f.start = n;
                f.end = y();
                return oe(f, e);
            }
            if (g("name")) {
                var u = ee(vi, n);
                b();
                if (u.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var f;
                        if (g("operator", "*")) {
                            b();
                            f = z(Vn);
                        } else {
                            f = z(Un);
                        }
                        f.start = n;
                        f.end = y();
                        return oe(f, e);
                    }
                    if (g("name") && Oe(p(), "punc", "=>")) {
                        n = _.token;
                        u = ee(vi, n);
                        b();
                        return $([ u ], n, true);
                    }
                    if (g("punc", "(")) {
                        var c = oe(u, e);
                        if (!g("punc", "=>")) return c;
                        var l = c.args;
                        if (l[l.length - 1] instanceof Pt) {
                            l.rest = l.pop().expression;
                        }
                        return $(l, n, true);
                    }
                }
                return g("punc", "=>") ? $([ u ], n) : oe(u, e);
            }
            if (Ce[_.token.type]) {
                return oe(V(), e);
            }
            w();
        };
        function G(e, n, t, i) {
            if (!i) i = ve;
            var r = true, a = [];
            while (!g("punc", e)) {
                if (r) r = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Oi({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(i());
                } else if (i === ve) {
                    a.push(new Pt({
                        start: _.token,
                        expression: (b(), i()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = i();
                    if (a.rest instanceof $t) s(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var J = n(function() {
            x("[");
            return new Vt({
                elements: G("]", !l.strict, true)
            });
        });
        var X = n(function() {
            return z(Pn);
        });
        var K = n(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var i = Q();
                    var r = _.token;
                    var a = z(Gn);
                    a.start = r;
                    a.end = y();
                    n.push(new ei({
                        start: t,
                        key: i,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new Pt({
                        start: t,
                        expression: ve(),
                        end: y()
                    }));
                    continue;
                }
                if (Oe(p(), "operator", "=")) {
                    var o = te(vi);
                    b();
                    n.push(new Zt({
                        start: t,
                        key: t.value,
                        value: new Bt({
                            start: t,
                            left: o,
                            operator: "=",
                            right: ve(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if (Oe(p(), "punc", ",") || Oe(p(), "punc", "}")) {
                    n.push(new Zt({
                        start: t,
                        key: t.value,
                        value: te(vi),
                        end: y()
                    }));
                    continue;
                }
                var i = Q();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = z(Wn);
                    f.start = s;
                    f.end = y();
                    n.push(new ei({
                        start: t,
                        key: i,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new Zt({
                        start: t,
                        key: i,
                        value: ve(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (i) {
                  case "async":
                    var u = g("operator", "*") && b();
                    i = Q();
                    var s = _.token;
                    var f = z(u ? Vn : Un);
                    f.start = s;
                    f.end = y();
                    n.push(new ei({
                        start: t,
                        key: i,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new ti({
                        start: t,
                        key: Q(),
                        value: X(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new ni({
                        start: t,
                        key: Q(),
                        value: X(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new Kt({
                properties: n
            });
        });
        function Q() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Te[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = ve();
                x("]");
                return n;

              default:
                w();
            }
        }
        function Z() {
            var e = _.token.value;
            f("name");
            return e;
        }
        function ee(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = _i;
                break;

              case "this":
                e = gi;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function ne(e) {
            if (e.name == "arguments" || e.name == "eval") s(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function te(e, n) {
            if (!g("name")) {
                if (!n) o("Name expected");
                return null;
            }
            var t = ee(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof ri) {
                ne(t);
            }
            b();
            return t;
        }
        function ie(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = G("]", !l.strict, true, function() {
                    return re(e);
                });
                return new Gt({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var i = true, r = [], a = null;
                while (!g("punc", "}")) {
                    if (i) i = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || Oe(p(), "punc", ":")) {
                        var s = Q();
                        x(":");
                        r.push(new Jt({
                            start: o,
                            key: s,
                            value: re(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = ie(e);
                        break;
                    }
                    var f = te(e);
                    if (g("operator", "=")) {
                        b();
                        f = new $t({
                            start: f.start,
                            name: f,
                            value: ve(),
                            end: y()
                        });
                    }
                    r.push(new Jt({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new Xt({
                    start: n,
                    properties: r,
                    rest: a,
                    end: y()
                });
            }
            return te(e);
        }
        function re(e) {
            var n = _.token;
            var t = ie(e);
            if (!g("operator", "=")) return t;
            b();
            return new $t({
                start: n,
                name: t,
                value: ve(),
                end: y()
            });
        }
        function ae(e) {
            var n = _.input.context().read_template;
            var t = [];
            var i = [];
            while (n(t)) {
                b();
                i.push(he());
                if (!g("punc", "}")) w();
            }
            b();
            return new yi({
                expressions: i,
                strings: t,
                tag: e
            });
        }
        var oe = function(e, n, t) {
            var i = e.start;
            if (g("punc", "[")) {
                b();
                var r = he();
                x("]");
                return oe(new jt({
                    start: i,
                    optional: t,
                    expression: e,
                    property: r,
                    end: y()
                }), n);
            }
            if (n && g("punc", "(")) {
                b();
                var a = new zt({
                    start: i,
                    optional: t,
                    expression: e,
                    args: G(")", !l.strict),
                    end: y()
                });
                return oe(a, true);
            }
            if (t || g("punc", ".")) {
                if (!t) b();
                return oe(new Ft({
                    start: i,
                    optional: t,
                    expression: e,
                    property: Z(),
                    end: y()
                }), n);
            }
            if (g("punc", "`")) {
                var o = ae(e);
                o.start = e.start;
                o.end = y();
                return oe(o, n);
            }
            if (g("operator", "?") && Oe(p(), "punc", ".")) {
                b();
                b();
                return oe(e, n, true);
            }
            if (e instanceof zt && !e.pure) {
                var i = e.start;
                var s = i.comments_before;
                var f = ln(i, "comments_before_length") ? i.comments_before_length : s.length;
                while (--f >= 0) {
                    var u = /[@#]__PURE__/.exec(s[f].value);
                    if (u) {
                        e.pure = u[0];
                        break;
                    }
                }
            }
            return e;
        };
        function se(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) o("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new Lt({
                    start: n,
                    expression: se(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) o("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var i = false;
                if (g("operator", "*")) {
                    b();
                    t = ve(e);
                    i = true;
                } else if (g("punc") ? !Ae[_.token.value] : !c()) {
                    t = ve(e);
                }
                return new Ut({
                    start: n,
                    expression: t,
                    nested: i,
                    end: y()
                });
            }
            if (g("operator") && ze[n.value]) {
                b();
                E();
                var r = fe(It, n, se(e));
                r.start = n;
                r.end = y();
                return r;
            }
            var a = W(true);
            while (g("operator") && Ii[_.token.value] && !u(_.token)) {
                a = fe(Ht, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function fe(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!pe(t)) s(n, "Invalid use of " + i + " operator");
                break;

              case "delete":
                if (t instanceof vi && _.input.has_directive("use strict")) s(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var ue = function(e, n, t) {
            var i = g("operator") ? _.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Hi[i] : null;
            if (r != null && r > n) {
                b();
                var a = ue(se(t), i == "**" ? r - 1 : r, t);
                return ue(new Yt({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function ce(e) {
            return ue(se(e), 0, e);
        }
        var le = function(e) {
            var n = _.token;
            var t = ce(e);
            if (g("operator", "?")) {
                b();
                var i = ve();
                x(":");
                return new Rt({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: ve(e),
                    end: y()
                });
            }
            return t;
        };
        function pe(e) {
            return e instanceof Mt && !e.optional || e instanceof vi;
        }
        function de(e) {
            if (e instanceof Vt) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Pt) {
                    n = de(e.elements.pop().expression);
                    if (!(n instanceof Wt || pe(n))) return e;
                }
                var t = e.elements.map(de);
                return un(t, function(e) {
                    return e instanceof $t || e instanceof Wt || e instanceof Oi || pe(e);
                }) ? new Gt({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Bt) {
                var i = de(e.left);
                return i instanceof Wt || pe(i) ? new $t({
                    start: e.start,
                    name: i,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof Kt)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof Pt) {
                n = de(e.properties.pop().expression);
                if (!(n instanceof Wt || pe(n))) return e;
            }
            var r = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof Zt)) return e;
                var s = de(o.value);
                if (!(s instanceof $t || s instanceof Wt || pe(s))) {
                    return e;
                }
                r.push(new Jt({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new Xt({
                start: e.start,
                properties: r,
                rest: n,
                end: e.end
            });
        }
        function ve(e) {
            var n = _.token;
            var t = le(e), i = _.token.value;
            if (g("operator") && qe[i]) {
                if (pe(t) || i == "=" && (t = de(t)) instanceof Wt) {
                    b();
                    return new Bt({
                        start: n,
                        left: t,
                        operator: i,
                        right: ve(e),
                        end: y()
                    });
                }
                o("Invalid assignment");
            }
            return t;
        }
        function he(e, n) {
            var t = _.token;
            var i = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    i.rest = ie(ui);
                    break;
                }
                i.push(ve(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && Oe(p(), "punc", "=>")) break;
            }
            return i.length == 1 && !i.rest ? i[0] : new Ct({
                start: t,
                expressions: i,
                end: y()
            });
        }
        function me(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            E();
            var _e = he();
            f("eof");
            return _e;
        }
        return function() {
            var e = _.token;
            var n = [];
            _.input.push_directives_stack();
            while (!g("eof")) n.push(v());
            _.input.pop_directives_stack();
            var t = y() || e;
            var i = l.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new Fn({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, i) {
        this.eliminated = 0;
        this.exported = false;
        this.global = false;
        this.id = e;
        this.init = i;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = x(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var i = n.variables.get(t) || n instanceof Fn && n.globals.get(t) || e.orig[0] instanceof ai && Ke(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (i && i !== e) return i.redefined() || i;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.exported || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof pi || this.orig[0] instanceof ke || this.orig[0] instanceof ci || this.orig[0] instanceof li);
        }
    };
    var Ri = fn("delete ++ --");
    function Bi(e, n) {
        if (n instanceof Bt) return n.left === e && e;
        if (n instanceof $t) return n.name === e && e;
        if (n instanceof Wt) return e;
        if (n instanceof Jt) return e;
        if (n instanceof $n) return n.init === e && e;
        if (n instanceof Nt) return Ri[n.operator] && n.expression;
    }
    Fn.DEFMETHOD("figure_out_scope", function(c) {
        c = ge(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var s = null;
        var f = false;
        var t = 0;
        var u = l.parent_scope = null;
        var p = new Mi(function(i, e) {
            if (i instanceof nt) {
                var n = f;
                f = p.parent() instanceof Tt;
                i.name.walk(p);
                f = n;
                a(function() {
                    if (i.extends) i.extends.walk(p);
                    i.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (i instanceof wt) {
                var n = f;
                f = p.parent() instanceof Tt;
                e();
                f = n;
                return true;
            }
            if (i instanceof Jn) {
                var n = f;
                f = p.parent() instanceof Tt;
                i.name.walk(p);
                f = n;
                a(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (i.rest) i.rest.walk(p);
                    wn(i, p);
                });
                return true;
            }
            if (i instanceof ht) {
                i.init_vars(u);
                e();
                return true;
            }
            if (i instanceof gt) {
                a(function() {
                    wn(i, p);
                });
                if (i.bcatch) i.bcatch.walk(p);
                if (i.bfinally) i.bfinally.walk(p);
                return true;
            }
            if (i instanceof Cn) {
                var t = u;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (i instanceof yn) {
                a(e);
                return true;
            }
            if (i instanceof ii) {
                i.scope = u;
            }
            if (i instanceof Ee) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof di) {
                u.def_variable(i).defun = s;
            } else if (i instanceof ai) {
                var r = u.def_variable(i);
                r.defun = s;
                if (f) r.exported = true;
            } else if (i instanceof ci) {
                var r = s.def_function(i, p.parent());
                if (f) r.exported = true;
                o(s, u);
            } else if (i instanceof ui) {
                s.def_variable(i);
                o(s, u);
            } else if (i instanceof li) {
                var r = s.def_function(i, i.name == "arguments" ? undefined : s);
                if (c.ie) r.defun = s.parent_scope.resolve();
            } else if (i instanceof si) {
                var r = u.def_variable(i);
                if (f) r.exported = true;
            } else if (i instanceof fi) {
                var r = s.def_variable(i, i instanceof oi ? undefined : null);
                if (f) r.exported = true;
                o(s, u);
            }
            function a(e) {
                i.init_vars(u);
                var n = s;
                var t = u;
                if (i instanceof Mn) s = i;
                u = i;
                e();
                u = t;
                s = n;
            }
            function o(e, n) {
                if (e === n) return;
                i.mark_enclosed(c);
                var t = n.find_variable(i.name);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(c);
            }
        });
        l.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new cn();
        var d = [];
        var p = new Mi(function(e) {
            if (e instanceof bt) {
                if (!(e.argname instanceof Wt)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                wn(e, p);
                return true;
            }
            if (e instanceof jn) {
                d.push(e);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                Rn(e, p);
                return true;
            }
            if (e instanceof ct) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof ri) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof di) {
                    var t = n.redefined();
                    if (t) for (var i = e.scope; i; i = i.parent_scope) {
                        an(i.enclosed, t);
                        if (i === t.scope) break;
                    }
                } else if (e instanceof ai) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                }
                if (e.name != "arguments") return true;
                var r = e instanceof fi && p.parent();
                if (r instanceof St && !r.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && v(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof vi) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof di || f instanceof ui || f instanceof li) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && v(a)) {
                    var r = p.parent();
                    if (Bi(e, r)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(r instanceof Mt && r.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var r = p.parent();
                    if (r.TYPE == "Call" && r.expression === e) {
                        var i = e.scope;
                        do {
                            i = i.resolve();
                            if (i.uses_eval) break;
                            i.uses_eval = true;
                        } while (i = i.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof Jn && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Mi(function(e) {
            if (e instanceof di) {
                var n = e.thedef.defun;
                if (n.name instanceof li && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof li) {
                var t = e.thedef;
                if (!i(e, e.scope.parent_scope.resolve())) {
                    delete t.defun;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function v(e) {
            return e.orig[0] instanceof ui && !(e.orig[1] instanceof ui || e.orig[2] instanceof ui) && !In(e.scope);
        }
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!un(i.orig, function(e) {
                return !(e instanceof ai || e instanceof si);
            })) return false;
            var r = n.find_variable(t);
            if (r) {
                var a = r.redefined();
                if (a) r = a;
            } else {
                r = l.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            if (r.undeclared) l.variables.set(t, r);
            if (t == "arguments" && v(i) && e instanceof li) return true;
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = i;
                e.thedef = r;
                e.reference(c);
            });
            return true;
        }
    });
    Fn.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function b(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new cn();
        e.variables = new cn();
        if (n) e.make_def = n.make_def;
    }
    function y(e, n) {
        b(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    yn.DEFMETHOD("init_vars", function(e) {
        b(this, e);
    });
    Mn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    Bn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        return this;
    });
    Ln.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    jn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        this.uses_arguments = false;
        this.def_variable(new ui({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    ii.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            an(t.enclosed, n);
            if (!e) {
                delete t._var_names;
            } else if (e.keep_fnames) {
                t.functions.each(function(e) {
                    an(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    ii.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    yn.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    yn.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof Jn) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    yn.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof Nn) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function w(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function x(e, i) {
        var n = e.scope;
        var t = w(n, i);
        var r = n.cname_holes;
        var a = Object.create(null);
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (o.indexOf(n) < 0) {
                    for (var t in w(n, i)) {
                        a[t] = true;
                    }
                    o.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = E(r[f]);
            if (a[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = E(++n.cname);
            if (t[s] || N[s] || i.reserved.has[s]) continue;
            if (!a[s]) break;
            r.push(n.cname);
        }
        t[s] = true;
        return s;
    }
    ii.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Ee.DEFMETHOD("unmangleable", Ze);
    ii.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function k(e) {
        e = ge(e, {
            eval: false,
            ie: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        an(e.reserved, "arguments");
        e.reserved.has = fn(e.reserved);
        return e;
    }
    Fn.DEFMETHOD("mangle_names", function(a) {
        a = k(a);
        var o = -1;
        if (a.cache && a.cache.props) {
            var n = w(this, a);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var s = [];
        var f = new Mi(function(n, e) {
            if (n instanceof En) {
                var t = o;
                e();
                if (!a.v8 || !l(f)) o = t;
                return true;
            }
            if (n instanceof yn) {
                if (a.webkit && n instanceof Sn && n.init instanceof kt) {
                    n.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof si)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                n.to_mangle = [];
                n.variables.each(function(e) {
                    if (!c(e)) n.to_mangle.push(e);
                });
                e();
                if (a.cache && n instanceof Fn) {
                    n.globals.each(u);
                }
                if (n instanceof Qn && f.has_directive("use asm")) {
                    var i = new vi(n.name);
                    i.scope = n;
                    i.reference(a);
                }
                n.to_mangle.forEach(u);
                return true;
            }
            if (n instanceof Ee) {
                var r;
                do {
                    r = E(++o);
                } while (N[r]);
                n.mangled_name = r;
                return true;
            }
        });
        this.walk(f);
        s.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function c(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof ai)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            s.push(n);
            n.references.forEach(r);
            if (e instanceof di || e instanceof ai) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
        function l(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof xn) return t instanceof Fn && !a.toplevel;
                if (t instanceof En) return true;
            }
        }
    });
    Fn.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(N);
        t.reserved.forEach(r);
        this.globals.each(a);
        this.walk(new Mi(function(e) {
            if (e instanceof yn) e.variables.each(a);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    Fn.DEFMETHOD("expand_names", function(i) {
        E.reset();
        E.sort();
        i = k(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(a);
        this.walk(new Mi(function(e) {
            if (e instanceof yn) e.variables.each(a);
        }));
        function r() {
            var e;
            do {
                e = E(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    dn.DEFMETHOD("tail_node", nn);
    Ct.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    Fn.DEFMETHOD("compute_char_frequency", function(e) {
        e = k(e);
        E.reset();
        var n = ii.prototype.add_source_map;
        try {
            ii.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) E.consider(this.name, -1);
            };
            if (e.properties) {
                Ft.prototype.add_source_map = function() {
                    E.consider(this.property, -1);
                };
                jt.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            E.consider(this.print_to_string(), 1);
        } finally {
            ii.prototype.add_source_map = n;
            delete Ft.prototype.add_source_map;
            delete jt.prototype.add_source_map;
        }
        E.sort();
        function t(e) {
            if (e instanceof xi) {
                E.consider(e.value, -1);
            } else if (e instanceof Rt) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Ct) {
                t(e.tail_node());
            }
        }
    });
    var E = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, a;
        function o() {
            i = null;
            a = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += i[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Li(e, n) {
        if (!(this instanceof Li)) return new Li(e, n);
        Fi.call(this, this.before, this.after);
        this.options = ge(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && ln(i, r)) {
                i[r.slice(1)] = Yi(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        this.drop_fargs = this.options["keep_fargs"] ? Ze : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof zt) {
                    n = e.expression;
                } else if (e instanceof yi) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof zt) {
                    n = e.expression;
                } else if (e instanceof yi) {
                    n = e.tag;
                }
                return !(n && Xe(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = en;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return Xe(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    Li.prototype = new Fi();
    t(Li.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.exported) return true;
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof Fn)) return false;
            var n = this.toplevel;
            return !un(e.orig, function(e) {
                return n[e instanceof ci ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            e.hoist_exports(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie: this.option("ie")
            };
            for (var a = 0; a < n; a++) {
                e.figure_out_scope(r);
                if (a > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var o = 0;
                    e.walk(new Mi(function() {
                        o++;
                    }));
                    dn.info("pass {pass}: last_count: {min_count}, count: {count}", {
                        pass: a,
                        min_count: t,
                        count: o
                    });
                    if (o < t) {
                        t = o;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof Mn;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(dn, function(e, n) {
            return e;
        });
        dn.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Fn.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var i = 0; i < n.length; i++) {
                var r = n[i];
                if (r instanceof Tt) {
                    n[i] = r = r.body;
                    if (r instanceof wt) {
                        r.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(r.name);
                    }
                } else if (r instanceof Dt) {
                    n.splice(i--, 1);
                    [].push.apply(t, r.properties);
                }
            }
            if (t.length) n.push(Ae(Dt, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof ri)) return;
                var n = Ae(hi, e, e);
                n.alias = n.name;
                t.push(n);
            }
        });
        Mn.DEFMETHOD("process_expression", function(i, r) {
            var a = this;
            var o = new Fi(function(e) {
                if (i && e instanceof bn) {
                    return r ? r(e) : Ae(ft, e, {
                        value: e.body
                    });
                }
                if (!i && e instanceof ft) {
                    return r ? r(e) : Ae(bn, e, {
                        body: e.value || Ae(It, e, {
                            operator: "void",
                            expression: Ae(ki, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof xn) {
                    if (e instanceof jn) {
                        if (e !== a) return e;
                    } else if (i === "awaits" && e instanceof gt) {
                        if (e.bfinally) return e;
                    }
                    for (var n = e.body.length; --n >= 0; ) {
                        var t = e.body[n];
                        if (!C(t, true)) {
                            e.body[n] = t.transform(o);
                            break;
                        }
                    }
                } else if (e instanceof dt) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof Cn) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            a.transform(o);
        });
        function T(e, n) {
            var t = n.get_property();
            if (t instanceof dn) return;
            var i;
            if (e instanceof Vt) {
                var r = e.elements;
                if (t == "length") return pe(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof jn) {
                if (t == "length") {
                    e.length_read = true;
                    return pe(e.argnames.length, e);
                }
            } else if (e instanceof Kt) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!Je(s)) return;
                    if (!i && a[o].key === t) i = a[o].value;
                }
            }
            return i instanceof vi && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof zi) return w.Boolean[n];
            if (e instanceof ki) return w.Number[n];
            if (e instanceof xi) return w.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Vt) return w.Array[n];
            if (e instanceof jn) return w.Function[n];
            if (e instanceof Kt) return w.Object[n];
            if (e instanceof Si) return w.RegExp[n] && !e.value.global;
        }
        function we(e, n, t, i, r, a, o) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof Ft && l(i, s.property)) {
                return;
            }
            var f = Bi(t, s);
            if (f) return f;
            if (s instanceof Vt) return we(e, n, s, s, r + 1);
            if (s instanceof Yt) {
                if (!Me[s.operator]) return;
                return we(e, n, s, s, r + 1);
            }
            if (s instanceof zt) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(i instanceof Nn) || !(s instanceof qt) && i.contains_this());
            }
            if (s instanceof Rt) {
                if (s.condition === t) return;
                return we(e, n, s, s, r + 1);
            }
            if (s instanceof $n) return s.init === t;
            if (s instanceof Zt) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return we(e, n, u, u, r + 2);
            }
            if (s instanceof Mt) {
                if (s.expression !== t) return;
                var c = T(i, s);
                return (!a || o) && we(e, n, s, c, r + 1);
            }
            if (s instanceof Ct) {
                if (s.tail_node() !== t) return;
                return we(e, n, s, i, r + 1, a, o);
            }
        }
        function A(e) {
            return e instanceof et || e instanceof jn;
        }
        function c(e) {
            return e instanceof et || e instanceof Qn || e instanceof Wn;
        }
        function xe(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function ke(e) {
            return e.orig[0] instanceof ui || e.orig[1] instanceof ui;
        }
        function K(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof Mn) return true;
            } while (n = n.parent_scope);
        }
        function Ee(e, n, t) {
            var i = e.definition();
            if (e.in_arg && ke(i)) return false;
            return un(i.orig, function(e) {
                if (e instanceof ai || e instanceof si) {
                    return n && J(n, e);
                }
                return !(t && e instanceof li);
            });
        }
        function Se(e, n, t, i) {
            if (i instanceof Bt) return i.operator == "=" && i.right === t;
            if (i instanceof zt) return i.expression !== t || i instanceof qt;
            if (i instanceof st) return i.value === t && n.resolve() !== e.scope.resolve();
            if (i instanceof St) return i.value === t;
        }
        var D = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(dn, Qe);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof Nn && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function l(t, i, r) {
                r.fn_defs = [];
                r.variables.each(function(e) {
                    a(t, i, e);
                    var n = e.init;
                    if (n instanceof Jn) {
                        r.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        m(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        m(t, e);
                    }
                });
                r.may_call_this = function() {
                    r.may_call_this = r.contains_this() ? en : Ze;
                };
                if (r.uses_arguments) r.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (i.option("ie")) r.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function f(t, i) {
                i.enclosed.forEach(function(e) {
                    if (i.variables.get(e.name) === e) return;
                    if (g(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof jn && ln(n, "safe_ids")) return;
                    e.fixed = false;
                });
            }
            function p(e, n, t) {
                if (!ln(t, "safe_ids")) return;
                var i = t.safe_ids;
                if (i === false) return;
                if (t.parent_scope.resolve().may_call_this === en) {
                    if (Xe(t, e.fn_visited)) f(e, t);
                } else if (i) {
                    var r = Xe(t, e.fn_visited);
                    if (i === e.safe_ids) {
                        if (!r) o(e, t);
                    } else if (r) {
                        f(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    o(e, t);
                }
            }
            function d(n, e) {
                var t = e.fn_defs;
                var i = e.may_call_this === en ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    o(n, e);
                    return false;
                });
                h(n);
                i.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    o(n, e);
                });
                t.forEach(function(e) {
                    delete e.safe_ids;
                });
                delete e.fn_defs;
                delete e.may_call_this;
            }
            function v(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function h(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function m(e, n) {
                e.safe_ids[n.id] = {};
            }
            function _(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function g(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!ln(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (xe(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = Ae(Di, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof Jn;
            }
            function b(e, n, t) {
                if (!t) {
                    if (ke(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!un(n.orig, function(e) {
                        return !(e instanceof ai);
                    })) return false;
                }
                if (n.fixed === undefined) return t || un(n.orig, function(e) {
                    return !(e instanceof si);
                });
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return n.fixed === null || ln(e.safe_ids, n.id) && !i.read;
                }
                if (!ln(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read) {
                        var r = e.find_parent(yn);
                        if (r instanceof et) return false;
                        if (n.scope.resolve() !== r.resolve()) return false;
                    }
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return g(e, n) && un(n.orig, function(e) {
                    return !(e instanceof li);
                });
            }
            function y(e, n) {
                var t = Ae(vi, e, e);
                t.fixed = n || Ae(Di, e);
                return t;
            }
            function u(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(ke(n) && n.scope.uses_arguments);
            }
            function w(e) {
                if (!e) return false;
                if (e instanceof Bt) {
                    var n = e.operator;
                    return n == "=" ? w(e.right) : !Me[n.slice(0, -1)];
                }
                if (e instanceof Ct) return w(e.tail_node());
                return e.is_constant() || A(e) || e instanceof mi;
            }
            function c(e, n) {
                if (n instanceof Vt) return true;
                if (n instanceof Yt) return Me[n.operator];
                if (n instanceof Rt) return n.condition !== e;
                if (n instanceof Ct) return n.tail_node() === e;
                if (n instanceof Pt) return true;
            }
            function x(e, n, t, i, r, a, o) {
                var s = e.parent(a);
                if (r && r.is_constant()) return;
                if (Se(n, t, i, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(r && r.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    return;
                } else if (c(i, s)) {
                    x(e, n, t, s, s, a + 1, o);
                } else if (s instanceof Zt && s.value === i) {
                    var f = e.parent(a + 1);
                    x(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Mt && s.expression === i) {
                    r = T(r, s);
                    x(e, n, t, s, r, a + 1, o + 1);
                    if (r) return;
                }
                if (a > 0) return;
                if (s instanceof zt && s.expression === i) return;
                if (s instanceof Ct && s.tail_node() !== i) return;
                if (s instanceof bn) return;
                if (s instanceof Nt && !Ri[s.operator]) return;
                n.direct_access = true;
            }
            function k(e) {
                if (!(e instanceof jt)) return;
                var n = e.expression;
                if (!(n instanceof vi)) return;
                var t = n.definition();
                if (!xe(t)) return;
                var i = e.property;
                if (i.is_constant()) i = i.value;
                if (!(i instanceof dn) && !D.test(i)) return;
                t.reassigned++;
                (i instanceof dn ? t.scope.argnames : [ t.scope.argnames[i] ]).forEach(function(e) {
                    if (e instanceof ui) e.definition().fixed = false;
                });
            }
            function E(a, t, e, o, n) {
                var s = new Mi(function(i) {
                    if (i instanceof $t) {
                        O(i);
                        v(a);
                        i.value.walk(a);
                        h(a);
                        var r = o;
                        if (r) o = function() {
                            var e = r();
                            var n;
                            if (Ce(e, t) || (n = L(t, e, true)) === undefined) {
                                return le(i, [ e, i.value ]);
                            }
                            return n instanceof dn ? i : e;
                        };
                        i.name.walk(s);
                        o = r;
                        return true;
                    }
                    if (i instanceof Gt) {
                        O(i);
                        var r = o;
                        i.elements.forEach(function(e, n) {
                            if (e instanceof Oi) return O(e);
                            if (r) o = function() {
                                return Ae(jt, e, {
                                    expression: r(),
                                    property: Ae(ki, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(s);
                        });
                        if (i.rest) {
                            if (r) o = t.option("rests") && function() {
                                var e = r();
                                return e instanceof Vt ? Ae(Vt, i, {
                                    elements: e.elements.slice(i.elements.length)
                                }) : i;
                            };
                            i.rest.walk(s);
                        }
                        o = r;
                        return true;
                    }
                    if (i instanceof Xt) {
                        O(i);
                        var r = o;
                        i.properties.forEach(function(t) {
                            O(t);
                            if (t.key instanceof dn) {
                                v(a);
                                t.key.walk(a);
                                h(a);
                            }
                            if (r) o = function() {
                                var e = t.key;
                                var n = jt;
                                if (typeof e == "string") {
                                    if (ji(e)) {
                                        n = Ft;
                                    } else {
                                        e = pe(e, t);
                                    }
                                }
                                return Ae(n, t, {
                                    expression: r(),
                                    property: e
                                });
                            };
                            t.value.walk(s);
                        });
                        if (i.rest) {
                            o = false;
                            i.rest.walk(s);
                        }
                        o = r;
                        return true;
                    }
                    n(i, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        i.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                e.walk(s);
            }
            function S(r, e, n) {
                var a = this;
                a.inlined = false;
                var o = r.parent();
                var t = Hn(a) || Yn(a);
                var i = false;
                a.walk(new Mi(function(e) {
                    if (t) return i = true;
                    if (e instanceof ft) return t = true;
                    if (e instanceof Mn && e !== a) return true;
                }));
                if (i) v(r);
                l(r, n, a);
                var s = !a.uses_arguments || r.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var i = o.args[e];
                    E(r, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? i : o.args[e];
                        if (n instanceof Ct && n.expressions.length < 2) n = n.expressions[0];
                        return n || Ae(Di, o);
                    }, c);
                });
                var f = a.rest;
                if (f) E(r, n, f, n.option("rests") && function() {
                    return a.rest === f ? Ae(Vt, a, {
                        elements: o.args.slice(a.argnames.length)
                    }) : f;
                }, c);
                Rn(a, r);
                var u = r.safe_ids;
                d(r, a);
                if (!i) r.safe_ids = u;
                return true;
                function c(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        m(r, t);
                        r.loop_ids[t.id] = r.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(Bt, function(a, e, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof vi && s.definition();
                var i = t || s instanceof Wt;
                switch (o.operator) {
                  case "=":
                    if (s.equivalent_to(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        c(s);
                        o.__drop = true;
                        return true;
                    }
                    if (t && f instanceof Nn) {
                        l();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) p(a, t, f);
                        return true;
                    }
                    if (i) {
                        f.walk(a);
                        l();
                        return true;
                    }
                    k(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    s.walk(a);
                    v(a);
                    if (i) {
                        f.walk(a);
                        l();
                    } else {
                        k(s);
                        f.walk(a);
                    }
                    h(a);
                    return true;

                  default:
                    if (!i) {
                        k(s);
                        return;
                    }
                    t.assignments++;
                    var r = t.fixed;
                    if (we(n, a, o, o, 0)) {
                        t.fixed = false;
                        return;
                    }
                    var u = g(a, t);
                    f.walk(a);
                    if (u && !s.in_arg && b(a, t)) {
                        _(t, s);
                        m(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return Ae(Yt, o, {
                                operator: o.operator.slice(0, -1),
                                left: y(s, r),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !r || !r.assigns ? [] : r.assigns.slice();
                        s.fixed.assigns.push(o);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function c(e) {
                    if (e instanceof Ft) {
                        c(e.expression);
                    } else if (e instanceof jt) {
                        c(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof vi) {
                        var n = e.definition();
                        _(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function l() {
                    var e = t && Re(a, t);
                    var r = we(n, a, o, f, 0, w(f), e);
                    E(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof vi)) {
                            k(e);
                            t();
                            return;
                        }
                        var i = e.definition();
                        i.assignments++;
                        if (n && !r && !e.in_arg && b(a, i)) {
                            _(i, e);
                            m(a, i);
                            if (s instanceof Wt || i.orig.length == 1 && i.orig[0] instanceof ci) {
                                i.single_use = false;
                            }
                            a.loop_ids[i.id] = a.in_loop;
                            x(a, i, e.scope, o, f, 0, 1);
                            e.fixed = i.fixed = n;
                            e.fixed.assigns = [ o ];
                        } else {
                            t();
                            i.fixed = false;
                        }
                    });
                }
            });
            e(Yt, function(e) {
                if (!Me[this.operator]) return;
                this.left.walk(e);
                v(e);
                this.right.walk(e);
                h(e);
                return true;
            });
            e(yn, function(e, n, t) {
                s(e, t, this);
            });
            e(zt, function(n, e) {
                var t = this;
                var i = t.expression;
                if (i instanceof Nn) {
                    var r = $e(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Pt) r = false;
                    });
                    if (r) i.reduce_vars = S;
                    i.walk(n);
                    if (r) delete i.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call" && n.in_boolean_context()) {
                    if (i instanceof vi) {
                        i.definition().bool_fn++;
                    } else if (i instanceof Bt && i.operator == "=" && i.left instanceof vi) {
                        i.left.definition().bool_fn++;
                    }
                }
                i.walk(n);
                var a = t.optional;
                if (a) v(n);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (a) h(n);
                var o = i instanceof vi && i.fixed_value();
                if (o instanceof jn) {
                    p(n, i.definition(), o);
                } else {
                    n.find_parent(Mn).may_call_this();
                }
                return true;
            });
            e(et, function(n, e, t) {
                var i = this;
                s(n, t, i);
                if (i.extends) i.extends.walk(n);
                var r = i.properties.filter(function(e) {
                    O(e);
                    if (e.key instanceof dn) e.key.walk(n);
                    return e.value;
                });
                if (i.name) {
                    var a = i.name.definition();
                    var o = n.parent();
                    if (o instanceof Tt || o instanceof At) a.single_use = false;
                    if (b(n, a, true)) {
                        m(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return i;
                        };
                        a.fixed.assigns = [ i ];
                        if (!ee(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                r.forEach(function(e) {
                    if (!e.static || e instanceof rt && e.value.contains_this()) {
                        v(n);
                        e.value.walk(n);
                        h(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(Rt, function(e) {
                this.condition.walk(e);
                v(e);
                this.consequent.walk(e);
                h(e);
                v(e);
                this.alternative.walk(e);
                h(e);
                return true;
            });
            e($t, function(e) {
                this.name.walk(e);
                v(e);
                this.value.walk(e);
                h(e);
                return true;
            });
            e(An, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                v(e);
                this.body.walk(e);
                if (Y(this, e.parent())) {
                    h(e);
                    v(e);
                }
                this.condition.walk(e);
                h(e);
                e.in_loop = n;
                return true;
            });
            e(On, function(e, n, t) {
                var i = this;
                s(e, t, i);
                if (i.init) i.init.walk(e);
                var r = e.in_loop;
                e.in_loop = i;
                v(e);
                if (i.condition) i.condition.walk(e);
                i.body.walk(e);
                if (i.step) {
                    if (Y(i, e.parent())) {
                        h(e);
                        v(e);
                    }
                    i.step.walk(e);
                }
                h(e);
                e.in_loop = r;
                return true;
            });
            e($n, function(e, n, t) {
                var i = this;
                s(e, t, i);
                i.object.walk(e);
                var r = e.in_loop;
                e.in_loop = i;
                v(e);
                var a = i.init;
                if (a instanceof wt) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof ri) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof Wt || a instanceof vi) {
                    a.mark_symbol(function(e) {
                        if (e instanceof vi) {
                            var n = e.definition();
                            _(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                i.body.walk(e);
                h(e);
                e.in_loop = r;
                return true;
            });
            e(dt, function(e) {
                this.condition.walk(e);
                v(e);
                this.body.walk(e);
                h(e);
                if (this.alternative) {
                    v(e);
                    this.alternative.walk(e);
                    h(e);
                }
                return true;
            });
            e(En, function(e) {
                v(e);
                this.body.walk(e);
                h(e);
                return true;
            });
            e(jn, function(e, n, t) {
                var i = this;
                if (ln(i, "safe_ids") && i.safe_ids !== e.safe_ids) return true;
                if (!an(e.fn_visited, i)) return true;
                i.inlined = false;
                v(e);
                l(e, t, i);
                n();
                d(e, i);
                if (i.name) x(e, i.name.definition(), i, i.name, i, 0, 1);
                return true;
            });
            e(Jn, function(e, n, t) {
                var i = this;
                var r = i.name.definition();
                var a = e.parent();
                if (a instanceof Tt || a instanceof At) r.single_use = false;
                if (ln(i, "safe_ids") && i.safe_ids !== e.safe_ids) return true;
                if (!an(e.fn_visited, i)) return true;
                i.inlined = false;
                v(e);
                l(e, t, i);
                n();
                d(e, i);
                return true;
            });
            e(jt, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                v(e);
                this.property.walk(e);
                h(e);
                return true;
            });
            e(vt, function(n, e, t) {
                var i = this;
                s(n, t, i);
                i.expression.walk(n);
                var r = true;
                i.body.forEach(function(e) {
                    if (e instanceof mt) return;
                    e.expression.walk(n);
                    if (r) {
                        r = false;
                        v(n);
                    }
                });
                if (!r) h(n);
                wn(i, n);
                return true;
            });
            e(ht, function(e) {
                v(e);
                wn(this, e);
                h(e);
                return true;
            });
            e(di, function() {
                this.definition().fixed = false;
            });
            e(oi, function() {
                this.definition().fixed = false;
            });
            e(vi, function(i, e, n) {
                var r = this.definition();
                _(r, this);
                if (r.references.length == 1 && !r.fixed && r.orig[0] instanceof ci) {
                    i.loop_ids[r.id] = i.in_loop;
                }
                var a = Re(i, r);
                if (a) a.enclosed.forEach(function(e) {
                    if (r === e) return;
                    if (e.scope.resolve() === a) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof St) return;
                    var t = i.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (r.fixed === false) {
                    var t = r.redefined();
                    if (t && K(r.scope, this.scope)) t.single_use = false;
                } else if (r.fixed === undefined || !g(i, r)) {
                    r.fixed = false;
                } else if (r.fixed) {
                    if (this.in_arg && r.orig[0] instanceof li) this.fixed = r.scope;
                    var o = this.fixed_value();
                    if (a) {
                        r.recursive_refs++;
                    } else if (o && u(n, r)) {
                        r.in_loop = i.loop_ids[r.id] !== i.in_loop;
                        r.single_use = A(o) && !o.pinned() && (!r.in_loop || i.parent() instanceof zt) || !r.in_loop && r.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        r.single_use = false;
                    }
                    if (we(n, i, this, o, 0, w(o), a)) {
                        if (r.single_use) {
                            r.single_use = "m";
                        } else {
                            r.fixed = false;
                        }
                    }
                    if (r.fixed && i.loop_ids[r.id] !== i.in_loop) r.cross_loop = true;
                    x(i, r, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = r.fixed;
                var s;
                if (o instanceof jn && !((s = i.parent()) instanceof zt && s.expression === this)) {
                    p(i, r, o);
                }
            });
            e(yi, function(n, e) {
                var t = this;
                var i = t.tag;
                if (!i) return;
                if (i instanceof Nn) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    i.walk(n);
                    return true;
                }
                i.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var r = i instanceof vi && i.fixed_value();
                if (r instanceof jn) {
                    p(n, i.definition(), r);
                } else {
                    n.find_parent(Mn).may_call_this();
                }
                return true;
            });
            e(Fn, function(n, e, t) {
                var i = this;
                i.globals.each(function(e) {
                    a(n, t, e);
                });
                v(n);
                l(n, t, i);
                e();
                d(n, i);
                return true;
            });
            e(gt, function(e, n, t) {
                var i = this;
                s(e, t, i);
                v(e);
                wn(i, e);
                h(e);
                if (i.bcatch) {
                    v(e);
                    i.bcatch.walk(e);
                    h(e);
                }
                if (i.bfinally) i.bfinally.walk(e);
                return true;
            });
            e(Nt, function(e, n) {
                var t = this;
                if (!Ii[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof vi)) {
                    k(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var a = r.fixed;
                if (g(e, r) && !i.in_arg && b(e, r)) {
                    _(r, i);
                    m(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return Ae(Yt, t, {
                            operator: t.operator.slice(0, -1),
                            left: Ae(It, t, {
                                operator: "+",
                                expression: y(i, a)
                            }),
                            right: Ae(ki, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof It) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return Ae(It, t, {
                                operator: "+",
                                expression: y(i, a)
                            });
                        };
                        i.fixed.assigns = a && a.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(St, function(i, e, n) {
                var r = this;
                var t = r.value;
                if (t instanceof Nn && r.name instanceof ri) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = r.name.definition();
                    if (!a.fixed) p(i, a, t);
                } else if (t) {
                    t.walk(i);
                    o();
                } else if (i.parent() instanceof kt) {
                    o();
                }
                return true;
                function o() {
                    E(i, n, r.name, function() {
                        return r.value || Ae(Di, r);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && b(i, t, true)) {
                            m(i, t);
                            i.loop_ids[t.id] = i.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ r ];
                            if (e instanceof ai && t.redefined() || !(Ee(e) || ee(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(Dn, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                v(e);
                n();
                h(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function O(e) {
            e._squeezed = false;
            e._optimized = false;
            delete e.fixed;
            if (e instanceof Mn) delete e._var_names;
        }
        Fn.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new Mi(t.option("reduce_vars") ? function(e, n) {
                O(e);
                return e.reduce_vars(i, n, t);
            } : O);
            i.fn_scanning = null;
            i.fn_visited = [];
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        ii.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof dn ? e : e();
        });
        vi.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            return e.orig.length == 1 && e.orig[0] instanceof li;
        });
        dn.DEFMETHOD("convert_symbol", Qe);
        function n(t, i) {
            return this.transform(new Fi(function(e, n) {
                if (e instanceof $t) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof Wt) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof Jt) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        }
        $t.DEFMETHOD("convert_symbol", n);
        Wt.DEFMETHOD("convert_symbol", n);
        function t(e, n) {
            var t = Ae(e, this, this);
            n(t, this);
            return t;
        }
        ri.DEFMETHOD("convert_symbol", t);
        vi.DEFMETHOD("convert_symbol", t);
        function i(n, t) {
            var i = new Mi(function(e) {
                if (e instanceof $t) {
                    e.value.walk(t);
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof Jt) {
                    if (e.key instanceof dn) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        }
        $t.DEFMETHOD("mark_symbol", i);
        Wt.DEFMETHOD("mark_symbol", i);
        function r(e) {
            return e(this);
        }
        ri.DEFMETHOD("mark_symbol", r);
        vi.DEFMETHOD("mark_symbol", r);
        dn.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        Wt.DEFMETHOD("match_symbol", function(n, t) {
            var i = false;
            var r = new Mi(function(e) {
                if (i) return true;
                if (e instanceof $t) {
                    if (!t) return i = true;
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof Jt) {
                    if (!t && e.key instanceof dn) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        });
        function g(e) {
            return e instanceof Kn || e instanceof Vn;
        }
        function ue(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        var ce = fn("Infinity NaN undefined");
        function Te(e, n) {
            if (e instanceof mi) return true;
            if (e instanceof Mt) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof vi) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Te(e, n);
            }
            if (e instanceof vi) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && ce[t.name];
            }
            return false;
        }
        function Ae(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function le(e, n) {
            if (n.length == 1) return n[0];
            return Ae(Ct, e, {
                expressions: n.reduce(b, [])
            });
        }
        function pe(e, n) {
            switch (typeof e) {
              case "string":
                return Ae(xi, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return Ae(Ai, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? Ae(It, n, {
                        operator: "-",
                        expression: Ae(ki, n, {
                            value: -e
                        })
                    }) : Ae(ki, n, {
                        value: e
                    });
                }
                return e < 0 ? Ae(It, n, {
                    operator: "-",
                    expression: Ae($i, n)
                }) : Ae($i, n);

              case "boolean":
                return Ae(e ? Ci : qi, n);

              case "undefined":
                return Ae(Di, n);

              default:
                if (e === null) {
                    return Ae(Ti, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return Ae(Si, n, {
                        value: e
                    });
                }
                throw new Error(on("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function de(e, n) {
            return n instanceof Mt || ze(n) && n.name == "eval";
        }
        function De(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && de(e, i);
            } else if (n instanceof yi) {
                r = n.tag === t && de(e, i);
            } else if (n instanceof It) {
                r = n.operator == "delete" || n.operator == "typeof" && ze(i);
            }
            return r ? le(t, [ Ae(ki, t, {
                value: 0
            }), i ]) : i;
        }
        function b(e, n) {
            if (n instanceof Ct) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function $(e) {
            return e instanceof xt || e instanceof nt || e instanceof kt;
        }
        function y(e) {
            if (e instanceof Jn) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || un(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !$(e);
        }
        function z(e) {
            if (e === null) return [];
            if (e instanceof kn) return un(e.body, y) ? e.body : [ e ];
            if (e instanceof _n) return [];
            if (gn(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function ve(e) {
            if (e === null) return true;
            if (e instanceof _n) return true;
            if (e instanceof kn) return e.body.length == 0;
            return false;
        }
        function E(e) {
            return un(e.body, function(e) {
                return ve(e) || e instanceof Qn || e instanceof Et && me(e);
            });
        }
        function q(e) {
            if (e instanceof Sn) {
                return e.body instanceof kn ? e.body : e;
            }
            return e;
        }
        function Oe(e) {
            while (e instanceof Mt) e = e.expression;
            return e;
        }
        function he(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof Mt);
            return e instanceof Nn ? !In(e) : he(e);
        }
        function $e(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof qt)) return true;
            var t = false;
            n.walk(new Mi(function(e) {
                if (t) return true;
                if (e instanceof bi) return t = true;
                if (e instanceof Mn && e !== n) return true;
            }));
            return !t;
        }
        function ze(e) {
            return e instanceof vi && e.definition().undeclared;
        }
        var qe = fn("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        vi.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && qe[this.name];
        });
        function me(e) {
            return un(e.definitions, function(e) {
                return !e.value;
            });
        }
        function C(e, n) {
            if (e instanceof nt) return n && !e.extends && un(e.properties, function(e) {
                if (e.key instanceof dn) return false;
                if (e instanceof rt && e.static && e.value) return false;
                return true;
            });
            if (e instanceof wt) return (n || e instanceof Et) && me(e);
            if (e instanceof Tt) return C(e.body, n);
            if (e instanceof At) return C(e.body, n);
            return e instanceof Jn;
        }
        function M(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!C(e[t], true)) return false;
            }
            return true;
        }
        function p(e, f) {
            var _e, ge, be;
            t();
            var ye, n = 10;
            do {
                ye = false;
                r(e);
                if (f.option("dead_code")) {
                    o(e, f);
                }
                if (f.option("if_return")) {
                    a(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    _(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (ye && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof bt) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof yt) {
                        n++;
                    } else if (e instanceof Sn) {
                        _e = true;
                    } else if (e instanceof Mn) {
                        be = e;
                        break;
                    } else if (e instanceof gt) {
                        if (!ge) ge = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, d) {
                if (be.pinned()) return o;
                var v;
                var s = Object.create(null);
                var h = [];
                var f = Object.create(null);
                var a;
                var u = o.length;
                var l = new Fi(function(e, n) {
                    if (j) return e;
                    if (!F) {
                        if (e !== c[p]) return e;
                        p++;
                        if (p < c.length) return Y(e, l);
                        F = true;
                        w = (y ? Q : J)(e, 0);
                        if (w === e) j = true;
                        return e;
                    }
                    var t = l.parent();
                    if (B(e, t)) {
                        j = true;
                        return e;
                    }
                    if (!x && L(e, t)) {
                        x = t;
                    }
                    if (e.single_use && t instanceof St && t.value === e) return e;
                    var i;
                    if (!(e instanceof ri) && (S && k.equivalent_to(e) || T && (i = T(e, this)))) {
                        if (!N || x && (i || !q || !M)) {
                            if (!i && !y) j = true;
                            return e;
                        }
                        if (Bi(e, t)) {
                            if (y && !i) g = true;
                            return e;
                        } else if (y) {
                            if (x && _ == 0) _ = b - P;
                            if (!i) P++;
                            return e;
                        } else {
                            P++;
                        }
                        ye = j = true;
                        dn.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (m.TYPE == "Binary") return Ae(Bt, m, {
                            operator: "=",
                            left: m.right.left,
                            right: Ae(Rt, m, {
                                condition: m.operator == "&&" ? m.left : m.left.negate(d),
                                consequent: m.right.right,
                                alternative: e
                            })
                        });
                        if (m instanceof Ht) {
                            if (k instanceof vi) k.definition().fixed = false;
                            return Ae(It, m, m);
                        }
                        if (m instanceof St) {
                            var r = m.name.definition();
                            if (r.references.length - r.replaced == 1 && !d.exposed(r)) {
                                r.replaced++;
                                return De(d, t, e, m.value);
                            }
                            return Ae(Bt, m, {
                                operator: "=",
                                left: Ae(vi, m.name, m.name),
                                right: m.value
                            });
                        }
                        var a = m;
                        while (a.write_only) {
                            a.write_only = false;
                            if (!(a instanceof Bt)) break;
                            a = a.right;
                        }
                        return m;
                    }
                    if (U(e, t) || A(e)) {
                        w = e;
                        if (e instanceof Mn) j = true;
                    }
                    if (e instanceof Pn) {
                        var o = N;
                        N = false;
                        n(e, l);
                        N = o;
                        return H(e);
                    }
                    if (e instanceof Wt) {
                        var o = N;
                        N = false;
                        n(e, l);
                        N = o;
                        return H(e);
                    }
                    if (e instanceof $t) {
                        e.name = e.name.transform(l);
                        var o = N;
                        N = false;
                        e.value = e.value.transform(l);
                        N = o;
                        return H(e);
                    }
                    if (e instanceof yn && !(e instanceof Mn) && !(e.variables && e.variables.all(function(e) {
                        return !z.has(e.name);
                    }))) {
                        var o = N;
                        N = false;
                        if (!Y(e, l)) n(e, l);
                        N = o;
                        return H(e);
                    }
                    return Y(e, l);
                }, H);
                var i = new Fi(function(e) {
                    if (j) return e;
                    if (!F) {
                        if (e !== c[p]) return e;
                        p++;
                        switch (c.length - p) {
                          case 0:
                            F = true;
                            if (g) return e;
                            if (e !== m) return e;
                            if (e instanceof St) return e;
                            I.replaced++;
                            var n = i.parent();
                            if (n instanceof Ct && n.tail_node() !== e) {
                                y.replaced++;
                                return rn.skip;
                            }
                            return r;

                          case 1:
                            if (!g && e.body === m) {
                                F = true;
                                I.replaced++;
                                y.replaced++;
                                return null;
                            }

                          default:
                            return Y(e, i);
                        }
                    }
                    if (e instanceof vi && e.definition() === I) {
                        if (Bi(e, i.parent())) return e;
                        if (!--P) j = true;
                        var t = r.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (P == _) {
                            j = true;
                            return Ae(Bt, m, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        I.replaced++;
                        return t;
                    }
                    if (e instanceof mt || e instanceof Mn) return e;
                }, ce);
                while (--u >= 0) {
                    if (u == 0 && d.option("unused")) W();
                    var c = [];
                    G(o[u]);
                    while (h.length > 0) {
                        c = h.pop();
                        var p = 0;
                        var m = c[c.length - 1];
                        var _ = -1;
                        var g = false;
                        var b;
                        var y = null;
                        var w = null;
                        var x = null;
                        var k = te(m);
                        var E = k && k.has_side_effects(d);
                        var S = k && !E && !Te(k, d);
                        var T = ae(m);
                        if (!S && !T) continue;
                        var t = m.name instanceof ui;
                        var A = Ze;
                        if (m.may_throw(d)) {
                            if (t && Hn(be)) continue;
                            A = ge ? function(e) {
                                return e.has_side_effects(d);
                            } : me;
                        }
                        var D = false;
                        var O = false;
                        var $ = true;
                        var z = fe(m);
                        var q = le(k);
                        var r = ie(m);
                        if (!E) E = pe();
                        var C = ge || !q ? function(e) {
                            return e instanceof Wt;
                        } : Ze;
                        var M = de(m);
                        var F = t;
                        var j = false;
                        var P = 0;
                        var N = !v || !F;
                        if (!N) {
                            for (var e = m.arg_index + 1; !j && e < v.length; e++) {
                                if (v[e]) v[e].transform(l);
                            }
                            N = true;
                        }
                        for (var n = u; !j && n < o.length; n++) {
                            o[n].transform(l);
                        }
                        if (y) {
                            if (!P || b > P + g) {
                                h.push(c);
                                a = true;
                                continue;
                            }
                            if (P == _) g = true;
                            var I = k.definition();
                            j = false;
                            p = 0;
                            F = t;
                            for (var n = u; !j && n < o.length; n++) {
                                if (!o[n].transform(i)) o.splice(n--, 1);
                            }
                            P = m instanceof St && m === c[c.length - 1] && I.references.length == I.replaced && !d.exposed(I);
                            y.last_ref = false;
                            y.single_use = false;
                            ye = true;
                        }
                        if (P && !ue(m)) o.splice(u, 1);
                    }
                }
                function H(e) {
                    if (j) return e;
                    if (w === e) j = true;
                    if (x === e) x = null;
                    return e;
                }
                function Y(e, n) {
                    if (!(e instanceof yn)) {
                        if (!(e instanceof it && !e.static)) return;
                        if (e.key instanceof dn) e.key = e.key.transform(n);
                        return e;
                    }
                    if (e instanceof Mn) return e;
                    if (e instanceof $n) {
                        e.object = e.object.transform(n);
                        j = true;
                        return e;
                    }
                    if (e instanceof vt) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !j && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof _t) {
                                if (!F) {
                                    if (i !== c[p]) continue;
                                    p++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!M) break;
                                T = false;
                            }
                        }
                        j = true;
                        return e;
                    }
                }
                function R(e, n) {
                    if (n instanceof Bt) return n.operator == "=" && n.left === e;
                    if (n instanceof $t) return n.name === e;
                    if (n instanceof Gt) return true;
                    if (n instanceof Jt) return n.value === e;
                }
                function B(e, n) {
                    if (e === r) return true;
                    if (n instanceof On) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof Bt) {
                        return e.operator != "=" && k.equivalent_to(e.left);
                    }
                    if (e instanceof zt) {
                        if (!(k instanceof Mt)) return false;
                        if (!k.equivalent_to(e.expression)) return false;
                        return !(r instanceof Nn && !r.contains_this());
                    }
                    if (e instanceof et) return !d.has_directive("use strict");
                    if (e instanceof hn) return true;
                    if (e instanceof Qn) return t && k.name === e.name.name;
                    if (e instanceof Jt) return e.key instanceof dn;
                    if (e instanceof Tn) return true;
                    if (e instanceof ct) return true;
                    if (e instanceof vi) {
                        if (e.is_declared(d)) {
                            if (e.fixed_value()) return false;
                            if (Ee(e)) {
                                return !(n instanceof Mt && n.expression === e) && xe(e.definition());
                            }
                        } else if (R(e, n)) {
                            return false;
                        }
                        if (!M) return true;
                        T = false;
                        return false;
                    }
                    if (e instanceof gt) return true;
                    if (e instanceof Cn) return true;
                    return false;
                }
                function L(e, n) {
                    if (n instanceof Bt) return n.left !== e && Me[n.operator.slice(0, -1)];
                    if (n instanceof Yt) return n.left !== e && Me[n.operator];
                    if (n instanceof zt) return n.optional && n.expression !== e;
                    if (n instanceof _t) return n.expression !== e;
                    if (n instanceof Rt) return n.condition !== e;
                    if (n instanceof dt) return n.condition !== e;
                    if (n instanceof jt) return n.optional && n.expression !== e;
                }
                function U(e, n) {
                    if (e instanceof Lt) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !Ye(e.right);
                    if (e instanceof zt) {
                        var t, i = e.expression;
                        if (i instanceof vi) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof jn)) return !e.is_expr_pure(d);
                        if (t && Re(d, t, i)) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = N;
                        N = false;
                        var a = w;
                        var o = x;
                        if (!un(i.argnames, function(e) {
                            if (e instanceof $t) {
                                e.value.transform(l);
                                if (j) return false;
                                e = e.name;
                            }
                            return !(e instanceof Wt);
                        })) {
                            j = true;
                        } else if (In(i) && i.value) {
                            i.value.transform(l);
                        } else for (var s = 0; !j && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof ft) {
                                if (f.value) f.value.transform(l);
                                break;
                            }
                            f.transform(l);
                        }
                        x = o;
                        w = a;
                        N = r;
                        delete i.collapse_scanning;
                        if (!j) return false;
                        j = false;
                        return true;
                    }
                    if (e instanceof st) {
                        if (ge) {
                            if (ge.bfinally) return true;
                            if (ge.bcatch && e instanceof ut) return true;
                        }
                        return E || k instanceof Mt || he(k);
                    }
                    if (e instanceof Wn) {
                        return d.option("ie") && e.name && z.has(e.name.name);
                    }
                    if (e instanceof mi) return ve(e, n);
                    if (e instanceof Mt) {
                        if (E) return true;
                        var u = e.expression;
                        if (u instanceof vi && xe(u.definition())) return true;
                        if (d.option("unsafe")) {
                            if (ze(u) && qe[u.name]) return false;
                            if (Fe(u)) return false;
                        }
                        if (!$) return true;
                        if (y) return false;
                        if (!ge && q) return false;
                        if (e.optional) return false;
                        return u.may_throw_on_access(d);
                    }
                    if (e instanceof Pt) return true;
                    if (e instanceof vi) {
                        if (ve(e, n)) return !R(e, n);
                        if (E && he(e)) return true;
                        var t = e.definition();
                        return (ge || t.scope.resolve() !== be) && !Ee(e);
                    }
                    if (e instanceof yi) return !e.is_expr_pure(d);
                    if (e instanceof St) {
                        if (C(e.name)) return true;
                        return (e.value || n instanceof kt) && e.name.match_symbol(function(e) {
                            return e instanceof ri && (z.has(e.name) || E && he(e));
                        }, true);
                    }
                    if (e instanceof Ut) return true;
                    var c = Bi(e.left, e);
                    if (!c) return false;
                    if (c instanceof Mt) return true;
                    if (C(c)) return true;
                    return c.match_symbol(function(e) {
                        return e instanceof vi && (z.has(e.name) || D && d.exposed(e.definition()));
                    }, true);
                }
                function V(e, n) {
                    if (!n) return !(e instanceof ii);
                    if (e instanceof $t) {
                        return n.has_side_effects(d) || e.value.has_side_effects(d) || V(e.name, Ce(n) && e.value);
                    }
                    if (e instanceof Wt) {
                        if (e.rest && V(e.rest)) return true;
                        if (e instanceof Gt) {
                            if (!(n instanceof Vt || n.is_string(d))) return true;
                            return !un(e.elements, function(e) {
                                return !V(e);
                            });
                        }
                        if (e instanceof Xt) {
                            if (!n.is_defined(d)) return true;
                            return !un(e.properties, function(e) {
                                if (e instanceof dn && e.has_side_effects(d)) return false;
                                return !V(e.value);
                            });
                        }
                    }
                }
                function W() {
                    var e, r = d.self();
                    if (r instanceof Nn && !Yn(r) && !r.uses_arguments && !r.pinned() && (e = d.parent()) instanceof zt && e.expression === r && $e(e) && un(e.args, function(e) {
                        return !(e instanceof Pt);
                    })) {
                        var a = d.has_directive("use strict");
                        if (a && !Xe(a, r.body)) a = false;
                        var o = Hn(r) ? function(e) {
                            return e instanceof ii && e.name == "await";
                        } : function(e) {
                            return e instanceof Lt && !n.find_parent(Mn);
                        };
                        var s = null;
                        var n = new Mi(function(e, n) {
                            if (!c) return true;
                            if (o(e) || e instanceof Ut) {
                                c = null;
                                return true;
                            }
                            if (e instanceof mi && (a || !s)) {
                                c = null;
                                return true;
                            }
                            if (e instanceof vi && r.variables.has(e.name)) {
                                var t = e.definition().scope;
                                if (t !== be) while (t = t.parent_scope) {
                                    if (t === be) return true;
                                }
                                c = null;
                            }
                            if (e instanceof Mn && !In(e)) {
                                var i = s;
                                s = e;
                                n();
                                s = i;
                                return true;
                            }
                        });
                        v = e.args.slice();
                        var t = v.length;
                        var i = Object.create(null);
                        for (var f = r.argnames.length; --f >= 0; ) {
                            var u = r.argnames[f];
                            var c = v[f];
                            var l;
                            if (u instanceof $t) {
                                l = u.value;
                                u = u.name;
                                v[t + f] = l;
                            }
                            if (u instanceof Wt) {
                                if (!V(u, c)) continue;
                                h.length = 0;
                                break;
                            }
                            if (u.name in i) continue;
                            i[u.name] = true;
                            if (l) c = !c || Ce(c) ? l : null;
                            if (!c && !l) {
                                c = Ae(Di, u).transform(d);
                            } else if (c instanceof jn && c.pinned()) {
                                c = null;
                            } else if (c) {
                                c.walk(n);
                            }
                            if (!c) continue;
                            var p = Ae(St, u, {
                                name: u,
                                value: c
                            });
                            p.name_index = f;
                            p.arg_index = l ? t + f : f;
                            h.unshift([ p ]);
                        }
                    }
                }
                function G(e, n) {
                    c.push(e);
                    if (e instanceof Vt) {
                        e.elements.forEach(function(e) {
                            G(e, n);
                        });
                    } else if (e instanceof Bt) {
                        var t = e.left;
                        if (!(t instanceof Wt)) h.push(c.slice());
                        G(t);
                        G(e.right);
                        if (t instanceof vi && e.operator == "=") {
                            s[t.name] = (s[t.name] || 0) + 1;
                        }
                    } else if (e instanceof Lt) {
                        G(e.expression, n);
                    } else if (e instanceof Yt) {
                        var i = Me[e.operator];
                        if (n && i && e.operator != "??" && e.right instanceof Bt && e.right.operator == "=" && !(e.right.left instanceof Wt)) {
                            h.push(c.slice());
                        }
                        G(e.left, !i && n);
                        G(e.right, n);
                    } else if (e instanceof zt) {
                        G(e.expression);
                        e.args.forEach(G);
                    } else if (e instanceof _t) {
                        G(e.expression);
                    } else if (e instanceof Rt) {
                        G(e.condition);
                        G(e.consequent, n);
                        G(e.alternative, n);
                    } else if (e instanceof wt) {
                        e.definitions.forEach(G);
                    } else if (e instanceof Ft) {
                        G(e.expression);
                    } else if (e instanceof Tn) {
                        G(e.condition);
                        if (!(e.body instanceof xn)) {
                            G(e.body);
                        }
                    } else if (e instanceof st) {
                        if (e.value) G(e.value);
                    } else if (e instanceof On) {
                        if (e.init) G(e.init, true);
                        if (e.condition) G(e.condition);
                        if (e.step) G(e.step, true);
                        if (!(e.body instanceof xn)) {
                            G(e.body);
                        }
                    } else if (e instanceof $n) {
                        G(e.object);
                        if (!(e.body instanceof xn)) {
                            G(e.body);
                        }
                    } else if (e instanceof dt) {
                        G(e.condition);
                        if (!(e.body instanceof xn)) {
                            G(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof xn)) {
                            G(e.alternative);
                        }
                    } else if (e instanceof Kt) {
                        e.properties.forEach(function(e) {
                            c.push(e);
                            if (e.key instanceof dn) G(e.key);
                            if (e instanceof Zt) G(e.value, n);
                            c.pop();
                        });
                    } else if (e instanceof Ct) {
                        var r = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            G(e, n < r);
                        });
                    } else if (e instanceof bn) {
                        G(e.body, true);
                    } else if (e instanceof Pt) {
                        G(e.expression);
                    } else if (e instanceof jt) {
                        G(e.expression);
                        G(e.property);
                    } else if (e instanceof vt) {
                        G(e.expression);
                        e.body.forEach(G);
                    } else if (e instanceof Nt) {
                        if (Ii[e.operator]) {
                            h.push(c.slice());
                        } else {
                            G(e.expression);
                        }
                    } else if (e instanceof St) {
                        if (e.name instanceof fi) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    h.push(c.slice());
                                }
                            } else {
                                f[e.name.name] = (f[e.name.name] || 0) + 1;
                            }
                        }
                        if (e.value) G(e.value);
                    } else if (e instanceof Ut) {
                        if (e.expression) G(e.expression);
                    }
                    c.pop();
                }
                function J(e, n) {
                    var t = l.parent(n);
                    if (t instanceof Vt) return e;
                    if (t instanceof Bt) return e;
                    if (t instanceof Lt) return e;
                    if (t instanceof Yt) return e;
                    if (t instanceof zt) return e;
                    if (t instanceof _t) return e;
                    if (t instanceof Rt) return e;
                    if (t instanceof wt) return Z(t, n + 1);
                    if (t instanceof st) return e;
                    if (t instanceof dt) return e;
                    if (t instanceof Sn) return e;
                    if (t instanceof Qt) return e;
                    if (t instanceof Mt) return e;
                    if (t instanceof Ct) {
                        return (t.tail_node() === e ? J : Z)(t, n + 1);
                    }
                    if (t instanceof bn) return Z(t, n + 1);
                    if (t instanceof Pt) return e;
                    if (t instanceof vt) return e;
                    if (t instanceof Nt) return e;
                    if (t instanceof St) return e;
                    if (t instanceof Ut) return e;
                    return null;
                }
                function X(e, n, t) {
                    var i;
                    do {
                        i = e;
                        e = l.parent(++t);
                    } while (e instanceof Bt && e.operator.slice(0, -1) == n || e instanceof Yt && e.operator == n);
                    return i;
                }
                function K(e, n, t, i, r) {
                    var a = N;
                    N = false;
                    var o = w;
                    var s = x;
                    var f = l.stack;
                    l.stack = [ i ];
                    e.transform(l);
                    l.stack = f;
                    x = s;
                    w = o;
                    N = a;
                    if (j) {
                        j = false;
                        return t;
                    }
                    return n(i, r + 1);
                }
                function Q(e, n) {
                    var t = l.parent(n);
                    if (t instanceof Vt) return Q(t, n + 1);
                    if (t instanceof Bt) {
                        if (A(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof vi && (k.name == e.name || y.name == e.name);
                        })) return e;
                        var i;
                        if (t.left === e || !Me[i = t.operator.slice(0, -1)]) {
                            return Q(t, n + 1);
                        }
                        return X(t, i, n);
                    }
                    if (t instanceof Yt) {
                        var i;
                        if (t.left === e || !Me[i = t.operator]) {
                            return Q(t, n + 1);
                        }
                        return X(t, i, n);
                    }
                    if (t instanceof zt) return t;
                    if (t instanceof _t) {
                        if (t.expression !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof Rt) {
                        if (t.condition !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof wt) return Z(t, n + 1);
                    if (t instanceof An) return e;
                    if (t instanceof st) return Z(t, n + 1);
                    if (t instanceof On) {
                        if (t.init !== e && t.condition !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof $n) {
                        if (t.init !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof dt) {
                        if (t.condition !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof Qt) {
                        var r = l.parent(n + 1);
                        return un(r.properties, function(e) {
                            return e instanceof Zt;
                        }) ? Q(r, n + 2) : r;
                    }
                    if (t instanceof Mt) {
                        var a = t.expression;
                        return a === e ? Q(t, n + 1) : e;
                    }
                    if (t instanceof Ct) {
                        return (t.tail_node() === e ? Q : Z)(t, n + 1);
                    }
                    if (t instanceof bn) return Z(t, n + 1);
                    if (t instanceof Pt) return Q(t, n + 1);
                    if (t instanceof vt) {
                        if (t.expression !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof Nt) {
                        if (t.operator == "delete") return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof St) return t.name.match_symbol(function(e) {
                        return e instanceof ri && (k.name == e.name || y.name == e.name);
                    }) ? e : Q(t, n + 1);
                    if (t instanceof Dn) {
                        if (t.condition !== e) return e;
                        return Q(t, n + 1);
                    }
                    if (t instanceof Ut) return Q(t, n + 1);
                    return null;
                }
                function Z(n, t) {
                    var i = l.parent(t);
                    if (U(n, i)) return n;
                    if (L(n, i)) return n;
                    if (i instanceof Vt) return Z(i, t + 1);
                    if (i instanceof Bt) return a(i.left);
                    if (i instanceof Lt) return n;
                    if (i instanceof Yt) return Z(i, t + 1);
                    if (i instanceof zt) return Z(i, t + 1);
                    if (i instanceof _t) return Z(i, t + 1);
                    if (i instanceof Rt) return Z(i, t + 1);
                    if (i instanceof wt) return Z(i, t + 1);
                    if (i instanceof st) return Z(i, t + 1);
                    if (i instanceof dt) return Z(i, t + 1);
                    if (i instanceof Sn) return n;
                    if (i instanceof Qt) {
                        var e = l.parent(t + 1);
                        return un(e.properties, function(e) {
                            return e instanceof Zt;
                        }) ? Z(e, t + 2) : e;
                    }
                    if (i instanceof Mt) {
                        var r = i.expression;
                        if (r === n) return Z(i, t + 1);
                        return K(r, Z, n, i, t);
                    }
                    if (i instanceof Ct) return Z(i, t + 1);
                    if (i instanceof bn) return Z(i, t + 1);
                    if (i instanceof Pt) return n;
                    if (i instanceof vt) return Z(i, t + 1);
                    if (i instanceof Nt) return Z(i, t + 1);
                    if (i instanceof St) return a(i.name);
                    if (i instanceof Ut) return n;
                    return null;
                    function a(e) {
                        if (A(i)) return n;
                        if (e !== n && e instanceof Wt) {
                            return K(e, Z, n, i, t);
                        }
                        return Z(i, t + 1);
                    }
                }
                function ee(e) {
                    if (a) {
                        a = false;
                        return;
                    }
                    if (b < 1) return;
                    var n = e instanceof Bt && e.operator == "=" ? e.left : e;
                    if (!(n instanceof vi)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (xe(t)) return;
                    if (n !== e) {
                        if (Te(n, d)) return;
                        var i = t.references.length - t.replaced;
                        if (i < 2) return;
                        var r = m.clone();
                        r[r instanceof Bt ? "right" : "value"] = n;
                        if (m.name_index >= 0) {
                            r.name_index = m.name_index;
                            r.arg_index = m.arg_index;
                        }
                        m = r;
                    }
                    return y = t;
                }
                function ne(e) {
                    return e.references.length - e.replaced - (s[e.name] || 0);
                }
                function te(t) {
                    if (t instanceof Bt) {
                        var i = t.left;
                        if (t.operator != "=") return i;
                        if (!(i instanceof vi)) return i;
                        var e = i.definition();
                        if (be.uses_arguments && ke(e)) return i;
                        if (d.exposed(e)) return i;
                        b = ne(e);
                        if (e.fixed && i.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === i.fixed;
                            }).length - 1;
                            if (n < b) {
                                b = n;
                                _ = 0;
                            }
                        }
                        ee(t.right);
                        return i;
                    }
                    if (t instanceof Yt) return t.right.left;
                    if (t instanceof Nt) return t.expression;
                    if (t instanceof St) {
                        var i = t.name;
                        var e = i.definition();
                        if (e.const_redefs) return;
                        if (!Xe(i, e.orig)) return;
                        if (be.uses_arguments && ke(e)) return;
                        var r = e.orig.length - e.eliminated - (f[e.name] || 0);
                        b = ne(e);
                        if (e.fixed) b = Math.min(b, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === i || ie(n) === t.value;
                        }).length);
                        if (r > 1 && !(i instanceof ui)) {
                            ee(t.value);
                            return Ae(vi, i, i);
                        }
                        if (ee(t.value) || b == 1 && !d.exposed(e)) {
                            return Ae(vi, i, i);
                        }
                        return;
                    }
                }
                function ie(e) {
                    if (e instanceof Bt) return e.right;
                    if (e instanceof Yt) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof St) return e.value;
                }
                function re(e) {
                    if (e instanceof Vt) return false;
                    if (e instanceof Yt && Me[e.operator]) {
                        return re(e.left) && re(e.right);
                    }
                    if (e instanceof zt) return false;
                    if (e instanceof Rt) {
                        return re(e.consequent) && re(e.alternative);
                    }
                    if (e instanceof Kt) return false;
                    return !e.has_side_effects(d);
                }
                function ae(n) {
                    if (n instanceof Bt && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Mi(function(e) {
                        if (e instanceof vi) t[e.definition().id] = true;
                    });
                    while (n instanceof Bt && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof mi) return o;
                    if (n instanceof vi) {
                        var i = n.evaluate(d);
                        if (i === n) return o;
                        return oe(i, o);
                    }
                    if (n.is_truthy()) return oe(true, Ze);
                    if (n.is_constant()) {
                        var r = n.evaluate(d);
                        if (!(r instanceof dn)) return oe(r, o);
                    }
                    if (!(k instanceof vi)) return false;
                    if (!re(n)) return false;
                    var a;
                    n.walk(new Mi(function(e) {
                        if (a) return true;
                        if (e instanceof vi && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function oe(i, r) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (i && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof dn)) return !t == !i;
                            }
                        }
                        return r(e);
                    };
                }
                function se(e) {
                    if (e instanceof vi) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Bt) return e.operator == "=" && se(e.right);
                    return e instanceof Mt || e instanceof mi;
                }
                function fe(r) {
                    var a = new cn();
                    if (r instanceof St) {
                        if (!r.name.definition().fixed) $ = false;
                        a.add(r.name.name, k);
                    }
                    var o = be.uses_arguments && !d.has_directive("use strict");
                    var s = be instanceof Fn;
                    var f = new Mi(function(e) {
                        var n;
                        if (e instanceof vi) {
                            n = e.fixed_value();
                            if (!n) {
                                n = e;
                                var t = e.definition();
                                if (!t.undeclared && (t.assignments || !t.escaped || t.escaped.cross_scope) && (Se(t, e.scope, e, f.parent()) || !Be(t))) {
                                    $ = false;
                                }
                            }
                        } else if (e instanceof mi) {
                            n = e;
                        }
                        if (n) a.add(e.name, we(d, f, e, n, 0));
                        if (o && e instanceof jt) {
                            be.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) $ = false;
                                    a.add(e.name, true);
                                }
                            });
                            o = false;
                        }
                        if (!s) return;
                        if (e.TYPE == "Call") {
                            if (O) return;
                            var i = e.expression;
                            if (i instanceof Mt) return;
                            if (i instanceof Nn && !i.contains_this()) return;
                            O = true;
                        } else if (e instanceof Mt && se(e.expression)) {
                            if (e === k && !(r instanceof Nt)) {
                                O = true;
                            } else {
                                D = true;
                            }
                        }
                    });
                    r.walk(f);
                    return a;
                }
                function ue(e) {
                    var n = e.name_index;
                    if (n >= 0) {
                        var t = be.argnames[n];
                        if (t instanceof $t) {
                            t.value = Ae(ki, t, {
                                value: 0
                            });
                            t.name.definition().fixed = false;
                        } else {
                            var i = d.parent().args;
                            if (i[n]) {
                                i[n] = Ae(ki, i[n], {
                                    value: 0
                                });
                                t.definition().fixed = false;
                            }
                        }
                        return true;
                    }
                    var r = c.length - 1;
                    if (c[r - 1].body === c[r]) r--;
                    var a = new Fi(function(e, n, t) {
                        if (F) return e;
                        if (e !== c[p]) return e;
                        p++;
                        if (p <= r) return Y(e, a);
                        F = true;
                        if (e instanceof St) {
                            f[e.name.name] = (f[e.name.name] || 0) + 1;
                            if (y) y.replaced++;
                            e = e.clone();
                            e.value = null;
                            return e;
                        }
                        return t ? rn.skip : null;
                    }, ce);
                    j = false;
                    F = false;
                    p = 0;
                    return o[u].transform(a);
                }
                function ce(e) {
                    if (e instanceof Ct) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return De(d, this.parent(), e, e.expressions[0]);
                    }
                }
                function le(e) {
                    var n = Oe(e);
                    return n instanceof vi && n.definition().scope.resolve() === be && !(_e && (z.has(n.name) && z.get(n.name)[0] !== e || m instanceof Nt || m instanceof Bt && m.operator != "="));
                }
                function pe() {
                    if (m instanceof Nt) return false;
                    return r.has_side_effects(d);
                }
                function de(e) {
                    if (e instanceof Nt) return false;
                    if (E) return false;
                    if (y) return true;
                    if (!(k instanceof vi)) return false;
                    var n;
                    if (e instanceof St) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = k.definition();
                    return t.references.length - t.replaced == n;
                }
                function ve(e, n) {
                    var t = z.get(e.name);
                    if (!t || un(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== k) return true;
                    T = false;
                }
                function he(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof ci) return false;
                    if (n.scope.resolve() !== be) return true;
                    if (O && d.exposed(n)) return true;
                    return !un(n.references, function(e) {
                        return e.scope.resolve() === be;
                    });
                }
                function me(e, n) {
                    if (e instanceof Bt) return me(e.left, true);
                    if (e instanceof Nt) return me(e.expression, true);
                    if (e instanceof St) return e.value && me(e.value);
                    if (n) {
                        if (e instanceof Ft) return me(e.expression, true);
                        if (e instanceof jt) return me(e.expression, true);
                        if (e instanceof vi) return e.definition().scope.resolve() !== be;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof kn) {
                        if (un(i.body, y)) {
                            ye = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof mn) {
                        if (Xe(i.value, n)) {
                            ye = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof _n) {
                        ye = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function a(i, r) {
                var a = r.self();
                var e = r.parent();
                var t = w(function(e) {
                    return e instanceof jn;
                });
                var n = t && e && e.TYPE == "Call";
                var o = b(i);
                for (var s = i.length; --s >= 0; ) {
                    var f = i[s];
                    var u = A(s);
                    var c = i[u];
                    if (t && !c && f instanceof ft) {
                        if (!f.value) {
                            ye = true;
                            i.splice(s, 1);
                            continue;
                        }
                        var l = f.value.tail_node();
                        if (l instanceof It && l.operator == "void") {
                            ye = true;
                            var p;
                            if (l === f.value) {
                                p = l.expression;
                            } else {
                                p = f.value.clone();
                                p.expressions[p.length - 1] = l.expression;
                            }
                            i[s] = Ae(bn, f, {
                                body: p
                            });
                            continue;
                        }
                    }
                    if (f instanceof dt) {
                        var d = F(f.body);
                        if (E(d)) {
                            if (d.label) sn(d.label.thedef.references, d);
                            ye = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = T(f.body, d);
                            f.body = Ae(kn, f, {
                                body: z(f.alternative).concat(S())
                            });
                            f.alternative = Ae(kn, f, {
                                body: p
                            });
                            i[s] = f;
                            i[s] = f.transform(r);
                            continue;
                        }
                        if (d && !f.alternative && f.body instanceof kn && c instanceof ot) {
                            var v = f.condition.negate(r);
                            if (v.print_to_string().length <= f.condition.print_to_string().length) {
                                ye = true;
                                f = f.clone();
                                f.condition = v;
                                i[u] = f.body;
                                f.body = c;
                                i[s] = f;
                                i[s] = f.transform(r);
                                continue;
                            }
                        }
                        var h = F(f.alternative);
                        if (E(h)) {
                            if (h.label) sn(h.label.thedef.references, h);
                            ye = true;
                            f = f.clone();
                            f.body = Ae(kn, f.body, {
                                body: z(f.body).concat(S())
                            });
                            var p = T(f.alternative, h);
                            f.alternative = Ae(kn, f.alternative, {
                                body: p
                            });
                            i[s] = f;
                            i[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (d && !h) {
                                B(f.condition, null, Ae(kn, a, {
                                    body: i.slice(s + 1)
                                }));
                            }
                            if (!d && h) {
                                B(f.condition, Ae(kn, a, {
                                    body: i.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof dt && f.body instanceof ft) {
                        var m = f.body.value;
                        var _ = f.body.in_bool || c instanceof ft && c.in_bool;
                        if (!m && !f.alternative && (t && !c || c instanceof ft && !c.value)) {
                            ye = true;
                            i[s] = Ae(bn, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof ft) {
                            ye = true;
                            f = f.clone();
                            f.alternative = c;
                            i.splice(s, 1, f.transform(r));
                            i.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && t && (_ || m && o)) {
                            ye = true;
                            f = f.clone();
                            f.alternative = Ae(ft, f, {
                                value: null
                            });
                            i.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var g = i[D(s)];
                        if (r.option("sequences") && t && !f.alternative && (!g && n || g instanceof dt && g.body instanceof ft) && A(u) == i.length && c instanceof bn) {
                            ye = true;
                            f = f.clone();
                            f.alternative = Ae(kn, c, {
                                body: [ c, Ae(ft, c, {
                                    value: null
                                }) ]
                            });
                            i.splice(s, 1, f.transform(r));
                            i.splice(u, 1);
                            continue;
                        }
                    }
                }
                function b(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof dt && i.body instanceof ft) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function y(e) {
                    return !e || e instanceof It && e.operator == "void";
                }
                function w(e) {
                    var n = a, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof dt && (t = n));
                    } while ((n instanceof kn || n instanceof Mn) && M(n.body, t));
                }
                function x(n) {
                    return w(function(e) {
                        return e === n;
                    });
                }
                function k(e) {
                    if (e instanceof ft) return t && y(e.value);
                    if (!(e instanceof ct)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof pt) return x(q(n));
                    if (n instanceof Sn) return false;
                    return x(n);
                }
                function E(e) {
                    if (!k(e)) return false;
                    for (var n = i.length; --n > s; ) {
                        var t = i[n];
                        if (t instanceof nt) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof xt || t instanceof kt) {
                            if (!un(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof ri && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function S() {
                    var n = [];
                    var t = false;
                    var e = i.splice(s + 1).filter(function(e) {
                        if (e instanceof Jn) {
                            n.push(e);
                            return false;
                        }
                        if ($(e)) t = true;
                        return true;
                    });
                    [].push.apply(t ? e : i, n);
                    return e;
                }
                function T(e, n) {
                    var t = z(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) i.push(Ae(bn, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function A(e) {
                    for (var n = e + 1; n < i.length; n++) {
                        if (!C(i[n])) break;
                    }
                    return n;
                }
                function D(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!C(i[n])) break;
                    }
                    return n;
                }
            }
            function o(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, a = 0, o = n.length; r < o; r++) {
                    var s = n[r];
                    if (s instanceof ct) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof lt && !(f instanceof Sn) && q(f) === i || s instanceof pt && q(f) === i) {
                            if (s.label) sn(s.label.thedef.references, s);
                        } else {
                            n[a++] = s;
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (F(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = a;
                ye = a != o;
                if (e) e.forEach(function(e) {
                    S(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = le(t[0], t);
                    n[i++] = Ae(bn, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof bn) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) b(t, f);
                    } else if (C(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != o) ye = true;
            }
            function p(e, n) {
                if (!(e instanceof kn)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof Et && me(r)) {
                        n.push(r);
                    } else if (t || $(r)) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    ye = true;
                    var n = r.body;
                    return le(n, [ n, e ]);
                }
                var i = 0, r;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (r) {
                        if (o instanceof st) {
                            if (o.value || !g(be)) {
                                o.value = t(o.value || Ae(Di, o)).optimize(n);
                            }
                        } else if (o instanceof On) {
                            if (!(o.init instanceof wt)) {
                                var s = false;
                                r.body.walk(new Mi(function(e) {
                                    if (s || e instanceof Mn) return true;
                                    if (e instanceof Yt && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = t(o.init); else {
                                        o.init = r.body;
                                        i--;
                                        ye = true;
                                    }
                                }
                            }
                        } else if (o instanceof zn) {
                            if (!$(o.init)) o.object = t(o.object);
                        } else if (o instanceof dt) {
                            o.condition = t(o.condition);
                        } else if (o instanceof vt) {
                            o.expression = t(o.expression);
                        } else if (o instanceof Cn) {
                            o.expression = t(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof dt) {
                        var f = [];
                        var u = p(o.body, f);
                        var c = p(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(Ae(dt, o, {
                                condition: o.condition,
                                body: u || Ae(_n, o.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            a += l;
                            i += l + 1;
                            r = null;
                            ye = true;
                            continue;
                        }
                    }
                    e[i++] = o;
                    r = o instanceof bn ? o : null;
                }
                e.length = i;
            }
            function c(e) {
                if (e instanceof Bt) return [ e ];
                if (e instanceof Ct) return e.expressions.slice();
            }
            function l(e, n, t) {
                var i = c(n);
                if (!i) return;
                var r = false;
                for (var a = i.length - 1; --a >= 0; ) {
                    var o = i[a];
                    if (!(o instanceof Bt)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof vi)) continue;
                    var s = i.slice(a + 1);
                    if (!m(o.left, o.right, s)) continue;
                    r = true;
                    i = i.slice(0, a + 1).concat(s);
                }
                if (e instanceof wt) {
                    t = t || 0;
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var f = e.definitions[a];
                        if (!f.value) continue;
                        if (m(f.name, f.value, i)) r = true;
                        if (v(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof Et && h(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function d(e, n) {
                if (!(e instanceof bn)) return;
                if (me(n)) return;
                var t = c(e.body);
                if (!t) return;
                var i = [];
                if (!h(i, t.reverse(), 0)) return;
                n.definitions = i.reverse().concat(n.definitions);
                return t.reverse();
            }
            function v(e, n, t) {
                if (!f.option("conditionals")) return;
                if (e.name instanceof Wt) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var a = ne(f, r, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function h(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof Bt)) break;
                    if (r.operator != "=") break;
                    var a = r.left;
                    if (!(a instanceof vi)) break;
                    if (ze(a)) break;
                    if (a.scope.resolve() !== be) break;
                    var o = a.definition();
                    if (o.scope !== be) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = Ae(fi, a, a);
                    e.push(Ae(St, r, {
                        name: s,
                        value: r.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function m(e, n, t) {
                if (!(n instanceof Kt)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof Bt)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof Mt)) break;
                    var a = r.left.expression;
                    if (!(a instanceof vi)) break;
                    if (e.name != a.name) break;
                    if (!r.right.is_constant_expression(be)) break;
                    var o = r.left.property;
                    if (o instanceof dn) {
                        o = o.evaluate(f);
                    }
                    if (o instanceof dn) break;
                    o = "" + o;
                    var s = o == "__proto__" || f.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != o && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof ti || e instanceof ni) {
                            return typeof n == "string" && n != o;
                        }
                        return n !== "__proto__";
                    };
                    if (!un(n.properties, s)) break;
                    n.properties.push(Ae(Zt, r, {
                        key: o,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function _(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var a = e[t];
                    if (i instanceof wt) {
                        if (a && a.TYPE == i.TYPE) {
                            a.definitions = a.definitions.concat(i.definitions);
                            ye = true;
                        } else if (r && r.TYPE == i.TYPE && me(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            ye = true;
                        } else if (i instanceof Et) {
                            var o = d(a, i);
                            if (o) {
                                if (o.length) {
                                    a.body = le(a, o);
                                    t++;
                                }
                                ye = true;
                            } else {
                                t++;
                            }
                            e[t] = r = i;
                        } else {
                            e[++t] = i;
                        }
                        continue;
                    } else if (i instanceof st) {
                        i.value = f(i.value);
                    } else if (i instanceof On) {
                        var o = l(a, i.init);
                        if (o) {
                            ye = true;
                            i.init = o.length ? le(i.init, o) : null;
                        } else if (a instanceof Et && (!i.init || i.init.TYPE == a.TYPE)) {
                            if (i.init) {
                                a.definitions = a.definitions.concat(i.init.definitions);
                            }
                            r = i.init = a;
                            e[t] = u(i);
                            ye = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && me(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            ye = true;
                        } else if (i.init instanceof Et) {
                            r = i.init;
                            o = d(a, i.init);
                            if (o) {
                                ye = true;
                                if (o.length == 0) {
                                    e[t] = u(i);
                                    continue;
                                }
                                a.body = le(a, o);
                            }
                        }
                    } else if (i instanceof $n) {
                        if (r && r.TYPE == i.init.TYPE) {
                            var s = r.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(vi, function(e, n) {
                                s.push(Ae(St, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            r.definitions = s;
                            ye = true;
                        }
                        i.object = f(i.object);
                    } else if (i instanceof dt) {
                        i.condition = f(i.condition);
                    } else if (i instanceof bn) {
                        var o = l(a, i.body);
                        if (o) {
                            ye = true;
                            if (!o.length) continue;
                            i.body = le(i.body, o);
                        }
                    } else if (i instanceof vt) {
                        i.expression = f(i.expression);
                    } else if (i instanceof Cn) {
                        i.expression = f(i.expression);
                    }
                    e[++t] = r ? u(i) : i;
                }
                e.length = t + 1;
                function f(e) {
                    var n = l(a, e, 1);
                    if (!n) return e;
                    ye = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return le(e, n);
                }
                function u(e) {
                    return e.transform(new Fi(function(e, n, t) {
                        if (e instanceof wt) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof $n && i.init === e) return e;
                            if (!me(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            ye = true;
                            if (i instanceof On && i.init === e) return null;
                            return t ? rn.skip : Ae(_n, e);
                        }
                        if (e instanceof Tt) return e;
                        if (e instanceof Mn) return e;
                        if (!gn(e)) return e;
                    }));
                }
            }
        }
        function S(r, a, o) {
            if (!(a instanceof nt || a instanceof wt || a instanceof Jn)) {
                dn.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            }
            var s;
            a.walk(new Mi(function(e, n) {
                if (e instanceof nt) {
                    e.extends = null;
                    e.properties = [];
                    f(e);
                    return true;
                }
                if (e instanceof wt) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        dn.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        f(e);
                    }
                    return true;
                }
                if (e instanceof Jn) {
                    f(e);
                    return true;
                }
                if (e instanceof Mn) return true;
                if (e instanceof yn) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(Ae(kn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = i;
                    return true;
                }
            }));
            function f(e) {
                if (s) {
                    s.push(e);
                    if (!y(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Ce(e, n) {
            return e.is_undefined || e instanceof Di || e instanceof It && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(dn, Ze);
            e(Vt, en);
            e(Bt, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(jn, en);
            e(Kt, en);
            e(Si, en);
            e(Ct, function() {
                return this.tail_node().is_truthy();
            });
            e(vi, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = Ze;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(dn, en);
            e(Vt, Ze);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof wi) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(Bt, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Yt, function() {
                return n(this.operator, this.left, this.right);
            });
            e(wi, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(jn, Ze);
            e(Kt, Ze);
            e(Si, Ze);
            e(Ct, function() {
                return this.tail_node().is_negative_zero();
            });
            e(vi, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = en;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(It, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            dn.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function r(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(dn, r);
            e(Vt, Ze);
            e(Bt, function(e) {
                var n = this.operator;
                var t = this.left;
                var i = this.right;
                if (n != "=") {
                    return Me[n.slice(0, -1)] && (t._dot_throw(e) || i._dot_throw(e));
                }
                if (!i._dot_throw(e)) return false;
                if (!(t instanceof vi)) return true;
                if (i instanceof Yt && i.operator == "||" && t.name == i.left.name) {
                    return i.right._dot_throw(e);
                }
                return true;
            });
            e(Yt, function(e) {
                return Me[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(et, Ze);
            e(Rt, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(wi, Ze);
            e(Ft, function(e, n) {
                if (!r(e, n)) return false;
                var t = this.expression;
                if (t instanceof vi) t = t.fixed_value();
                return !(this.property == "prototype" && A(t));
            });
            e(jn, Ze);
            e(Ti, en);
            e(Kt, function(n, t) {
                return r(n, t) && !un(this.properties, function(e) {
                    if (!(e instanceof Zt)) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(mi, function(e, n) {
                return r(e, n) && !this.scope.resolve().new;
            });
            e(Ct, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(vi, function(e, n) {
                if (this.is_undefined) return true;
                if (!r(e, n)) return false;
                if (ze(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if (xe(t) && !t.scope.rest && un(t.scope.argnames, function(e) {
                    return e instanceof ui;
                })) return t.scope.uses_arguments > 2;
                var i = this.fixed_value();
                if (!i) return true;
                this._dot_throw = en;
                if (i._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = Ze;
                return false;
            });
            e(It, function() {
                return this.operator == "void";
            });
            e(Ht, Ze);
            e(Di, en);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(dn, Ze);
            e(Vt, en);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(Bt, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(Yt, function(e) {
                return t(e, this.operator, this);
            });
            e(Rt, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(wi, en);
            e(Oi, Ze);
            e(jn, en);
            e(Kt, en);
            e(Ct, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(vi, function(e) {
                if (this.is_undefined) return false;
                if (ze(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = Ze;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(It, function() {
                return this.operator != "void";
            });
            e(Ht, en);
            e(Di, Ze);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(dn, Ze);
            e(Bt, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = fn("in instanceof == != === !== < <= >= >");
            e(Yt, function(e) {
                return n[this.operator] || Me[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(zi, en);
            var t = fn("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(zt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Ft && (t[n.property] || n.property == "test" && n.expression instanceof Si);
            });
            e(Rt, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(qt, Ze);
            e(Ct, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(vi, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = Ze;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = fn("! delete");
            e(It, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(dn, Ze);
            var n = fn("- * / % ** & | ^ << >> >>>");
            e(Bt, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Yt, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = fn([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(zt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Ft && (t[n.property] || ze(n.expression) && n.expression.name == "Math");
            });
            e(Rt, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(qt, Ze);
            e(ki, en);
            e(Ct, function(e) {
                return this.tail_node().is_number(e);
            });
            e(vi, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = Ze;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = fn("+ - ~ ++ --");
            e(Nt, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(dn, Ze);
            e(Bt, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Yt, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = fn([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(zt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Ft && t[n.property];
            });
            e(Rt, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Ct, function(e) {
                return this.tail_node().is_string(e);
            });
            e(xi, en);
            e(vi, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = Ze;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(yi, function(e) {
                return !this.tag || fe(e, this.tag);
            });
            e(It, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var Me = fn("&& || ??");
        (function(e) {
            function r(e, n) {
                if (e instanceof dn) return e.clone(true);
                if (Array.isArray(e)) return Ae(Vt, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (ln(e, i)) {
                        t.push(Ae(Zt, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return Ae(Kt, n, {
                        properties: t
                    });
                }
                return pe(e, n);
            }
            function o(e) {
                dn.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            Fn.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new Fi(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof Mt)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (Bi(i, r)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(dn, Qe);
            e(Ft, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(ri, function(e) {
                if (!this.definition().global) return;
                if (ln(e.option("global_defs"), this.name)) o(this);
            });
            e(vi, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (ln(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function _e(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function u(e, n, t) {
            return _e(Ae(bn, e, {
                body: e
            }), Ae(bn, n, {
                body: n
            }), t).body;
        }
        function ge(e, n, t, i) {
            return (pn(e) ? u : _e)(n, t, i);
        }
        function a(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = fn(n[e]);
            });
            return t;
        }
        function o(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof mn)) return t;
            }
        }
        function s() {
            if (this.value) return Ae(ft, this.value, {
                value: this.value
            });
            return o(this.body);
        }
        Bn.DEFMETHOD("first_statement", s);
        Ln.DEFMETHOD("first_statement", s);
        jn.DEFMETHOD("first_statement", function() {
            return o(this.body);
        });
        jn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof $t) break;
            }
            return n;
        });
        function be(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = pe(t, n).optimize(e);
            return ge(e, n, t, e.eval_threshold);
        }
        var f = [ "constructor", "toString", "valueOf" ];
        var w = a({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(f),
            Boolean: f,
            Function: f,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(f),
            Object: f,
            RegExp: [ "exec", "test" ].concat(f),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(f)
        });
        var x = a({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Fe(e) {
            if (!(e instanceof Ft)) return false;
            var n = e.expression;
            if (!ze(n)) return false;
            var t = x[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(dn, Ze);
            e(wi, en);
            e(Si, Ze);
            var n = fn("! ~ - + void");
            e(It, function() {
                return n[this.operator] && this.expression instanceof wi;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            dn.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var m = new Mi(function(e) {
                if (e instanceof Bt) u(e.left);
                if (e instanceof Nt && Ii[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof Gt) {
                    e.elements.forEach(u);
                } else if (e instanceof Xt) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof Mt) {
                    u(e.expression);
                } else if (e instanceof vi) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(vn, function() {
                throw new Error(on("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Pn, nn);
            e(Ei, nn);
            e(et, nn);
            e(dn, nn);
            e(wi, function() {
                return this.value;
            });
            e(Bt, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof vi)) return this;
                    if (!ln(r, "_eval")) {
                        if (!r.fixed) return this;
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!ln(r, "_eval") && r instanceof vi && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = Ae(Yt, this, {
                        operator: o.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                r.walk(m);
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                u(r);
                return f;
            });
            e(Ct, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var a = 0, o = r.length - 1; a < o; a++) {
                    r[a].walk(m);
                }
                var s = r[o];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(jn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Vt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Oi) return this;
                        var s = o._eval(e, n, t, i);
                        if (o === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            var f = fn("__proto__ toString valueOf");
            e(Kt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof Zt)) return this;
                        var s = o.key;
                        if (s instanceof dn) {
                            s = s._eval(e, n, t, i);
                            if (s === o.key) return this;
                        }
                        if (f[s]) return this;
                        r[s] = o.value._eval(e, n, t, i);
                        if (r[s] === o.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var c = fn("! typeof void");
            e(It, function(e, n, t, i) {
                var r = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (r instanceof jn || r instanceof vi && r.fixed_value() instanceof jn)) {
                    return typeof function() {};
                }
                var o = r instanceof vi && r.definition();
                if (!c[a] && !(o && o.fixed)) i++;
                r.walk(m);
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                    if (ln(r, "_eval")) s = +(a[0] + 1) + +s;
                    u(r);
                    return s;
                }
                return this;
            });
            e(Ht, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof vi)) {
                    if (!n) return this;
                } else if (!ln(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof vi && r.definition().fixed)) i++;
                r.walk(m);
                var o = r._eval(e, n, t, i);
                if (o === r) return this;
                u(r);
                return +o;
            });
            var l = fn("&& || === !==");
            e(Yt, function(e, n, t, i) {
                if (!l[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var a = n && !(r && typeof r == "object");
                var o = this.right._eval(e, a, t, i);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && o;
                    break;

                  case "||":
                    s = r || o;
                    break;

                  case "??":
                    s = r == null ? o : r;
                    break;

                  case "|":
                    s = r | o;
                    break;

                  case "&":
                    s = r & o;
                    break;

                  case "^":
                    s = r ^ o;
                    break;

                  case "+":
                    s = r + o;
                    break;

                  case "-":
                    s = r - o;
                    break;

                  case "*":
                    s = r * o;
                    break;

                  case "/":
                    s = r / o;
                    break;

                  case "%":
                    s = r % o;
                    break;

                  case "<<":
                    s = r << o;
                    break;

                  case ">>":
                    s = r >> o;
                    break;

                  case ">>>":
                    s = r >>> o;
                    break;

                  case "==":
                    s = r == o;
                    break;

                  case "===":
                    s = r === o;
                    break;

                  case "!=":
                    s = r != o;
                    break;

                  case "!==":
                    s = r !== o;
                    break;

                  case "<":
                    s = r < o;
                    break;

                  case "<=":
                    s = r <= o;
                    break;

                  case ">":
                    s = r > o;
                    break;

                  case ">=":
                    s = r >= o;
                    break;

                  case "**":
                    s = Math.pow(r, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && ln(o, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(Cn) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Rt, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var a = r ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, i);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new Mi(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof Mn) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(vi, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var a;
                if (ln(r, "_eval")) {
                    a = r._eval();
                } else {
                    this._eval = nn;
                    a = r._eval(e, n, t, i);
                    delete this._eval;
                    if (a === r) return this;
                    r._eval = function() {
                        return a;
                    };
                    t.push(r);
                }
                return a && typeof a == "object" && !o(this, i) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var p = a({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var d = fn("global ignoreCase multiline source");
            e(Mt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var a = this.expression;
                    if (!ze(a)) {
                        r = a._eval(e, n, t, i + 1);
                        if (r == null || r === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof dn) {
                        o = o._eval(e, n, t, i);
                        if (o === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = p[a.name];
                        if (!s || !s[o]) return this;
                        r = _[a.name];
                    } else if (r instanceof RegExp) {
                        if (!d[o]) return this;
                    } else if (typeof r == "object") {
                        if (!ln(r, o)) return this;
                    } else if (typeof r == "function") switch (o) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.length();

                      default:
                        return this;
                    }
                    return r[o];
                }
                return this;
            });
            function g(e, n, t, i, r) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, i, r);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(zt, function(i, r, a, o) {
                var e = this.expression;
                var n = e instanceof vi ? e.fixed_value() : e;
                if (n instanceof Bn || n instanceof Qn || n instanceof Wn) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(i)) return this;
                    var s = g(this.args, i, r, a, o);
                    if (!un(n.argnames, function(e, n) {
                        if (e instanceof $t) {
                            if (!s) return false;
                            if (s[n] !== undefined) return false;
                            var t = e.value._eval(i, r, a, o);
                            if (t === e.value) return false;
                            s[n] = t;
                            e = e.name;
                        }
                        return !(e instanceof Wt);
                    })) return this;
                    if (n.rest instanceof Wt) return this;
                    if (!s && !r) return this;
                    var t = n.first_statement();
                    if (!(t instanceof ft)) {
                        if (r) {
                            n.walk(m);
                            var f = false;
                            n.evaluating = true;
                            wn(n, new Mi(function(e) {
                                if (f) return true;
                                if (e instanceof ft) {
                                    if (e.value && e.value._eval(i, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof Mn && e !== n) return true;
                            }));
                            delete n.evaluating;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || un(n.argnames, function(e, n) {
                        return h(e, s[n]);
                    }) && !(n.rest && !h(n.rest, s.slice(n.argnames.length))) || r) {
                        n.evaluating = true;
                        u = u._eval(i, r, a, o);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (i.option("unsafe") && e instanceof Mt) {
                    var l = e.property;
                    if (l instanceof dn) {
                        l = l._eval(i, r, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (ze(p)) {
                        var d = x[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(i, r, a, o + 1);
                        if (u == null || u === p) return this;
                        var v = w[u.constructor.name];
                        if (!v || !v[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Si)) return this;
                    }
                    var s = g(this.args, i, r, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        dn.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function h(e, n) {
                    if (e instanceof $t) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var i = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return i;
                        };
                        c.push(e);
                    });
                    return true;
                }
            });
            e(qt, nn);
            e(yi, function(e, n, t, i) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!fe(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var r = g(this.expressions, e, n, t, i);
                if (!r) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < r.length; s++) {
                    o += r[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = nn;
                return this;
                function f(e) {
                    return e.replace(/\\(u\{[^}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                        var t = Pi(n);
                        if (typeof t != "string") a = true;
                        return t;
                    });
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return Ae(It, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = a(e);
                if (t) {
                    var r = Ae(bn, n, {
                        body: n
                    });
                    return _e(i, r) === r ? n : i;
                }
                return _e(i, n);
            }
            e(dn, function() {
                return a(this);
            });
            e(vn, function() {
                throw new Error("Cannot negate a statement");
            });
            e(Yt, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return a(this);
            });
            e(tt, function() {
                return a(this);
            });
            e(Rt, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(Nn, function() {
                return a(this);
            });
            e(Ct, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return le(this, n);
            });
            e(It, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var d = fn("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var v = fn("Map Set WeakMap WeakSet");
        zt.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (ze(n)) {
                    if (d[n.name]) return true;
                    if (this instanceof qt && v[n.name]) return true;
                }
                if (Fe(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        yi.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (ze(n) && d[n.name]) return true;
                if (n instanceof Ft && ze(n.expression)) {
                    var t = x[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        dn.DEFMETHOD("is_call_pure", Ze);
        zt.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Ft)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof Vt) {
                i = w.Array;
            } else if (t.is_boolean(e)) {
                i = w.Boolean;
            } else if (t.is_number(e)) {
                i = w.Number;
            } else if (t instanceof Si) {
                i = w.RegExp;
            } else if (t.is_string(e)) {
                i = w.String;
                if (r == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = w.Object;
            }
            return i && i[r];
        });
        function h(e) {
            while ((e = e.tail_node()) instanceof vi) {
                e = e.fixed_value();
                if (!e) return true;
            }
            return !(e instanceof Vt || e.TYPE == "Binary" && !Me[e.operator] || e instanceof wi || e instanceof jn || e instanceof Kt && un(e.properties, function(e) {
                return !(e instanceof ti || e instanceof Pt);
            }) || e instanceof mi || e instanceof Nt);
        }
        (function(e) {
            function t(e, n, t) {
                return !un(e, t ? function(e) {
                    return e instanceof Pt ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                return !e.expression.is_string(n) || e.expression.has_side_effects(n);
            }
            e(dn, en);
            e(Vt, function(e) {
                return t(this.elements, e, n);
            });
            e(Bt, function(e) {
                var n = this.left;
                if (!(n instanceof Mt)) return true;
                var t = n.expression;
                return !(t instanceof mi) || !t.scope.resolve().new || n instanceof jt && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Yt, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !Ye(this.right);
            });
            e(xn, function(e) {
                return t(this.body, e);
            });
            e(zt, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(_t, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(et, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof vi) n = n.fixed_value();
                    if (!c(n)) return true;
                }
                return t(this.properties, e);
            });
            e(it, function(e) {
                return this.key instanceof dn && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(Rt, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(wi, Ze);
            e(wt, function(e) {
                return t(this.definitions, e);
            });
            e(Gt, function(e) {
                return t(this.elements, e);
            });
            e(Jt, function(e) {
                return this.key instanceof dn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Xt, function(e) {
                return t(this.properties, e);
            });
            e(Ft, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(_n, Ze);
            e(dt, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(En, function(e) {
                return this.body.has_side_effects(e);
            });
            e(jn, Ze);
            e(Kt, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return h(t) || t.has_side_effects(n);
                });
            });
            e(mi, Ze);
            e(Qt, function(e) {
                return this.key instanceof dn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Ct, function(e) {
                return t(this.expressions, e);
            });
            e(bn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(jt, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(vt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(ri, Ze);
            e(vi, function(e) {
                return !this.is_declared(e) || !Ee(this, e);
            });
            e(yi, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(gt, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Nt, function(e) {
                return Ri[this.operator] || this.expression.has_side_effects(e);
            });
            e(St, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(dn, en);
            e(wi, Ze);
            e(Wt, en);
            e(_n, Ze);
            e(jn, Ze);
            e(mi, Ze);
            e(ri, Ze);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function i(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof vi) e = e.fixed_value();
                if (!(e instanceof jn)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return In(e) && e.value && e.value.may_throw(n);
            }
            e(Vt, function(e) {
                return t(this.elements, e);
            });
            e(Bt, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof vi) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(Yt, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !Ye(this.right);
            });
            e(xn, function(e) {
                return t(this.body, e);
            });
            e(zt, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = en;
                var n = i(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(_t, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Rt, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e($t, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e(wt, function(e) {
                return t(this.definitions, e);
            });
            e(Ft, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(dt, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(En, function(e) {
                return this.body.may_throw(e);
            });
            e(Kt, function(e) {
                return t(this.properties, e);
            });
            e(Qt, function(e) {
                return this.value.may_throw(e) || this.key instanceof dn && this.key.may_throw(e);
            });
            e(ft, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Ct, function(e) {
                return t(this.expressions, e);
            });
            e(bn, function(e) {
                return this.body.may_throw(e);
            });
            e(jt, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(vt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(vi, function(e) {
                return !this.is_declared(e) || !Ee(this, e);
            });
            e(yi, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = en;
                var n = i(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(gt, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Nt, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof vi);
            });
            e(St, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(dn, Ze);
            e(Vt, function(e) {
                return t(this.elements, e);
            });
            e(Yt, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && (this.operator != "in" || Ye(this.right));
            });
            e(et, function(e) {
                var n = this.extends;
                if (n && !c(n)) return false;
                return t(this.properties, e);
            });
            e(it, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(wi, en);
            e(jn, function(r) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Mi(function(e, n) {
                    if (!o) return true;
                    if (e instanceof yn) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof vi) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Xe(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e.name);
                            if (i ? i === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof mi) {
                        if (In(a) && un(s, function(e) {
                            return !(e instanceof Mn) || In(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(Kt, function(e) {
                return t(this.properties, e);
            });
            e(Qt, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e(Nt, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function F(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(vn, tn);
            e(ot, nn);
            function n() {
                var e = this.body.length;
                return e > 0 && F(this.body[e - 1]);
            }
            e(kn, n);
            e(ht, n);
            e(dt, function() {
                return this.alternative && F(this.body) && F(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var m = fn([ "use asm", "use strict" ]);
        e(mn, function(e, n) {
            if (n.option("directives") && (!m[e.value] || n.has_directive(e.value) !== e)) {
                return Ae(_n, e);
            }
            return e;
        });
        e(hn, function(e, n) {
            if (n.option("drop_debugger")) return Ae(_n, e);
            return e;
        });
        e(En, function(e, n) {
            if (n.option("dead_code") && e.body instanceof lt && n.loopcontrol_target(e.body) === e.body) {
                return Ae(_n, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(xn, function(e, n) {
            e.body = p(e.body, n);
            return e;
        });
        function Q(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? rn.skip : Ae(_n, e);

              case 1:
                var i = e.body[0];
                if (!y(i)) return e;
                if (n instanceof Sn && i instanceof Jn) return e;
                return i;
            }
            return e;
        }
        e(kn, function(e, n) {
            e.body = p(e.body, n);
            return Q(e, n.parent());
        });
        function _(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof Gt)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(jn, function(e, n) {
            _(e, n);
            e.body = p(e.body, n);
            return e;
        });
        function k(e, n) {
            if (!n.option("arrows")) return e;
            _(e, n);
            var t = p(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var i = t[0];
                if (i instanceof ft) {
                    e.body.length = 0;
                    e.value = i.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(Bn, k);
        e(Ln, k);
        e(Wn, function(n, e) {
            _(n, e);
            n.body = p(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var i = 0; i < n.body.length; i++) {
                var r = n.body[i];
                if (r instanceof mn) continue;
                if (r instanceof ft) {
                    if (i != n.body.length - 1) break;
                    var a = r.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof vi) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof Qn || o instanceof Wn)) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!un(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof at || t instanceof ei) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!un(n.argnames, function(e) {
                        return e instanceof ui;
                    })) break;
                    if (!un(a.args, function(e) {
                        return !(e instanceof Pt);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof vi)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(ui, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var j = fn("arguments await yield");
        Mn.DEFMETHOD("merge_variables", function(v) {
            if (!v.option("merge_vars")) return;
            var h, m, _ = {}, g = this;
            var o = [], s = [], f = 0;
            var b = new cn();
            var y = Object.create(null);
            var u = Object.create(null);
            var w = new Mi(function(r, e) {
                if (r instanceof Bt) {
                    var n = r.left;
                    var t = r.right;
                    if (n instanceof Wt) {
                        t.walk(w);
                        var i = new Mi(function(e) {
                            if (e instanceof Wt) return;
                            if (e instanceof $t) {
                                x();
                                e.value.walk(w);
                                k();
                                e.name.walk(i);
                            } else if (e instanceof Jt) {
                                if (e.key instanceof dn) {
                                    x();
                                    _.block = e;
                                    e.key.walk(w);
                                    e.value.walk(i);
                                    k();
                                } else {
                                    e.value.walk(i);
                                }
                            } else if (e instanceof vi) {
                                E(e);
                            } else {
                                e.walk(w);
                            }
                            return true;
                        });
                        n.walk(i);
                        return true;
                    }
                    if (Me[r.operator.slice(0, -1)]) {
                        n.walk(w);
                        x();
                        t.walk(w);
                        if (n instanceof vi) E(n);
                        k();
                        return true;
                    }
                    if (n instanceof vi) {
                        if (r.operator != "=") E(n, true);
                        t.walk(w);
                        E(n);
                        return true;
                    }
                    return;
                }
                if (r instanceof Yt) {
                    if (!Me[r.operator]) return;
                    r.left.walk(w);
                    x();
                    r.right.walk(w);
                    k();
                    return true;
                }
                if (r instanceof lt) {
                    var a = w.loopcontrol_target(r);
                    if (!(a instanceof Sn)) S(a);
                    return true;
                }
                if (r instanceof zt) {
                    var o = r.expression;
                    var s = o.tail_node();
                    if (!(s instanceof Nn)) {
                        e();
                        return d(o);
                    }
                    if (o !== s) o.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(w);
                    });
                    r.args.forEach(function(e) {
                        e.walk(w);
                    });
                    s.walk(w);
                    return true;
                }
                if (r instanceof Rt) {
                    r.condition.walk(w);
                    x();
                    r.consequent.walk(w);
                    k();
                    x();
                    r.alternative.walk(w);
                    k();
                    return true;
                }
                if (r instanceof pt) {
                    var a = w.loopcontrol_target(r);
                    if (a instanceof An) S(a);
                    return true;
                }
                if (r instanceof An) {
                    x();
                    _.block = r;
                    _.loop = true;
                    var f = _;
                    r.body.walk(w);
                    if (_.inserted === r) _ = f;
                    r.condition.walk(w);
                    k();
                    return true;
                }
                if (r instanceof On) {
                    if (r.init) r.init.walk(w);
                    x();
                    _.block = r;
                    _.loop = true;
                    if (r.condition) r.condition.walk(w);
                    r.body.walk(w);
                    if (r.step) r.step.walk(w);
                    k();
                    return true;
                }
                if (r instanceof $n) {
                    r.object.walk(w);
                    x();
                    _.block = r;
                    _.loop = true;
                    r.init.walk(w);
                    r.body.walk(w);
                    k();
                    return true;
                }
                if (r instanceof dt) {
                    r.condition.walk(w);
                    x();
                    r.body.walk(w);
                    k();
                    if (r.alternative) {
                        x();
                        r.alternative.walk(w);
                        k();
                    }
                    return true;
                }
                if (r instanceof En) {
                    x();
                    _.block = r;
                    var f = _;
                    r.body.walk(w);
                    if (_.inserted === r) _ = f;
                    k();
                    return true;
                }
                if (r instanceof Mn) {
                    x();
                    _.block = r;
                    if (r === g) m = _;
                    if (r instanceof jn) {
                        if (r.name) y[r.name.definition().id] = false;
                        var i = r.uses_arguments && !w.has_directive("use strict") ? function(e) {
                            if (e instanceof ui) y[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof ui) E(e);
                        };
                        var u = new Mi(function(e) {
                            if (e instanceof ri) y[e.definition().id] = false;
                            if (!(e instanceof vi)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e.name) === n)) {
                                y[n.id] = false;
                                y[t.id] = false;
                            } else {
                                var i = _;
                                k();
                                E(e, true);
                                _ = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(i, u);
                        });
                        if (r.rest) r.rest.mark_symbol(i, u);
                    }
                    Rn(r, w);
                    k();
                    return true;
                }
                if (r instanceof jt) {
                    var o = r.expression;
                    if (r.optional) {
                        o.walk(w);
                        x();
                        r.property.walk(w);
                        k();
                    } else {
                        e();
                    }
                    return d(o);
                }
                if (r instanceof vt) {
                    r.expression.walk(w);
                    var f = _;
                    r.body.forEach(function(e) {
                        if (e instanceof mt) return;
                        e.expression.walk(w);
                        if (f === _) x();
                    });
                    _ = f;
                    r.body.forEach(function(e) {
                        x();
                        _.block = r;
                        var n = _;
                        wn(e, w);
                        if (_.inserted === r) _ = n;
                        k();
                    });
                    return true;
                }
                if (r instanceof ai || r instanceof si) {
                    y[r.definition().id] = false;
                    return true;
                }
                if (r instanceof vi) {
                    E(r, true);
                    return true;
                }
                if (r instanceof gt) {
                    var c = h;
                    h = r;
                    var f = _;
                    wn(r, w);
                    _ = f;
                    if (r.bcatch) {
                        if (r.bcatch.argname) r.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof di) {
                                var n = e.definition();
                                y[n.id] = false;
                                if (n = n.redefined()) y[n.id] = false;
                            }
                        }, w);
                        if (r.bfinally || (h = c)) {
                            wn(r.bcatch, w);
                        } else {
                            x();
                            wn(r.bcatch, w);
                            k();
                        }
                    }
                    h = c;
                    _ = f;
                    if (r.bfinally) r.bfinally.walk(w);
                    return true;
                }
                if (r instanceof Nt) {
                    if (!Ii[r.operator]) return;
                    var l = r.expression;
                    if (!(l instanceof vi)) return;
                    E(l, true);
                    return true;
                }
                if (r instanceof St) {
                    var p = r.value;
                    if (p) {
                        p.walk(w);
                    } else {
                        p = _.block instanceof $n && _.block.init === w.parent();
                    }
                    r.name.mark_symbol(p ? function(e) {
                        if (!(e instanceof ri)) return;
                        if (e instanceof fi) {
                            E(e);
                        } else {
                            y[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof ri)) return;
                        var n = e.definition().id;
                        if (!(e instanceof fi)) {
                            y[n] = false;
                        } else if (!(n in y)) {
                            b.add(n, e);
                        } else if (y[n]) {
                            y[n].push(e);
                        }
                        return true;
                    }, w);
                    return true;
                }
                if (r instanceof Dn) {
                    x();
                    _.block = r;
                    _.loop = true;
                    e();
                    k();
                    return true;
                }
                function d(e) {
                    if (v.option("ie")) {
                        var n = Oe(e);
                        if (n instanceof vi) n.walk(w);
                    }
                    return true;
                }
            });
            w.directives = Object.create(v.directives);
            g.walk(w);
            var e = Object.create(null);
            while (o.length && s.length) {
                var n = o.pop();
                var t = n.definition;
                if (!(t.id in u)) continue;
                if (!y[t.id]) continue;
                var i = {
                    start: y[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = y[t.id].end;
                var r = [];
                do {
                    var a = s.pop();
                    if (!a) continue;
                    if (a.index > n.index) continue;
                    var c = a.definition.id;
                    var l = y[c];
                    if (!l) continue;
                    if (i.start.block !== l.start.block || !A(i, l) || (i.start.loop || !Be(t)) && !A(l, i) || v.option("webkit") && ke(t) !== ke(a.definition) || !un(l, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(a);
                        continue;
                    }
                    var p = [], d = [];
                    l.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof vi) {
                            d.push(e);
                        } else {
                            p.push(e);
                        }
                    });
                    t.orig = p.concat(t.orig);
                    t.references = d.concat(t.references);
                    t.fixed = a.definition.fixed && t.fixed;
                    e[c] = t;
                    break;
                } while (s.length);
                if (r.length) s = s.concat(r);
            }
            function x() {
                _ = Object.create(_);
            }
            function k() {
                _ = Object.getPrototypeOf(_);
            }
            function E(e, n) {
                var t = e.definition(), i, r = _;
                if (h) {
                    x();
                    r = _;
                    k();
                }
                if (t.id in y) {
                    var a = y[t.id];
                    if (!a) return;
                    if (a.start.block !== r.block) return y[t.id] = false;
                    a.push(e);
                    a.end = r;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((i = g.variables.get(t.name)) !== t) {
                    if (i && m === r) y[i.id] = false;
                    return y[t.id] = false;
                } else if (v.exposed(t) || j[e.name]) {
                    return y[t.id] = false;
                } else {
                    var a = b.get(t.id) || [];
                    a.push(e);
                    y[t.id] = a;
                    if (!n) {
                        a.start = r;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (r.block !== g) return y[t.id] = false;
                    a.start = m;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function S(e) {
                var n = [];
                while (true) {
                    if (ln(_, "block")) {
                        var t = _.block;
                        if (t instanceof En) t = t.body;
                        if (t === e) break;
                    }
                    n.push(_);
                    k();
                }
                _.inserted = _.block;
                x();
                while (n.length) {
                    var i = n.pop();
                    x();
                    if (ln(i, "block")) _.block = i.block;
                    if (ln(i, "loop")) _.loop = i.loop;
                }
            }
            function T(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function A(e, n) {
                return T(e.start, e.end) || T(e.start, n.start);
            }
        });
        function ye(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = Ae(Oi, e);
            }
        }
        function Z(e, n) {
            var t = Ae(tt, e, e);
            t.name = n ? null : Ae(pi, e.name, e.name);
            return t;
        }
        function je(e, n) {
            var t;
            switch (e.CTOR) {
              case Xn:
                t = Un;
                break;

              case Kn:
                t = Vn;
                break;

              case Qn:
                t = Wn;
                break;

              case Zn:
                t = Gn;
                break;
            }
            var i = Ae(t, e, e);
            i.name = n ? null : Ae(li, e.name, e.name);
            return i;
        }
        Mn.DEFMETHOD("drop_unused", function(S) {
            if (!S.option("unused")) return;
            var T = this;
            var A = !(T instanceof Fn) || S.toplevel.funcs;
            var D = !(T instanceof Fn) || S.toplevel.vars;
            var O = /keep_assign/.test(S.option("unused")) ? Ze : function(e, n) {
                var t, r = false;
                if (e instanceof Bt) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof Nt) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof vi)) return;
                var i = t.definition();
                if (o[i.id]) return;
                if (S.exposed(i)) return;
                if (!Ee(t, S, r)) return;
                return t;
                function a(e, n) {
                    if (e instanceof Mt) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(S, true)) {
                            r = true;
                            if (n && e instanceof jt) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof Bt && e.operator == "=") {
                        e.write_only = "p";
                        var i = a(e.right);
                        if (!n) return i;
                        n.assign = e;
                        return i instanceof vi ? i : e.left;
                    }
                    return e;
                }
            };
            var $ = Object.create(null);
            var o = Object.create(null);
            var h = function(e) {
                h = a(T, 0, Qe);
                return h(e);
                function a(e, n, i) {
                    var r = S.parent(n);
                    if (!r) return i;
                    var t = r instanceof jn && Xe(e, r.argnames);
                    return a(r, n + 1, t ? function(e) {
                        var n = i(e);
                        if (n) return n;
                        n = r.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof ui || t instanceof li) return n;
                        }
                    } : r.variables ? function(e) {
                        return i(e) || r.variables.get(e);
                    } : i);
                }
            };
            var z = Object.create(null);
            var m = [];
            var q = Object.create(null);
            var _ = Object.create(null);
            var g = Object.create(null);
            var C = Object.create(null);
            if (T instanceof Fn && S.top_retain) {
                T.variables.each(function(e) {
                    if (S.top_retain(e) && !(e.id in q)) {
                        q[e.id] = true;
                        m.push(e);
                    }
                });
            }
            var b = new cn();
            var y = new cn();
            var M = this;
            var w = new Mi(function(s, e) {
                if (s instanceof jn && s.uses_arguments && !w.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in q)) {
                            q[n.id] = true;
                            m.push(n);
                        }
                    });
                }
                if (s === T) return;
                if (M === T) {
                    if (s instanceof nt) {
                        var t = s.name.definition();
                        if ((!A || t.exported) && !(t.id in q)) {
                            q[t.id] = true;
                            m.push(t);
                        }
                        if (s.extends) s.extends.walk(w);
                        var i = false;
                        if (w.parent() instanceof At) {
                            i = true;
                            o[t.id] = true;
                        }
                        s.properties.forEach(function(e) {
                            if (e.key instanceof dn) e.key.walk(w);
                            if (!e.value) return;
                            if (i || e instanceof rt && e.static) {
                                var n = M;
                                M = s;
                                e.value.walk(w);
                                M = n;
                            } else {
                                y.add(t.id, e.value);
                            }
                        });
                        return true;
                    }
                    if (s instanceof Jn) {
                        var t = s.name.definition();
                        if ((!A || t.exported) && !(t.id in q)) {
                            q[t.id] = true;
                            m.push(t);
                        }
                        y.add(t.id, s);
                        if (w.parent() instanceof At) {
                            o[t.id] = true;
                        } else {
                            return true;
                        }
                    }
                    if (s instanceof wt) {
                        s.definitions.forEach(function(i) {
                            var r = i.value;
                            var a = r && (i.name instanceof Wt || r.has_side_effects(S));
                            var o = a && r.tail_node().operator == "=";
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof ri)) return;
                                var n = e.definition();
                                C[n.id] = (C[n.id] || 0) + 1;
                                if (s instanceof Et && n.orig[0] instanceof di) {
                                    var t = n.redefined();
                                    if (t) C[t.id] = (C[t.id] || 0) + 1;
                                }
                                if (!(n.id in q) && (!D || n.exported || (s instanceof xt ? n.redefined() : n.const_redefs) || !(s instanceof Et || ee(n)))) {
                                    q[n.id] = true;
                                    m.push(n);
                                }
                                if (r) {
                                    if (!a) {
                                        y.add(n.id, r);
                                    } else if (o) {
                                        E(n, e, g[n.id]);
                                    }
                                    b.add(n.id, i);
                                }
                                return true;
                            }, w);
                            if (a) r.walk(w);
                        });
                        return true;
                    }
                    if (s instanceof ui) {
                        var t = s.definition();
                        C[t.id] = (C[t.id] || 0) + 1;
                        b.add(t.id, s);
                        return true;
                    }
                    if (s instanceof oi) {
                        var t = s.definition();
                        if (!(t.id in q) && (!D || !ee(t))) {
                            q[t.id] = true;
                            m.push(t);
                        }
                        return true;
                    }
                }
                return r(s, e, true);
            });
            w.directives = Object.create(S.directives);
            T.walk(w);
            var F = S.option("keep_fnames") ? Ze : S.option("ie") ? function(e) {
                return !S.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in q)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof ui) return true;
                return un(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (S.option("ie")) y.each(function(e, n) {
                if (n in q) return;
                e.forEach(function(e) {
                    e.walk(new Mi(function(e) {
                        if (e instanceof Wn && e.name && !F(e.name.definition())) {
                            e.walk(w);
                            return true;
                        }
                        if (e instanceof Mn) return true;
                    }));
                });
            });
            w = new Mi(r);
            for (var e = 0; e < m.length; e++) {
                var n = y.get(m[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(w);
                });
            }
            Object.keys($).forEach(function(e) {
                var t = $[e];
                if (!t) {
                    delete $[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        an(n, e);
                    });
                    return n;
                }, []);
                var n = (b.get(e) || []).filter(function(n) {
                    return Ke(n instanceof Nt ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Nt) return false;
                        return i(e) === i(n);
                    }, t);
                });
                if (t.length == n.length) {
                    $[e] = n;
                } else {
                    delete $[e];
                }
            });
            var j = [];
            var P = [];
            var N = [];
            var I = [];
            var H = new Fi(function(i) {
                if (i instanceof $t) return J(H, i);
                if (i instanceof Wt && i.rest) i.rest = i.rest.transform(H);
                if (i instanceof Gt) {
                    var e = !i.rest;
                    for (var n = i.elements.length; --n >= 0; ) {
                        var t = i.elements[n].transform(H);
                        if (t) {
                            i.elements[n] = t;
                            e = false;
                        } else if (e) {
                            i.elements.pop();
                        } else {
                            i.elements[n] = Ae(Oi, i.elements[n]);
                        }
                    }
                    return i;
                }
                if (i instanceof Xt) {
                    var r = [];
                    i.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof dn) {
                            e.key = e.key.transform(Y);
                            n = e.key.has_side_effects(S);
                        }
                        if ((n || i.rest) && a(e.value)) {
                            e.value = e.value.transform(Y);
                            r.push(e);
                        } else {
                            var t = e.value.transform(H);
                            if (!t && i.rest) {
                                if (e.value instanceof Gt) {
                                    t = Ae(Gt, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = Ae(Xt, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                r.push(e);
                            }
                        }
                    });
                    i.properties = r;
                    return i;
                }
                if (i instanceof ri) return i.definition().id in q ? i : null;
            });
            var Y = new Fi(function(v, n, e) {
                var h = Y.parent();
                if (D) {
                    var t = [], i = O(v, t);
                    if (i) {
                        var r;
                        if (V(i, v)) {
                            if (v instanceof Bt) {
                                r = W(v);
                                if (v.write_only === true) r = r.drop_side_effect_free(S);
                            }
                            if (!r) r = Ae(ki, v, {
                                value: 0
                            });
                        }
                        if (r) {
                            if (t.assign) {
                                var a = t.assign.drop_side_effect_free(S);
                                if (a) {
                                    a.write_only = true;
                                    t.unshift(a);
                                }
                            }
                            if (!(h instanceof Ct) || h.tail_node() === v || r.has_side_effects(S)) {
                                t.push(r);
                            }
                            switch (t.length) {
                              case 0:
                                return rn.skip;

                              case 1:
                                return De(S, h, v, t[0].transform(Y));

                              default:
                                return le(v, t.map(function(e) {
                                    return e.transform(Y);
                                }));
                            }
                        }
                    } else if (v instanceof Ht && v.expression instanceof vi && U(v.expression.definition(), v) < 0) {
                        return Ae(It, v, {
                            operator: "+",
                            expression: v.expression
                        });
                    }
                }
                if (v instanceof zt) N.push(v);
                if (M !== T) return;
                if (A && v !== T && v instanceof nt) {
                    var o = v.name.definition();
                    if (!(o.id in q)) {
                        R(v.name, "Dropping unused class {name}");
                        o.eliminated++;
                        n(v, Y);
                        if (h instanceof At) return Z(v, true);
                        var s = v.drop_side_effect_free(S, true);
                        if (s === v) s = Z(v, true);
                        if (s) return Ae(bn, v, {
                            body: s
                        });
                        return e ? rn.skip : Ae(_n, v);
                    }
                }
                if (v instanceof tt && v.name && F(v.name.definition())) {
                    P.push(v);
                }
                if (v instanceof jn) {
                    if (A && v !== T && v instanceof Jn) {
                        var o = v.name.definition();
                        if (!(o.id in q)) {
                            R(v.name, "Dropping unused function {name}");
                            o.eliminated++;
                            if (h instanceof At) {
                                E();
                                return je(v, true);
                            }
                            return e ? rn.skip : Ae(_n, v);
                        }
                    }
                    if (v instanceof Nn && v.name && F(v.name.definition())) {
                        P.push(v);
                    }
                    if (!(v instanceof Pn)) {
                        if (v.rest) {
                            var f = v.rest.transform(H);
                            if (f instanceof Wt && !f.rest && (!v.uses_arguments || Y.has_directive("use strict"))) {
                                if (f instanceof Gt) {
                                    if (f.elements.length == 0) f = null;
                                } else if (f.properties.length == 0) {
                                    f = null;
                                }
                            }
                            v.rest = f;
                        }
                        var u = v.argnames;
                        var c = S.drop_fargs(v, h) && !v.rest;
                        var l = c ? -1 : v.length();
                        for (var p = u.length; --p >= 0; ) {
                            var i = u[p];
                            if (!(i instanceof ui)) {
                                var d = i.transform(H);
                                if (d) {
                                    c = false;
                                } else if (c) {
                                    R(i.name, "Dropping unused default argument {name}");
                                    u.pop();
                                } else if (p > l) {
                                    R(i.name, "Dropping unused default argument assignment {name}");
                                    i.name.__unused = true;
                                    u[p] = i.name;
                                } else {
                                    R(i.name, "Dropping unused default argument value {name}");
                                    i.value = Ae(ki, i, {
                                        value: 0
                                    });
                                }
                                continue;
                            }
                            var o = i.definition();
                            if (o.id in q) {
                                c = false;
                                if (U(o, i) < 0) i.__unused = null;
                            } else if (c) {
                                R(i, "Dropping unused function argument {name}");
                                u.pop();
                            } else {
                                i.__unused = true;
                            }
                        }
                        I.push(v);
                    }
                }
                if (v instanceof bt && v.argname instanceof Wt) {
                    v.argname.transform(H);
                }
                if (v instanceof wt && !(h instanceof $n && h.init === v)) {
                    var m = [], _ = [], g = [];
                    var b = [];
                    var y = 0;
                    var w = v instanceof Et;
                    v.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(Y);
                        var e = t.value;
                        if (t.name instanceof Wt) {
                            var n = X(t.name, e, function(e) {
                                if (!D) return e;
                                if (e.definition().id in q) return e;
                                if (p(e)) return e;
                                if (w && !Ee(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = Ae(St, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                d();
                            } else if (n.value) {
                                b.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var i = w ? Ee(t.name) : ee(a);
                        if (!i || !D || a.id in q) {
                            if (e && U(a, t) < 0) {
                                e = e.drop_side_effect_free(S);
                                if (e) {
                                    dn.warn("Side effects in last use of variable {name} [{file}:{line},{col}]", B(t.name));
                                    b.push(e);
                                }
                                e = null;
                                j.push(t);
                            }
                            var r;
                            if (!e && !(v instanceof kt)) {
                                if (h instanceof Tt) {
                                    d();
                                } else if (i && C[a.id] > 1) {
                                    dn.info("Dropping declaration of variable {name} [{file}:{line},{col}]", B(t.name));
                                    C[a.id]--;
                                    a.eliminated++;
                                } else {
                                    _.push(t);
                                }
                            } else if (S.option("functions") && !S.option("ie") && i && C[a.id] == 1 && a.assignments == 0 && e instanceof Nn && !xe(a) && !In(e) && u(e, a.references) && c(e) && (r = l(e, t.name.name)) !== false) {
                                dn.warn("Declaring {name} as function [{file}:{line},{col}]", B(t.name));
                                var o;
                                switch (e.CTOR) {
                                  case Un:
                                    o = Xn;
                                    break;

                                  case Vn:
                                    o = Kn;
                                    break;

                                  case Wn:
                                    o = Qn;
                                    break;

                                  case Gn:
                                    o = Zn;
                                    break;
                                }
                                var s = Ae(o, t, e);
                                s.name = Ae(ci, t.name, t.name);
                                var f = t.name.scope.resolve().def_function(s.name);
                                if (r) r.forEach(function(e) {
                                    e.name = f.name;
                                    e.thedef = f;
                                    e.reference();
                                });
                                m.push(s);
                            } else {
                                if (i && C[a.id] > 1 && !(h instanceof Tt) && a.orig.indexOf(t.name) > a.eliminated) {
                                    C[a.id]--;
                                    y++;
                                }
                                d();
                            }
                        } else if (p(t.name)) {
                            e = e && e.drop_side_effect_free(S);
                            if (e) b.push(e);
                            if (C[a.id] > 1) {
                                dn.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", B(t.name));
                                C[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                _.push(t);
                            }
                        } else {
                            e = e && !e.single_use && e.drop_side_effect_free(S);
                            if (e) {
                                dn.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", B(t.name));
                                b.push(e);
                            } else {
                                R(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function u(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return un(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function c(e) {
                            if (!w || S.has_directive("use strict") || !(e instanceof Wn)) {
                                return h instanceof Mn;
                            }
                            return h instanceof xn || h instanceof On && h.init === v || h instanceof dt;
                        }
                        function l(t, i) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == i) return e;
                            var r;
                            switch (i) {
                              case "await":
                                r = Hn;
                                break;

                              case "yield":
                                r = Yn;
                                break;
                            }
                            return un(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(i) !== a) return false;
                                if (r) do {
                                    n = n.resolve();
                                    if (r(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function p(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof di && n.scope.resolve() === e.scope.resolve();
                        }
                        function d() {
                            if (b.length > 0) {
                                if (g.length == 0) {
                                    m.push(Ae(bn, v, {
                                        body: le(v, b)
                                    }));
                                } else if (e) {
                                    b.push(e);
                                    t.value = le(e, b);
                                } else {
                                    t.value = Ae(It, t, {
                                        operator: "void",
                                        expression: le(t, b)
                                    });
                                }
                                b = [];
                            }
                            g.push(t);
                        }
                    });
                    switch (_.length) {
                      case 0:
                        if (g.length == 0) break;
                        if (g.length == y) {
                            [].unshift.apply(b, g.map(function(e) {
                                dn.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", B(e.name));
                                var n = e.name.definition();
                                var t = Ae(vi, e.name, e.name);
                                n.references.push(t);
                                var i = Ae(Bt, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = U(n, e);
                                if (r >= 0) $[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (g.length == 0) {
                            var x = _[0].name.definition().id;
                            if (x in z) {
                                v.definitions = _;
                                z[x].init = v;
                                break;
                            }
                        }

                      default:
                        v.definitions = _.concat(g);
                        m.push(v);
                    }
                    if (b.length > 0) {
                        m.push(Ae(bn, v, {
                            body: le(v, b)
                        }));
                    }
                    return L(m, v, e);
                }
                if (v instanceof Bt) {
                    n(v, Y);
                    if (!(v.left instanceof Wt)) return v;
                    var s = X(v.left, v.right, function(e) {
                        return e;
                    }, v.write_only === true);
                    if (s.name) return Ae(Bt, v, {
                        operator: v.operator,
                        left: s.name,
                        right: s.value
                    });
                    if (s.value) return s.value;
                    if (h instanceof Ct && h.tail_node() !== v) return rn.skip;
                    return Ae(ki, v, {
                        value: 0
                    });
                }
                if (v instanceof En && v.body instanceof On) {
                    n(v, Y);
                    if (v.body instanceof kn) {
                        var k = v.body;
                        v.body = k.body.pop();
                        k.body.push(v);
                        return e ? rn.splice(k.body) : k;
                    }
                    return v;
                }
                if (v instanceof Mn) {
                    E();
                    return v;
                }
                if (v instanceof oi) {
                    if (!S.option("imports") || v.definition().id in q) return v;
                    return e ? rn.skip : null;
                }
                function E() {
                    var e = M;
                    M = v;
                    n(v, Y);
                    M = e;
                }
            }, function(e, n) {
                if (e instanceof kn) return Q(e, Y.parent(), n);
                if (e instanceof On) {
                    var t;
                    if (e.init instanceof kn) {
                        t = e.init;
                        e.init = t.body.pop();
                        t.body.push(e);
                    }
                    if (e.init instanceof Qn) {
                        if (!t) {
                            t = Ae(kn, e, {
                                body: [ e ]
                            });
                        }
                        t.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof bn) {
                        e.init = e.init.body;
                    } else if (ve(e.init)) {
                        e.init = null;
                    }
                    return !t ? e : n ? rn.splice(t.body) : t;
                }
                if (e instanceof zn) {
                    if (!D || !S.option("loops")) return;
                    if (!ve(e.body)) return;
                    var i = G(e);
                    if (!i) return;
                    var r = i.definition();
                    if (r.id in q) return;
                    R(i, "Dropping unused loop variable {name}");
                    if (z[r.id] === e) delete z[r.id];
                    var a = [];
                    var o = e.object.drop_side_effect_free(S);
                    if (o) {
                        dn.warn("Side effects in object of for-in loop [{file}:{line},{col}]", o.start);
                        a.push(Ae(bn, e, {
                            body: o
                        }));
                    }
                    if (e.init instanceof wt && r.orig[0] instanceof di) {
                        a.push(e.init);
                    }
                    return L(a, e, n);
                }
                if (e instanceof Ot) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof Ct) {
                    if (e.expressions.length > 1) return;
                    return De(S, Y.parent(), e, e.expressions[0]);
                }
            });
            Y.push(S.parent());
            T.transform(Y);
            if (T instanceof jn && T.body.length == 1 && T.body[0] instanceof mn && T.body[0].value == "use strict") {
                T.body.length = 0;
            }
            j.forEach(function(e) {
                e.value = null;
            });
            P.forEach(function(e) {
                e.name = null;
            });
            N.forEach(function(e) {
                He(e, S, I);
            });
            function R(e, n) {
                dn[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", B(e));
            }
            function B(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function i(e) {
                return e[e instanceof Bt ? "right" : "value"];
            }
            function L(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? rn.skip : Ae(_n, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? rn.splice(e) : Ae(kn, n, {
                        body: e
                    });
                }
            }
            function x(e, n) {
                if (e.scope.resolve() !== T) return false;
                if (!e.fixed || !n.fixed) $[e.id] = false;
                return $[e.id] !== false;
            }
            function k(e, n) {
                if (!$[e.id]) $[e.id] = [];
                if (n.fixed.assigns) an($[e.id], n.fixed.assigns);
            }
            function U(e, n) {
                var t = $[e.id];
                return t && t.indexOf(n);
            }
            function E(e, n, t) {
                if (e.id in q) return;
                if (n && t) {
                    q[e.id] = n;
                    m.push(e);
                } else {
                    _[e.id] = n;
                    g[e.id] = t;
                }
            }
            function V(e, n) {
                var t = e.definition();
                var i = q[t.id];
                if (!i) return true;
                if (n[n instanceof Bt ? "left" : "expression"] !== e) return false;
                return i === e && t.references.length - t.replaced == 1 || U(t, n) < 0;
            }
            function W(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Yt && Me[n.operator])) return n;
                if (!(n.left instanceof vi)) return n;
                if (!(e.left instanceof vi)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(S)) return n;
                if (x(t, n.left)) k(t, n.left);
                return n.right;
            }
            function G(e) {
                var n = e.init;
                if (n instanceof wt) {
                    n = n.definitions[0].name;
                    return n instanceof ri && n;
                }
                while (n instanceof Mt) n = n.expression.tail_node();
                if (n instanceof vi) return n;
            }
            function r(e, n, t) {
                if (e instanceof Bt && e.left instanceof vi) {
                    var i = e.left.definition();
                    if (i.scope.resolve() === T) b.add(i.id, e);
                }
                if (e instanceof Nt && e.expression instanceof vi) {
                    var i = e.expression.definition();
                    if (i.scope.resolve() === T) b.add(i.id, e);
                }
                var r, a = [], o = O(e, a);
                if (o && ((r = o.definition()).scope.resolve() === T || T.variables.get(o.name) === r) && !(xe(r) && !un(T.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof ui) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    if (e.write_only === "p" && e.right.may_throw_on_access(S, true)) return;
                    var s = a.assign;
                    if (s) {
                        s.write_only = true;
                        s.walk(w);
                    }
                    a.forEach(function(e) {
                        e.walk(w);
                    });
                    if (e instanceof Bt) {
                        var f = W(e), u = false;
                        if (t && e.write_only === true && !f.has_side_effects(S)) {
                            y.add(r.id, f);
                        } else {
                            f.walk(w);
                            u = f.tail_node().operator == "=";
                        }
                        if (e.left === o) {
                            if (!e.write_only || u) {
                                E(r, o, g[r.id]);
                            }
                        } else {
                            var c = o.fixed_value();
                            if (!c || !c.is_constant()) {
                                E(r, _[r.id], true);
                            }
                        }
                    }
                    if (x(r, o) && Bi(o, e) !== o) k(r, o);
                    return true;
                }
                if (e instanceof zn) {
                    if (e.init instanceof vi && M === T) {
                        var l = e.init.definition().id;
                        if (!(l in z)) z[l] = e;
                    }
                    if (!D || !S.option("loops")) return;
                    if (!ve(e.body)) return;
                    if (e.init.has_side_effects(S)) return;
                    var o = G(e);
                    if (!o) return;
                    var i = o.definition();
                    if (i.scope.resolve() !== T) {
                        var p = h(o.name);
                        if (p === i || p && p.redefined() === i) return;
                    }
                    e.object.walk(w);
                    return true;
                }
                if (e instanceof vi) {
                    r = e.definition();
                    if (!(r.id in q)) {
                        q[r.id] = true;
                        m.push(r);
                    }
                    if (K(r.scope, e.scope)) {
                        var d = r.redefined();
                        if (d && !(d.id in q)) {
                            q[d.id] = true;
                            m.push(d);
                        }
                    }
                    if (x(r, e)) k(r, e);
                    return true;
                }
                if (e instanceof Mn) {
                    var v = M;
                    M = e;
                    n();
                    M = v;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof $t ? e.name : e) instanceof ri;
            }
            function J(e, n) {
                n.value = n.value.transform(Y);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof Wt) return null;
                    var i = n.value.drop_side_effect_free(S);
                    if (!i) return null;
                    R(n.name, "Side effects in default value of unused variable {name}");
                    n.name.__unused = null;
                    n.value = i;
                }
                return n;
            }
            function X(e, m, _, g) {
                var b = new Fi(function(a) {
                    if (a instanceof $t) {
                        if (S.option("default_values") && m && m.is_defined(S)) {
                            a = a.name;
                        } else {
                            var e = g;
                            g = false;
                            var n = J(b, a);
                            g = e;
                            if (!n && g && m) m = m.drop_side_effect_free(S);
                            return n;
                        }
                    }
                    if (a instanceof Gt) {
                        var e = g;
                        var t = m;
                        if (m instanceof vi) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var i = m instanceof Vt && m.elements;
                        var r = [], o = g && [], s = 0;
                        a.elements.forEach(function(e, n) {
                            m = i && i[n];
                            if (m instanceof Oi) {
                                m = null;
                            } else if (m instanceof Pt) {
                                if (g) {
                                    o.length = s;
                                    ye(t, o);
                                    [].push.apply(o, i.slice(n));
                                    t.elements = o;
                                }
                                m = i = false;
                            }
                            e = e.transform(b);
                            if (e) r[s] = e;
                            if (g && m) o[s] = m;
                            if (e || m || !g || !i) s++;
                        });
                        m = i && Ae(Vt, t, {
                            elements: i.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var f = g;
                            g = false;
                            a.rest = a.rest.transform(S.option("rests") ? b : Y);
                            g = f;
                            if (a.rest) r.length = s;
                        }
                        if (g) {
                            if (m && !a.rest) m = m.drop_side_effect_free(S);
                            if (m instanceof Vt) {
                                m = m.elements;
                            } else if (m instanceof Ct) {
                                m = m.expressions;
                            } else if (m) {
                                m = [ m ];
                            }
                            if (m && m.length) {
                                o.length = s;
                                [].push.apply(o, m);
                            }
                        }
                        m = t;
                        g = e;
                        if (i && o) {
                            ye(m, o);
                            m.elements = o;
                        }
                        if (!a.rest && (m instanceof Vt || m && m.is_string(S))) switch (r.length) {
                          case 0:
                            if (g) m = m.drop_side_effect_free(S);
                            return null;

                          case 1:
                            if (!g) break;
                            var u = r[0];
                            if (!(u instanceof ii)) break;
                            m = Ae(jt, a, {
                                expression: m,
                                property: Ae(ki, a, {
                                    value: 0
                                })
                            });
                            return u;
                        }
                        ye(a, r);
                        a.elements = r;
                        return a;
                    }
                    if (a instanceof Xt) {
                        var e = g;
                        var t = m;
                        if (m instanceof vi) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var c, l;
                        if (m instanceof Kt) {
                            c = [];
                            l = Object.create(null);
                            m.properties.forEach(function(e, n) {
                                if (e instanceof Pt) return l = false;
                                var t = e.key;
                                if (t instanceof dn) t = t.evaluate(S, true);
                                if (t instanceof dn) {
                                    l = false;
                                } else if (l && !(e instanceof ni)) {
                                    l[t] = e;
                                }
                                c[n] = t;
                            });
                        }
                        if (a.rest) {
                            m = false;
                            a.rest = a.rest.transform(S.option("rests") ? b : Y);
                        }
                        var p = Object.create(null);
                        var d = g && Object.create(null);
                        var v = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof dn) {
                                e.key = n = n.transform(Y);
                                n = n.evaluate(S, true);
                            }
                            if (n instanceof dn) {
                                d = false;
                            } else {
                                p[n] = !(n in p);
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], i;
                            if (e instanceof dn) {
                                g = false;
                                m = false;
                                i = t.value.transform(b) || w(t.value);
                            } else {
                                g = d && p[e];
                                var r = l && l[e];
                                if (r) {
                                    m = r.value;
                                    if (m instanceof Pn) m = false;
                                } else {
                                    m = false;
                                }
                                i = t.value.transform(b);
                                if (!i) {
                                    if (a.rest || y(t)) i = w(t.value);
                                    if (d && !(e in d)) {
                                        if (r) {
                                            d[e] = r;
                                            if (m === null) {
                                                l[e] = y(r) && Ae(Zt, r, {
                                                    key: r.key,
                                                    value: Ae(ki, r, {
                                                        value: 0
                                                    })
                                                });
                                            }
                                        } else {
                                            d[e] = true;
                                        }
                                    }
                                } else if (d) {
                                    d[e] = false;
                                }
                                if (m) r.value = m;
                            }
                            if (i) {
                                t.value = i;
                                v.push(t);
                            }
                        });
                        m = t;
                        g = e;
                        if (d && c) m.properties = rn(m.properties, function(e, n) {
                            if (e instanceof Pt) return e;
                            var t = c[n];
                            if (t instanceof dn) return e;
                            if (t in d) {
                                var i = d[t];
                                if (!i) return e;
                                if (i === e) return l[t] || rn.skip;
                            } else if (a.rest) {
                                return e;
                            }
                            var r = e.value.drop_side_effect_free(S);
                            if (r) {
                                e.value = r;
                                return e;
                            }
                            return y(e) ? Ae(Zt, e, {
                                key: e.key,
                                value: Ae(ki, e, {
                                    value: 0
                                })
                            }) : rn.skip;
                        });
                        if (m && !a.rest) switch (v.length) {
                          case 0:
                            if (m.may_throw_on_access(S, true)) break;
                            if (g) m = m.drop_side_effect_free(S);
                            return null;

                          case 1:
                            if (!g) break;
                            var h = v[0];
                            if (h.key instanceof dn) break;
                            if (!(h.value instanceof ii)) break;
                            m = Ae(jt, a, {
                                expression: m,
                                property: pe(h.key, h)
                            });
                            return h.value;
                        }
                        a.properties = v;
                        return a;
                    }
                    if (a instanceof Oi) {
                        a = null;
                    } else {
                        a = _(a);
                    }
                    if (!a && g && m) m = m.drop_side_effect_free(S);
                    return a;
                });
                return {
                    name: e.transform(b),
                    value: m
                };
                function y(e) {
                    return e.key instanceof dn && e.key.has_side_effects(S);
                }
                function w(e) {
                    if (e instanceof $t) return w(e.name);
                    if (e instanceof Wt) {
                        if (m === null) {
                            m = Ae(ki, e, {
                                value: 0
                            });
                        } else if (m) {
                            if (m.tail_node().write_only === true || m.may_throw_on_access(S, true)) {
                                m = Ae(Vt, e, {
                                    elements: m instanceof Ct ? m.expressions : [ m ]
                                });
                            }
                        }
                        return Ae(Xt, e, {
                            properties: []
                        });
                    }
                    e.__unused = null;
                    return e;
                }
            }
        });
        Mn.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Mi(function(e) {
                    if (n > 1) return true;
                    if (e instanceof Tt) return true;
                    if (e instanceof Mn && e !== u) return true;
                    if (e instanceof Et) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = Object.create(null);
            var l = [];
            var p = [];
            var d = new cn(), v = 0;
            var h = new Fi(function(e, n, t) {
                if (e === u) return;
                if (e instanceof mn) {
                    l.push(e);
                    return t ? rn.skip : Ae(_n, e);
                }
                if (e instanceof Jn) {
                    if (!s) return e;
                    var i = h.parent();
                    if (i instanceof Tt) return e;
                    if (i instanceof At) return e;
                    if (i !== u && o.has_directive("use strict")) return e;
                    p.push(e);
                    return t ? rn.skip : Ae(_n, e);
                }
                if (e instanceof Et) {
                    if (!f) return e;
                    var i = h.parent();
                    if (i instanceof Tt) return e;
                    if (!un(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof fi && !c[n.name] && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        d.set(e.name.name, e);
                        ++v;
                    });
                    var r = e.to_assignments();
                    if (i instanceof $n && i.init === e) {
                        if (r) return r;
                        var a = e.definitions[0].name;
                        return Ae(vi, a, a);
                    }
                    if (i instanceof On && i.init === e) return r;
                    if (!r) return t ? rn.skip : Ae(_n, e);
                    return Ae(bn, e, {
                        body: r
                    });
                }
                if (e instanceof Mn) return e;
                if (e instanceof ai) {
                    c[e.name] = true;
                    return e;
                }
            });
            u.transform(h);
            if (v > 0) {
                var m = [];
                if (u instanceof jn) u.each_argname(function(e) {
                    d.del(e.name);
                });
                d.each(function(e, n) {
                    e = e.clone();
                    e.value = null;
                    m.push(e);
                    d.set(n, e);
                });
                if (m.length > 0) {
                    _(u.body);
                    m = Ae(Et, u, {
                        definitions: m
                    });
                    p.push(m);
                }
            }
            u.body = l.concat(p, u.body);
            function _(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof bn) {
                        var t = n.body, i, r;
                        if (t instanceof Bt && t.operator == "=" && (i = t.left) instanceof ii && d.has(i.name)) {
                            var a = d.get(i.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof Ct) o = o.clone();
                            a.value = o;
                            sn(m, a);
                            m.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof Ct && (r = t.expressions[0]) instanceof Bt && r.operator == "=" && (i = r.left) instanceof ii && d.has(i.name)) {
                            var a = d.get(i.name);
                            if (a.value) break;
                            a.value = r.right;
                            sn(m, a);
                            m.push(a);
                            n.body = le(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof _n) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof kn && !_(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function P(n, t) {
            n.walk(new Mi(function(e) {
                if (e instanceof ft) {
                    t(e);
                    return true;
                }
                if (e instanceof Mn && e !== n) return true;
            }));
        }
        function N(e) {
            var i = Object.create(null);
            P(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof vi) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function I(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function H(e, i) {
            P(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = L(i, n);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? le(e.value, [ n, Ae(ki, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof dn)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? le(e.value, [ n, Ae(ki, e.value, {
                            value: 1
                        }) ]) : Ae(ki, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Mn.DEFMETHOD("process_boolean_returns", Qe);
        Qn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = N(this);
            if (!I(this.name.definition(), n, e)) return;
            if (e.parent() instanceof At) return;
            H(this, e);
        });
        Wn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = N(this);
            if (this.name && !I(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof Bt) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof vi)) return;
                if (!I(i.definition(), n, e)) return;
            } else if (t instanceof zt && t.expression !== this) {
                var r = t.expression;
                if (r instanceof vi) r = r.fixed_value();
                if (!(r instanceof jn)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i instanceof $t) i = i.name;
                if (i instanceof ui && !I(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            H(this, e);
        });
        yn.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        Mn.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof ri) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (Xe(n, i)) return;
                do {
                    an(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var r = t;
            for (var a = 0; !un(i, function(e) {
                return !e.var_names()[r];
            }); a++) r = t + "$" + a;
            var o = Ae(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(o);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names()[r] = true;
            });
            return o;
        });
        Mn.DEFMETHOD("hoist_properties", function(r) {
            if (!r.option("hoist_props") || r.has_directive("use asm")) return;
            var f = this;
            var a = f instanceof Fn && r.top_retain || Ze;
            var u = Object.create(null);
            f.transform(new Fi(function(i, e) {
                if (i instanceof Bt) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new cn();
                    var a = [];
                    var o = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(fi, i.left, e.key);
                        o.push(Ae(St, i, {
                            name: n,
                            value: null
                        }));
                        var t = Ae(vi, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(Ae(Bt, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, Ae(Et, i, {
                        definitions: o
                    }));
                    return le(i, a);
                }
                if (i instanceof Mn) return i === f ? undefined : i;
                if (i instanceof St) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new cn();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(Ae(St, i, {
                            name: s(i.name.CTOR, i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return rn.splice(n);
                }
                function s(e, n, t) {
                    var i = f.make_var(e, n, n.name + "_" + t);
                    r.set(t, i.definition());
                    return i;
                }
            }));
            f.transform(new Fi(function(e, n) {
                if (e instanceof Mt) {
                    if (!(e.expression instanceof vi)) return;
                    var t = u[e.expression.definition().id];
                    if (!t) return;
                    var i = t.get(e.get_property());
                    var r = Ae(vi, e, {
                        name: i.name,
                        scope: e.expression.scope,
                        thedef: i
                    });
                    r.reference();
                    return r;
                }
                if (e instanceof vi) {
                    if (!(e.definition().id in u)) return;
                    return Ae(Kt, e, {
                        properties: []
                    });
                }
            }));
            function t(e, n, t) {
                if (!(e instanceof ii)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (a(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof Kt && n.properties.length > 0 && un(n.properties, Je) && un(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && Ee(e, r);
            }
        });
        function Pe(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return un(t.references, function(e) {
                return !(e instanceof vi);
            });
        }
        (function(e) {
            function l(e, n, t, i) {
                var r = e.length;
                var a = [], o = false;
                for (var s = 0; s < r; s++) {
                    var f = e[s];
                    var u;
                    if (i && f instanceof Pt) {
                        u = i(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function p(e, n, t) {
                var i = e.expression;
                if (!i.is_string(n)) return e;
                return i.drop_side_effect_free(n, t);
            }
            function d(e) {
                return e instanceof Pt ? Ae(Vt, e, {
                    elements: [ e ]
                }) : e;
            }
            e(dn, nn);
            e(Pn, tn);
            e(Vt, function(e, n) {
                var t = l(this.elements, e, n, p);
                if (!t) return null;
                if (t === this.elements && un(t, function(e) {
                    return e instanceof Pt;
                })) return this;
                return le(this, t.map(d));
            });
            e(Bt, function(e) {
                var n = this.left;
                if (n instanceof Mt) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                var i = this.right;
                if (!Me[this.operator.slice(0, -1)]) {
                    this.write_only = true;
                    if (Oe(n).is_constant_expression(e.find_parent(Mn))) {
                        return i.drop_side_effect_free(e);
                    }
                }
                return this;
            });
            e(Lt, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!oe(e, n)) return this;
                var t = this.clone();
                t.expression = n.drop_side_effect_free(e) || Ae(ki, this, {
                    value: 0
                });
                return t;
            });
            e(Yt, function(e, n) {
                var t = this.left;
                var i = this.right;
                var r = this.operator;
                if (r == "in" && !Ye(i)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || Ae(ki, t, {
                        value: 0
                    });
                    return o;
                }
                var s = i.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (Me[r] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== i) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (r == "??") return o;
                    var f = Ae(Yt, this, {
                        operator: r == "&&" ? "||" : "&&",
                        left: t.negate(e, n),
                        right: o.right
                    });
                    return n ? u(o, f) : _e(o, f);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return le(this, [ a, s ]);
            });
            function v(a, n) {
                var e = In(n);
                var t = Hn(n);
                var i = false;
                if (e && a.option("arrows")) {
                    if (!n.value) {
                        i = true;
                    } else if (!t || oe(a, n.value)) {
                        n.value = n.value.drop_side_effect_free(a);
                    }
                } else if (n instanceof Un || n instanceof Wn) {
                    if (n.name) {
                        var r = n.name.definition();
                        i = r.references.length == r.replaced;
                    } else {
                        i = true;
                    }
                }
                if (i) {
                    n.process_expression(false, function(e) {
                        var n = e.value;
                        if (n) {
                            if (t && !oe(a, n)) return e;
                            n = n.drop_side_effect_free(a, true);
                        }
                        if (!n) return Ae(_n, e);
                        return Ae(bn, e, {
                            body: n
                        });
                    });
                    P(n, function(e) {
                        var n = e.value;
                        if (n) {
                            if (t && !oe(a, n)) return;
                            e.value = n.drop_side_effect_free(a);
                        }
                    });
                }
                if (t && a.option("awaits")) {
                    if (i) n.process_expression("awaits", function(e) {
                        var n = e.body;
                        if (n instanceof Lt) {
                            if (oe(a, n.expression)) {
                                n = n.expression.drop_side_effect_free(a, true);
                                if (!n) return Ae(_n, e);
                                e.body = n;
                            }
                        } else if (n instanceof Ct) {
                            var t = n.expressions;
                            for (var i = t.length; --i >= 0; ) {
                                var r = t[i];
                                if (!(r instanceof Lt)) break;
                                if (!oe(a, r.expression)) break;
                                if (t[i] = r.expression.drop_side_effect_free(a)) break;
                            }
                            switch (i) {
                              case -1:
                                return Ae(_n, e);

                              case 0:
                                e.body = t[0];
                                break;

                              default:
                                t.length = i + 1;
                                break;
                            }
                        }
                        return e;
                    });
                    var o = !i && n.name || e && n.value && !oe(a, n.value);
                    var s = new Mi(function(e) {
                        if (o) return true;
                        if (s.parent() === n && e.may_throw(a)) return o = true;
                        if (e instanceof Lt) return o = true;
                        if (e instanceof qn) return o = true;
                        if (e instanceof ft) {
                            if (e.value && !oe(a, e.value)) return o = true;
                            return;
                        }
                        if (e instanceof Mn && e !== n) return true;
                    });
                    n.walk(s);
                    if (!o) {
                        var f;
                        switch (n.CTOR) {
                          case Ln:
                            f = Bn;
                            break;

                          case Un:
                            f = Wn;
                            break;

                          case Vn:
                            f = Gn;
                            break;
                        }
                        return Ae(f, n, n);
                    }
                }
                return i && n.clone();
            }
            e(zt, function(n, e) {
                var t = this;
                if (t.is_expr_pure(n)) {
                    if (t.pure) dn.warn("Dropping __PURE__ call [{file}:{line},{col}]", t.start);
                    var i = l(t.args, n, e, p);
                    return i && le(t, i.map(d));
                }
                var r = t.expression;
                if (t.is_call_pure(n)) {
                    var a = t.args.slice();
                    a.unshift(r.expression);
                    a = l(a, n, e, p);
                    return a && le(t, a.map(d));
                }
                if (n.option("yields") && Yn(r)) {
                    var o = t.clone();
                    o.expression = Ae(Wn, r, r);
                    o.expression.body = [];
                    var s = o.transform(n);
                    if (s !== o) return s.drop_side_effect_free(n, e);
                }
                var f = v(n, r);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (r._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof qt) {
                    var u = r;
                    if (u instanceof vi) u = u.fixed_value();
                    if (u instanceof jn) {
                        u.new = true;
                        var c = un(u.body, function(e) {
                            return !e.has_side_effects(n);
                        });
                        delete u.new;
                        if (c) {
                            var a = t.args.slice();
                            a.unshift(r);
                            a = l(a, n, e, p);
                            return a && le(t, a.map(d));
                        }
                        if (!u.contains_this()) return Ae(zt, t, t);
                    }
                }
                return t;
            });
            function r(e, n, t) {
                var i = [], r = [];
                var a = e.properties;
                for (var o = 0; o < a.length; o++) {
                    var s = a[o];
                    if (s.key instanceof dn) i.push(s.key);
                    if (s.static && s.value && s instanceof rt && s.value.has_side_effects(n)) {
                        if (s.value.contains_this()) return e;
                        r.push(s.value);
                    }
                }
                var f = e.extends;
                if (f) {
                    if (f instanceof vi) f = f.fixed_value();
                    f = !c(f);
                    if (!f) i.unshift(e.extends);
                }
                i = l(i, n, t);
                if (i) t = false;
                r = l(r, n, t);
                if (!i) {
                    if (!f && !r) return null;
                    i = [];
                }
                if (f) {
                    var u = Z(e, true);
                    u.properties = [];
                    if (i.length) u.properties.push(Ae(at, e, {
                        key: le(e, i),
                        value: Ae(Wn, e, {
                            argnames: [],
                            body: []
                        }).init_vars(u)
                    }));
                    i = [ u ];
                }
                if (r) i.push(Ae(zt, e, {
                    expression: Ae(Bn, e, {
                        argnames: [],
                        body: [],
                        value: le(e, r)
                    }).init_vars(e.parent_scope),
                    args: []
                }));
                return le(e, i);
            }
            e(tt, function(e, n) {
                var t = this;
                var i = t.name;
                if (i && i.fixed_value() !== t && i.definition().references.length > 0) return t;
                return r(t, e, n);
            });
            e(Rt, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie")) {
                    i = [];
                    if (n instanceof Wn) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof Wn) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? Ae(Yt, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = Ae(Yt, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : le(this, i);
            });
            e(wi, tn);
            e(nt, function(e, n) {
                return r(this, e, n);
            });
            e(Ft, function(e, n) {
                var t = this.expression;
                if (!this.optional && t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(Wn, function(e) {
                return Pe(this, e) ? null : this;
            });
            e(Nn, tn);
            e(Kt, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Pt) {
                        t.push(e);
                    } else {
                        if (e.key instanceof dn) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var i = l(t, e, n, function(e, n, t) {
                    var i = e.expression;
                    return h(i) ? e : i.drop_side_effect_free(n, t);
                });
                if (!i) return null;
                if (i === t && !un(i, function(e) {
                    return !(e instanceof Pt);
                })) return this;
                return le(this, i.map(function(e) {
                    return e instanceof Pt ? Ae(Kt, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(mi, tn);
            e(Ct, function(e, n) {
                var t = l(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r = t[i];
                if (e.option("awaits") && i > 0 && r instanceof Lt && r.expression.is_constant()) {
                    t = t.slice(0, -1);
                    i--;
                    r.expression = t[i];
                    t[i] = r;
                }
                var a, o, s;
                if (e.option("conditionals") && i > 0 && (a = t[i - 1]) instanceof Bt && a.operator == "=" && (s = a.left) instanceof vi && (o = ne(e, s.definition(), a.right, r))) {
                    a = a.clone();
                    a.right = o;
                    t = t.slice(0, -2);
                    t.push(a.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : le(this, t);
            });
            e(jt, function(e, n) {
                var t = this.expression;
                var i = this.property;
                if (t.may_throw_on_access(e)) {
                    if (!this.optional) return this;
                    if (i.has_side_effects(e)) {
                        i = i.drop_side_effect_free(e);
                        if (!i) return t.drop_side_effect_free(e, n);
                        var r = this.clone();
                        r.property = i;
                        return r;
                    }
                }
                t = t.drop_side_effect_free(e, n);
                if (!t) return i.drop_side_effect_free(e, n);
                i = i.drop_side_effect_free(e);
                if (!i) return t;
                return le(this, [ t, i ]);
            });
            e(vi, function(e) {
                return this.is_declared(e) && Ee(this, e) ? null : this;
            });
            e(yi, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var i = t.expressions;
                    if (i.length == 0) return null;
                    return le(t, i).drop_side_effect_free(e, n);
                }
                var r = t.tag;
                var a = v(e, r);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (r._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e(Nt, function(e, n) {
                var t = this.expression;
                if (Ri[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof vi && Ee(t, e)) {
                    return null;
                }
                var i = t.drop_side_effect_free(e, n);
                if (n && i && he(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(bn, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    dn.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return Ae(_n, e);
                }
                if (i !== t) {
                    return Ae(bn, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(Dn, function(e, n) {
            return n.option("loops") ? Ae(On, e, e).optimize(n) : e;
        });
        function Y(n, e, t) {
            if (!t) t = ct;
            var i = false;
            var r = new Mi(function(e) {
                if (i || e instanceof Mn) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof En) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(An, function(t, e) {
            if (!e.option("loops")) return t;
            var n = L(e, t.condition);
            if (!(n instanceof dn)) {
                if (n && !Y(t, e.parent(), pt)) return Ae(On, t, {
                    body: Ae(kn, t.body, {
                        body: [ t.body, Ae(bn, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!Y(t, e.parent())) return Ae(kn, t.body, {
                    body: [ t.body, Ae(bn, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof kn && !Y(t, e.parent(), pt)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a instanceof dt && !a.alternative && a.body instanceof lt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = Ae(Yt, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (a instanceof bn) {
                        if (o(a.body)) break;
                        t.condition = le(t, [ a.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!C(a, true)) {
                        break;
                    }
                }
                t.body = Q(t.body, e.parent());
            }
            if (t.body instanceof _n) return Ae(On, t, t).optimize(e);
            if (t.body instanceof bn) return Ae(On, t, {
                condition: le(t.condition, [ t.body.body, t.condition ]),
                body: Ae(_n, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Mi(function(e) {
                    if (n) return true;
                    if (e instanceof vi) {
                        if (!Xe(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function R(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof lt || e instanceof pt && s(e) || e instanceof st)) {
                var i = [];
                if (gn(n.init)) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(Ae(bn, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof st;
                if (n.condition && r) {
                    i.push(Ae(dt, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(Ae(bn, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                S(t, n.body, i);
                return Ae(kn, n, {
                    body: i
                });
            }
            if (e instanceof dt) {
                var a = o(e.body);
                if (a instanceof lt && !s(a)) {
                    if (n.condition) {
                        n.condition = Ae(Yt, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = z(e.alternative);
                    S(t, e.body, i);
                    return f(i);
                }
                a = o(e.alternative);
                if (a instanceof lt && !s(a)) {
                    if (n.condition) {
                        n.condition = Ae(Yt, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = z(e.body);
                    S(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function o(e) {
                return e instanceof kn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof kn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = Ae(kn, n.body, {
                        body: e
                    }).transform(t);
                }
                return R(n, t);
            }
        }
        e(On, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = L(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var i = [];
                        if (gn(e.init)) {
                            i.push(e.init);
                        } else if (e.init) {
                            i.push(Ae(bn, e.init, {
                                body: e.init
                            }));
                        }
                        i.push(Ae(bn, e.condition, {
                            body: e.condition
                        }));
                        S(n, e.body, i);
                        return Ae(kn, e, {
                            body: i
                        }).optimize(n);
                    }
                } else if (!(t instanceof dn)) {
                    e.body = Ae(kn, e.body, {
                        body: [ Ae(bn, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return R(e, n);
        });
        e($n, function(e, t) {
            if (t.option("varify") && $(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof Wt || n instanceof si) && !n.match_symbol(function(e) {
                    if (e instanceof ri) {
                        var n = e.definition();
                        return !Be(n) || W(t, n);
                    }
                }, true)) {
                    e.init = G(e.init);
                }
            }
            return e;
        });
        function B(e, n, t) {
            if (!(e instanceof Yt)) return;
            if (!(e.left instanceof xi)) {
                switch (e.operator) {
                  case "&&":
                    B(e.left, n);
                    B(e.right, n);
                    break;

                  case "||":
                    B(f(e.left), t);
                    B(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof It)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!ze(i)) return;
            var r;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = a ? t : n;
                break;

              case "!=":
                r = a ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var o = i.definition();
            var s = new Mi(function(e) {
                if (e instanceof Mn) {
                    var n = s.parent();
                    if (n instanceof zt && n.expression === e) return;
                    return true;
                }
                if (e instanceof vi && e.definition() === o) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof Yt)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function L(e, n, t) {
            if (n.truthy) return true;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function U(e, n) {
            var t;
            var i = 0;
            var r = false;
            var a = e.self();
            if (!gn(a)) while (true) {
                t = a;
                a = e.parent(i++);
                if (a instanceof Yt) {
                    var o = a.operator;
                    if (!Me[o]) return;
                    var s = a.left;
                    if (s === t) continue;
                    if (u(s)) switch (o) {
                      case "&&":
                        n[r ? "falsy" : "truthy"] = true;
                        break;

                      case "||":
                      case "??":
                        n[r ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof Rt) {
                    var f = a.condition;
                    if (f === t) continue;
                    if (u(f)) switch (t) {
                      case a.consequent:
                        n[r ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[r ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof st) {
                    break;
                } else if (a instanceof dt) {
                    break;
                } else if (a instanceof Ct) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof bn) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(i++);
                if (a instanceof kn) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof dt) {
                    if (u(a.condition)) switch (t) {
                      case a.body:
                        n[r ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[r ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function u(e) {
                if (n.equivalent_to(e)) return true;
                if (!(e instanceof It)) return false;
                if (e.operator != "!") return false;
                if (!n.equivalent_to(e.expression)) return false;
                r = true;
                return true;
            }
        }
        e(dt, function(e, f) {
            if (ve(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            if (f.option("booleans") && !e.condition.has_side_effects(f)) {
                U(f, e.condition);
            }
            if (f.option("dead_code")) {
                var n = L(f, e.condition);
                if (!n) {
                    dn.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var t = [ Ae(bn, e.condition, {
                        body: e.condition
                    }) ];
                    S(f, e.body, t);
                    if (e.alternative) t.push(e.alternative);
                    return Ae(kn, e, {
                        body: t
                    }).optimize(f);
                } else if (!(n instanceof dn)) {
                    dn.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var t = [ Ae(bn, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) S(f, e.alternative, t);
                    return Ae(kn, e, {
                        body: t
                    }).optimize(f);
                }
            }
            var i = e.condition.negate(f);
            var r = e.condition.print_to_string().length;
            var a = i.print_to_string().length;
            var o = a < r;
            if (e.alternative && o) {
                o = false;
                e.condition = i;
                var s = e.body;
                e.body = e.alternative || Ae(_n, e);
                e.alternative = s;
            }
            var t = [], u = [], c = [];
            var l = h(e.body, t, u, c);
            var p = h(e.alternative, t, u, c);
            if (l && p) {
                if (u.length > 0) t.push(Ae(Et, e, {
                    definitions: u
                }));
                if (l.length == 0) {
                    t.push(Ae(bn, e.condition, {
                        body: p.length > 0 ? Ae(Yt, e, {
                            operator: "||",
                            left: e.condition,
                            right: le(e.alternative, p)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (p.length == 0) {
                    if (r === a && !o && e.condition instanceof Yt && e.condition.operator == "||") {
                        o = true;
                    }
                    t.push(Ae(bn, e, {
                        body: Ae(Yt, e, {
                            operator: o ? "||" : "&&",
                            left: o ? i : e.condition,
                            right: le(e.body, l)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    t.push(Ae(bn, e, {
                        body: Ae(Rt, e, {
                            condition: e.condition,
                            consequent: le(e.body, l),
                            alternative: le(e.alternative, p)
                        })
                    }).optimize(f));
                }
                c.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return Ae(kn, e, {
                    body: t
                }).optimize(f);
            }
            if (ve(e.body)) {
                e = Ae(dt, e, {
                    condition: i,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof st && e.alternative instanceof st && e.body.TYPE == e.alternative.TYPE) {
                var d = Ae(e.body.CTOR, e, {
                    value: Ae(Rt, e, {
                        condition: e.condition,
                        consequent: e.body.value || Ae(Di, e.body).transform(f),
                        alternative: e.alternative.value || Ae(Di, e.alternative).transform(f)
                    })
                });
                if (d instanceof ft) {
                    d.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return d;
            }
            if (e.body instanceof dt && !e.body.alternative && !e.alternative) {
                e = Ae(dt, e, {
                    condition: Ae(Yt, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (F(e.body)) {
                if (e.alternative) {
                    var v = e.alternative;
                    e.alternative = null;
                    return Ae(kn, e, {
                        body: [ e, v ]
                    }).optimize(f);
                }
            }
            if (F(e.alternative)) {
                var t = e.body;
                e.body = e.alternative;
                e.condition = o ? i : e.condition.negate(f);
                e.alternative = null;
                return Ae(kn, e, {
                    body: [ e, t ]
                }).optimize(f);
            }
            if (f.option("typeofs")) B(e.condition, e.body, e.alternative);
            return e;
            function h(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof kn) {
                    var r = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof Jn) {
                            n.push(o);
                        } else if (o instanceof _n) {
                            continue;
                        } else if (o instanceof bn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(o.body);
                        } else if (o instanceof Et) {
                            if (!f.option("sequences") && r.length > 0) return;
                            o.remove_initializers(f, t);
                            o.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof Jn) {
                    n.push(e);
                    return [];
                }
                if (e instanceof _n) return [];
                if (e instanceof bn) return [ e.body ];
                if (e instanceof Et) {
                    var r = [];
                    e.remove_initializers(f, t);
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    if (!e.value) return;
                    r.push(Ae(Bt, e, {
                        operator: "=",
                        left: e.name.convert_symbol(vi, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(vt, function(i, t) {
            if (!t.option("switches")) return i;
            if (!t.option("dead_code")) return i;
            var e = [];
            var n;
            var r = [];
            var a;
            var o;
            var s = [];
            for (var f = 0, u = i.body.length; f < u; f++) {
                n = i.body[f];
                if (n instanceof mt) {
                    var c = e[e.length - 1];
                    if (a || w(n.body[0], t) && (!c || F(c))) {
                        k(n, c);
                        continue;
                    } else {
                        a = n;
                    }
                } else {
                    var l = n.expression;
                    var p = Ae(Yt, i, {
                        operator: "===",
                        left: i.expression,
                        right: l
                    }).evaluate(t, true);
                    if (!p) {
                        if (l.has_side_effects(t)) s.push(l);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(p instanceof dn)) {
                        if (a) {
                            var d = e.indexOf(a);
                            e.splice(d, 1);
                            k(a, e[d - 1]);
                            a = null;
                        }
                        if (l.has_side_effects(t)) {
                            o = n;
                        } else {
                            a = n = Ae(mt, n, n);
                        }
                        while (++f < u) k(i.body[f], n);
                    }
                }
                if (f + 1 >= u || F(n)) {
                    var c = e[e.length - 1];
                    var v = n.body;
                    if (F(c)) switch (c.body.length - v.length) {
                      case 1:
                        var h = c.body[c.body.length - 1];
                        if (!w(h, t)) break;
                        v = v.concat(h);

                      case 0:
                        var m = Ae(kn, c, c);
                        var _ = Ae(kn, n, {
                            body: v
                        });
                        if (m.equivalent_to(_)) c.body = [];
                    }
                }
                if (s.length) {
                    if (n instanceof mt) {
                        e.push(Ae(_t, i, {
                            expression: le(i, s),
                            body: []
                        }));
                    } else {
                        s.push(n.expression);
                        n.expression = le(i, s);
                    }
                    s = [];
                }
                e.push(n);
            }
            if (s.length && !o) {
                e.push(Ae(_t, i, {
                    expression: le(i, s),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var h = n.body[n.body.length - 1];
                if (w(h, t)) n.body.pop();
                if (n === a) {
                    if (!E(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (a) {
                    if (!E(a)) break;
                    if (e[e.length - 2] !== a) break;
                    a.body = a.body.concat(n.body);
                    n.body = [];
                } else if (!E(n)) break;
                k(n);
                if (e.pop() === a) a = null;
            }
            if (!n) {
                r.push(Ae(bn, i.expression, {
                    body: i.expression
                }));
                if (s.length) r.push(Ae(bn, i, {
                    body: le(i, s)
                }));
                return Ae(kn, i, {
                    body: r
                }).optimize(t);
            }
            if (n === a) while (n = e[e.length - 2]) {
                if (n instanceof mt) break;
                if (!E(n)) break;
                var l = n.expression;
                if (l.has_side_effects(t)) {
                    var c = e[e.length - 3];
                    if (c && !F(c)) break;
                    a.body.unshift(Ae(bn, i, {
                        body: l
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = r.concat(e[0].body);
            i.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var l = e[0].expression;
                var v = e[0].body.slice();
                if (e[0] !== a && e[0] !== o) return Ae(dt, i, {
                    condition: Ae(Yt, i, {
                        operator: "===",
                        left: i.expression,
                        right: l
                    }),
                    body: Ae(kn, i, {
                        body: v
                    }),
                    alternative: null
                }).optimize(t);
                if (l) v.unshift(Ae(bn, l, {
                    body: l
                }));
                v.unshift(Ae(bn, i.expression, {
                    body: i.expression
                }));
                return Ae(kn, i, {
                    body: v
                }).optimize(t);

              case 2:
                if (!Xe(a, e) || !x(e[1])) break;
                var v = e[0].body.slice();
                var g = v.length && w(v[v.length - 1], t);
                if (g) v.pop();
                if (!un(v, x)) break;
                var b = e[1].body.length && Ae(kn, e[1], e[1]);
                var y = Ae(dt, i, {
                    condition: Ae(Yt, i, e[0] === a ? {
                        operator: "!==",
                        left: i.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: e[0].expression
                    }),
                    body: Ae(kn, e[0], {
                        body: v
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = Ae(kn, i, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return i;
            function w(e, n) {
                return e instanceof lt && n.loopcontrol_target(e) === i;
            }
            function x(e) {
                var n = false;
                var t = new Mi(function(e) {
                    if (n || e instanceof jn || e instanceof bn) return true;
                    if (w(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !F(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    S(t, e, r);
                }
            }
        });
        e(gt, function(e, n) {
            e.body = p(e.body, n);
            if (n.option("dead_code")) {
                if (E(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof di && !Ee(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        S(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof Et)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(Ae(kn, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(Ae(kn, e.bfinally, e.bfinally).optimize(n));
                    }
                    return Ae(kn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && E(e.bfinally)) {
                    var t = Ae(kn, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return Ae(kn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function V(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof ri) t.push(Ae(St, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        xt.DEFMETHOD("remove_initializers", V(function(e, n) {
            return Ae(Di, n).optimize(e);
        }));
        kt.DEFMETHOD("remove_initializers", V(tn));
        Et.DEFMETHOD("remove_initializers", V(tn));
        wt.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var n = t.name.definition();
                var i = t.value;
                if (i) {
                    if (i instanceof Ct) i = i.clone();
                    var r = Ae(vi, t.name, t.name);
                    var a = Ae(Bt, t, {
                        operator: "=",
                        left: r,
                        right: i
                    });
                    e.push(a);
                    r.fixed = function() {
                        return a.right;
                    };
                    r.fixed.assigns = [ a ];
                    n.references.forEach(function(e) {
                        var n = e.fixed && e.fixed.assigns;
                        if (n && n[0] === t) n[0] = a;
                    });
                    n.references.push(r);
                }
                n.eliminated++;
                n.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return le(this, e);
        });
        function ee(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof li ? 3 : 2);
        }
        function W(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names()[n.name]) return true;
            }
        }
        function G(e) {
            return Ae(Et, e, {
                definitions: e.definitions.map(function(e) {
                    return Ae(St, e, {
                        name: e.name.convert_symbol(fi, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                            i.enclosed.push(t);
                            i.var_names()[t.name] = true;
                        }),
                        value: e.value
                    });
                })
            });
        }
        function J(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return ee(t) && Be(t) && !W(e, t);
        }
        function X(e, n) {
            return n.option("varify") && un(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof ri) return !J(n, e);
                }, true);
            }) ? G(e) : e;
        }
        e(xt, X);
        e(kt, X);
        function Ne(e, n) {
            if (!n.option("optional_chains")) return;
            if (!e.optional) return;
            var t = e.expression;
            var i = L(n, t, true);
            if (i == null) return Ae(It, e, {
                operator: "void",
                expression: t
            }).optimize(n);
            if (!(i instanceof dn)) e.optional = false;
        }
        function Ie(e, n) {
            var t = e.expression;
            if (!(t instanceof Ct)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return le(e, i);
        }
        function He(e, t, n) {
            var i = e.expression;
            var r = i instanceof vi ? i.fixed_value() : i;
            if (!(r instanceof jn)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (n && n.indexOf(r) < 0) return;
            var a = e.args;
            if (!un(a, function(e) {
                return !(e instanceof Pt);
            })) return;
            var o = r.argnames;
            var s = r === i && !r.name;
            if (r.rest) {
                if (!(s && t.option("rests"))) return;
                var f = o.length;
                a = a.slice(0, f);
                while (a.length < f) a.push(Ae(Di, e).optimize(t));
                a.push(Ae(Vt, e, {
                    elements: e.args.slice(f)
                }));
                o = o.concat(r.rest);
                r.rest = null;
            } else {
                a = a.slice();
                o = o.slice();
            }
            var u = 0, c = 0;
            var l = s && t.option("default_values");
            var p = s && t.drop_fargs(r, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof Gt) {
                    return e.elements.length == 0 && !e.rest && n instanceof Vt;
                }
                if (e instanceof Xt) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.__unused;
            } : Ze;
            var d = [];
            for (var v = 0; v < a.length; v++) {
                var h = o[v];
                if (l && h instanceof $t && a[v].is_defined(t)) {
                    o[v] = h = h.name;
                }
                if (!h || "__unused" in h) {
                    var m = a[v].drop_side_effect_free(t);
                    if (p(h)) {
                        if (h) o.splice(v, 1);
                        a.splice(v, 1);
                        if (m) d.push(m);
                        v--;
                        continue;
                    } else if (m) {
                        d.push(m);
                        a[u++] = le(e, d);
                        d = [];
                    } else if (h) {
                        if (d.length) {
                            a[u++] = le(e, d);
                            d = [];
                        } else {
                            a[u++] = Ae(ki, a[v], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (p(h, a[v])) {
                    var m = a[v].drop_side_effect_free(t);
                    o.splice(v, 1);
                    a.splice(v, 1);
                    if (m) d.push(m);
                    v--;
                    continue;
                } else {
                    d.push(a[v]);
                    a[u++] = le(e, d);
                    d = [];
                }
                c = u;
            }
            for (;v < o.length; v++) {
                if (p(o[v])) o.splice(v--, 1);
            }
            r.argnames = o;
            a.length = c;
            e.args = a;
            if (!d.length) return;
            var _ = le(e, d);
            a.push(a.length < o.length ? Ae(It, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        e(zt, function(l, u) {
            var o = l.expression;
            var e = Ne(l, u);
            if (e) return e;
            if (u.option("sequences")) {
                if (o instanceof Mt) {
                    var n = Ie(o, u);
                    if (n !== o) {
                        var t = l.clone();
                        t.expression = n.expressions.pop();
                        n.expressions.push(t);
                        return n.optimize(u);
                    }
                } else if (!de(u, o.tail_node())) {
                    var n = Ie(l, u);
                    if (n !== l) return n.optimize(u);
                }
            }
            if (u.option("unused")) He(l, u);
            if (u.option("unsafe")) {
                if (ze(o)) switch (o.name) {
                  case "Array":
                    if (l.args.length == 1) {
                        var i = l.args[0];
                        if (i instanceof ki) try {
                            var r = i.value;
                            if (r > 6) break;
                            var a = Array(r);
                            for (var s = 0; s < r; s++) a[s] = Ae(Oi, l);
                            return Ae(Vt, l, {
                                elements: a
                            });
                        } catch (e) {
                            dn.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: r,
                                file: l.start.file,
                                line: l.start.line,
                                col: l.start.col
                            });
                            break;
                        }
                        if (!i.is_boolean(u) && !i.is_string(u)) break;
                    }
                    return Ae(Vt, l, {
                        elements: l.args
                    });

                  case "Object":
                    if (l.args.length == 0) return Ae(Kt, l, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (l.args.length == 0) return Ae(xi, l, {
                        value: ""
                    });
                    if (l.args.length == 1) return Ae(Yt, l, {
                        operator: "+",
                        left: Ae(xi, l, {
                            value: ""
                        }),
                        right: l.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (l.args.length == 0) return Ae(ki, l, {
                        value: 0
                    });
                    if (l.args.length == 1) return Ae(It, l, {
                        operator: "+",
                        expression: Ae(Yt, l, {
                            operator: "+",
                            left: Ae(xi, l, {
                                value: ""
                            }),
                            right: l.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (l.args.length == 0) return Ae(qi, l).optimize(u);
                    if (l.args.length == 1) return Ae(It, l, {
                        operator: "!",
                        expression: Ae(It, l, {
                            operator: "!",
                            expression: l.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var f = [];
                    if (un(l.args, function(e) {
                        var n = e.evaluate(u);
                        f.unshift(n);
                        return e !== n;
                    })) try {
                        return ge(u, l, Ae(Si, l, {
                            value: RegExp.apply(RegExp, f)
                        }));
                    } catch (e) {
                        dn.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: l,
                            file: l.start.file,
                            line: l.start.line,
                            col: l.start.col
                        });
                    }
                    break;
                } else if (o instanceof Ft) switch (o.property) {
                  case "toString":
                    var c = o.expression;
                    if (l.args.length == 0 && !(c.may_throw_on_access(u) || c instanceof _i)) {
                        return Ae(Yt, l, {
                            operator: "+",
                            left: Ae(xi, l, {
                                value: ""
                            }),
                            right: c
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof Vt && l.args.length < 2) e: {
                        var p = l.args[0];
                        if (o.expression.elements.length == 0 && !(p instanceof Pt)) {
                            return p ? le(l, [ p, Ae(xi, l, {
                                value: ""
                            }) ]).optimize(u) : Ae(xi, l, {
                                value: ""
                            });
                        }
                        if (p) {
                            p = p.evaluate(u);
                            if (p instanceof dn) break e;
                        }
                        var a = [];
                        var d = [];
                        for (var s = 0; s < o.expression.elements.length; s++) {
                            var v = o.expression.elements[s];
                            var h = v.evaluate(u);
                            if (h !== v) {
                                d.push(h);
                            } else if (v instanceof Pt) {
                                break e;
                            } else {
                                if (d.length > 0) {
                                    a.push(Ae(xi, l, {
                                        value: d.join(p)
                                    }));
                                    d.length = 0;
                                }
                                a.push(v);
                            }
                        }
                        if (d.length > 0) a.push(Ae(xi, l, {
                            value: d.join(p)
                        }));
                        if (a.length == 1) {
                            if (a[0].is_string(u)) return a[0];
                            return Ae(Yt, a[0], {
                                operator: "+",
                                left: Ae(xi, l, {
                                    value: ""
                                }),
                                right: a[0]
                            });
                        }
                        if (p == "") {
                            var i;
                            if (a[0].is_string(u) || a[1].is_string(u)) {
                                i = a.shift();
                            } else {
                                i = Ae(xi, l, {
                                    value: ""
                                });
                            }
                            return a.reduce(function(e, n) {
                                return Ae(Yt, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, i).optimize(u);
                        }
                        var m = l.clone();
                        m.expression = m.expression.clone();
                        m.expression.expression = m.expression.expression.clone();
                        m.expression.expression.elements = a;
                        return ge(u, l, m);
                    }
                    break;

                  case "charAt":
                    if (l.args.length < 2) {
                        var m = Ae(Yt, l, {
                            operator: "||",
                            left: Ae(jt, l, {
                                expression: o.expression,
                                property: l.args.length ? Ae(Yt, l.args[0], {
                                    operator: "|",
                                    left: Ae(ki, l, {
                                        value: 0
                                    }),
                                    right: l.args[0]
                                }) : Ae(ki, l, {
                                    value: 0
                                })
                            }).optimize(u),
                            right: Ae(xi, l, {
                                value: ""
                            })
                        });
                        m.is_string = en;
                        return m.optimize(u);
                    }
                    break;

                  case "apply":
                    if (l.args.length == 2 && l.args[1] instanceof Vt) {
                        var _ = l.args[1].elements.slice();
                        _.unshift(l.args[0]);
                        return Ae(zt, l, {
                            expression: Ae(Ft, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: _
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var g = o.expression;
                    if (g instanceof vi) {
                        g = g.fixed_value();
                    }
                    if (g instanceof jn && !g.contains_this()) {
                        return (l.args.length ? le(this, [ l.args[0], Ae(zt, l, {
                            expression: o.expression,
                            args: l.args.slice(1)
                        }) ]) : Ae(zt, l, {
                            expression: o.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && ze(o) && o.name == "Function") {
                if (l.args.length == 0) return Ae(Wn, l, {
                    argnames: [],
                    body: []
                }).init_vars(o.scope);
                if (un(l.args, function(e) {
                    return e instanceof xi;
                })) {
                    try {
                        var b = "n(function(" + l.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + l.args[l.args.length - 1].value + "})";
                        var y = Yi(b);
                        var w = {
                            ie: u.option("ie")
                        };
                        y.figure_out_scope(w);
                        var x = new Li(u.options);
                        y = y.transform(x);
                        y.figure_out_scope(w);
                        y.compute_char_frequency(w);
                        y.mangle_names(w);
                        var k;
                        y.walk(new Mi(function(e) {
                            if (k) return true;
                            if (e instanceof jn) {
                                k = e;
                                return true;
                            }
                        }));
                        var b = Ui();
                        kn.prototype._codegen.call(k, b);
                        l.args = [ Ae(xi, l, {
                            value: k.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), Ae(xi, l.args[l.args.length - 1], {
                            value: b.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return l;
                    } catch (e) {
                        if (e instanceof Ni) {
                            dn.warn("Error parsing code passed to new Function [{file}:{line},{col}]", l.args[l.args.length - 1].start);
                            dn.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var E = o instanceof vi ? o.fixed_value() : o;
            var S = u.parent(), T = u.self();
            var A = E instanceof jn && (!Hn(E) || u.option("awaits") && S instanceof Lt) && (!Yn(E) || u.option("yields") && T instanceof Ut && T.nested);
            var D = A && E.first_statement();
            var O = 0, $ = false;
            var z = !un(l.args, function(e) {
                return !(e instanceof Pt);
            });
            var q = A && un(E.argnames, function(e, n) {
                if (O == 1 && l.args[n] instanceof Pt) O = 2;
                if (e instanceof $t) {
                    if (!O) O = 1;
                    var t = O == 1 && l.args[n];
                    if (t && !Ce(t)) O = 2;
                    if (L(e.value)) return false;
                    e = e.name;
                }
                if (e instanceof Wt) {
                    $ = true;
                    if (L(e)) return false;
                }
                return true;
            }) && !(E.rest instanceof Wt && L(E.rest));
            var C = q && u.option("inline") && !l.is_expr_pure(u);
            if (C && D instanceof ft) {
                var h = D.value;
                if (o === E && !E.name && (!h || h.is_constant_expression()) && G(E)) {
                    return le(l, V(h)).optimize(u);
                }
            }
            if (A) {
                var M, h, F = false;
                if (C && !E.uses_arguments && !E.pinned() && !(E.name && E instanceof Nn) && (o === E || !Re(u, M = o.definition(), E) && E.is_constant_expression(ue(u))) && !z && (h = X(D)) && !E.contains_this()) {
                    var j = o === E || M.single_use && M.references.length - M.replaced == 1;
                    if (Q()) {
                        var _ = l.args.slice();
                        var P = [];
                        _.push(h.clone(true).transform(new Fi(function(e) {
                            if (e instanceof vi) {
                                var n = e.definition();
                                if (E.variables.get(e.name) !== n) {
                                    P.push(e);
                                    return e;
                                }
                                var t = K(n);
                                var i = _[t];
                                if (!i) return Ae(Di, l);
                                _[t] = null;
                                var r = this.parent();
                                return r ? De(u, r, e, i) : i;
                            }
                        })));
                        var N = E.inlined;
                        if (o !== E) E.inlined = true;
                        var m = le(l, _.filter(function(e) {
                            return e;
                        })).optimize(u);
                        E.inlined = N;
                        m = De(u, S, T, m);
                        if (j || _e(m, l) === m) {
                            P.forEach(function(e) {
                                e.scope = o === E ? E.parent_scope : o.scope;
                                e.reference();
                                var n = e.definition();
                                if (j) n.replaced++;
                                n.single_use = false;
                            });
                            return m;
                        } else if (!m.has_side_effects(u)) {
                            l.drop_side_effect_free = tn;
                        }
                    }
                    var I, H, Y, R;
                    if (j && te()) {
                        E._squeezed = true;
                        if (o !== E) E.parent_scope = o.scope;
                        var m = le(l, fe()).optimize(u);
                        return De(u, S, T, m);
                    }
                }
                if (u.option("side_effects") && q && un(E.body, ve) && (E === o ? Pe(E, u) : !O && !$ && !E.rest) && !(In(E) && E.value) && G(E)) {
                    return le(l, V()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (o instanceof Mt) {
                    var B = o.expression;
                    while (B.expression) {
                        B = B.expression;
                    }
                    if (ze(B) && B.name == "console") {
                        return Ae(Di, l).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && S instanceof bn && he(T)) {
                return l.negate(u, true);
            }
            return be(u, l);
            function L(e) {
                var n = false;
                e.walk(new Mi(function(e) {
                    if (n) return true;
                    if (e instanceof vi && E.variables.get(e.name) === e.definition()) {
                        return n = true;
                    }
                }));
                return n;
            }
            function U(e) {
                return Ae(Ft, e, {
                    expression: Ae(Vt, e, {
                        elements: []
                    }),
                    property: "e"
                });
            }
            function V(e) {
                var n = l.args.slice();
                var t = O > 1 || $ || E.rest;
                if (t || z) n = [ Ae(Vt, l, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Fi(function(i, e) {
                        if (i instanceof $t) return Ae($t, i, {
                            name: i.name.transform(o) || U(i),
                            value: i.value
                        });
                        if (i instanceof Gt) {
                            var t = [];
                            i.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            ye(i, t);
                            return Ae(Gt, i, {
                                elements: t
                            });
                        }
                        if (i instanceof Xt) {
                            var r = [], a = [];
                            i.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof dn)) n = pe(n, e);
                                        a.push(n);
                                        n = le(i, a);
                                        a = [];
                                    }
                                    r.push(Ae(Jt, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof dn) {
                                    a.push(n);
                                }
                            });
                            if (a.length) r.push(Ae(Jt, i, {
                                key: le(i, a),
                                value: U(i)
                            }));
                            return Ae(Xt, i, {
                                properties: r
                            });
                        }
                        if (i instanceof ui) return null;
                    });
                    var i = [];
                    E.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) i[n] = e;
                    });
                    var r = E.rest && E.rest.transform(o);
                    if (r) i.length = E.argnames.length;
                    ye(E, i);
                    n[0] = Ae(Bt, l, {
                        operator: "=",
                        left: Ae(Gt, E, {
                            elements: i,
                            rest: r
                        }),
                        right: n[0]
                    });
                } else E.argnames.forEach(function(e) {
                    if (e instanceof $t) n.push(e.value);
                });
                n.push(e || Ae(Di, l));
                return n;
            }
            function W() {
                var e = [];
                var n = R || u.find_parent(Mn);
                if (Hn(n)) e.push("await");
                if (Yn(n)) e.push("yield");
                return e.length && fn(e);
            }
            function G(e) {
                var t = W();
                if (!t) return true;
                var i = true;
                var r = new Mi(function(e) {
                    if (!i) return true;
                    if (e instanceof Mn) {
                        if (e === E) return;
                        if (In(e)) {
                            for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(r);
                        } else if (e instanceof Jn && t[e.name.name]) {
                            i = false;
                        }
                        return true;
                    }
                    if (e instanceof ii && t[e.name] && e !== E.name) i = false;
                });
                e.walk(r);
                return i;
            }
            function J(e) {
                if (!e) return Ae(Di, l);
                if (e instanceof ft) return e.value || Ae(Di, l);
                if (e instanceof bn) return Ae(It, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function X(e) {
                var n = E.body.length;
                if (n < 2) {
                    e = J(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = E.body[t];
                    if (i instanceof Et) {
                        var r = F || !me(i);
                        if (r) {
                            F = true;
                            if (e) return false;
                        }
                    } else if (i instanceof Xn || i instanceof Qn || i instanceof _n) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return J(e);
            }
            function K(e) {
                for (var n = E.argnames.length; --n >= 0; ) {
                    if (E.argnames[n].definition() === e) return n;
                }
            }
            function Q() {
                if (O || $ || F || E.rest) return;
                if (u.option("inline") < 2 && E.argnames.length) return;
                if (!E.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof ui;
                })) return;
                var r = false;
                var a = W();
                var o;
                var s = [];
                var f = false;
                h.walk(new Mi(function(e, n) {
                    if (r) return true;
                    if (e instanceof Yt && Me[e.operator] || e instanceof Rt) {
                        s = null;
                        return;
                    }
                    if (e instanceof Mn) return r = true;
                    if (a && e instanceof ii && a[e.name]) return r = true;
                    if (e instanceof vi) {
                        var t = e.definition();
                        if (E.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof Jn) return r = true;
                        if (Bi(e, this.parent())) return r = true;
                        var i = K(t);
                        if (!(o < i)) o = i;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(E.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        f = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = l.args.length;
                if (s && E.argnames.length >= e) {
                    e = E.argnames.length;
                    while (e-- > o && E.argnames[e] === s.pop());
                    e++;
                }
                var n = f && !s && u.find_parent(Mn);
                return e <= o || un(l.args.slice(o, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function Z(e, n) {
                return e[n] || ce[n] || R.var_names()[n];
            }
            function ee(n, t, i) {
                var r = false;
                E.each_argname(function(e) {
                    if (r) return;
                    if (e.__unused) return;
                    if (!i || Z(n, e.name)) return r = true;
                    t[e.name] = true;
                    if (Y) Y.push(e.definition());
                });
                return !r;
            }
            function ne(n, e, t) {
                for (var i = 0; i < E.body.length; i++) {
                    var r = E.body[i];
                    if (r instanceof Jn) {
                        if (!t || Z(e, r.name.name)) return false;
                        if (!un(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        if (Y) Y.push(r.name.definition());
                        continue;
                    }
                    if (!(r instanceof Et)) continue;
                    if (!t) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var o = r.definitions[a].name;
                        if (Z(n, o.name)) return false;
                        if (Y) Y.push(o.definition());
                    }
                }
                return true;
            }
            function te() {
                var n = Object.create(null);
                var e = 0, t;
                R = T;
                do {
                    if (R.variables) R.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    t = R;
                    R = u.parent(e++);
                    if (R instanceof Tn) {
                        Y = [];
                    } else if (R instanceof On) {
                        if (R.init === t) continue;
                        Y = [];
                    } else if (R instanceof $n) {
                        if (R.init === t) continue;
                        if (R.object === t) continue;
                        Y = [];
                    } else if (R instanceof vi) {
                        if (R.fixed_value() instanceof Mn) return false;
                    }
                } while (!(R instanceof Mn));
                H = R.body.indexOf(t) + 1;
                if (!H) return false;
                if (!G(E)) return false;
                var i = o !== E || E.parent_scope.resolve() === R;
                if (R instanceof Fn) {
                    if (u.toplevel.vars) {
                        n["arguments"] = true;
                    } else {
                        i = false;
                    }
                }
                var r = u.option("inline");
                I = Object.create(n);
                if (!ee(n, I, r >= 2 && i)) return false;
                var a = Object.create(I);
                if (!ne(n, a, r >= 3 && i)) return false;
                return !Y || Y.length == 0 || !Ue(E, Y);
            }
            function ie(e, n, t, i) {
                var r = t.definition();
                if (!R.var_names()[t.name]) {
                    R.var_names()[t.name] = true;
                    e.push(Ae(St, t, {
                        name: t,
                        value: null
                    }));
                }
                R.variables.set(t.name, r);
                R.enclosed.push(r);
                if (!i) return;
                var a = Ae(vi, t, t);
                r.references.push(a);
                n.push(Ae(Bt, l, {
                    operator: "=",
                    left: a,
                    right: i
                }));
            }
            function re(e, n) {
                var t = E.argnames.length;
                for (var i = l.args.length; --i >= t; ) {
                    n.push(l.args[i]);
                }
                var r = [];
                for (i = t; --i >= 0; ) {
                    var a = E.argnames[i];
                    var o;
                    if (a instanceof $t) {
                        r.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = l.args[i];
                    if (o.__unused || R.var_names()[o.name]) {
                        if (s) n.push(s);
                    } else {
                        var f = Ae(fi, o, o);
                        o.definition().orig.push(f);
                        if ("__unused" in o) {
                            ie(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && Y && a === o) s = Ae(Di, l);
                            ie(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (i = r.length; --i >= 0; ) {
                    var u = r[i];
                    if ("__unused" in u.name) {
                        n.push(u.value);
                    } else {
                        var c = Ae(vi, u.name, u.name);
                        u.name.definition().references.push(c);
                        n.push(Ae(Bt, u, {
                            operator: "=",
                            left: c,
                            right: u.value
                        }));
                    }
                }
            }
            function ae(r, a) {
                a.push(Ae(Bt, l, {
                    operator: "=",
                    left: Ae(Gt, l, {
                        elements: E.argnames.map(function(e) {
                            return e.convert_symbol(vi, n);
                        }),
                        rest: E.rest && E.rest.convert_symbol(vi, n)
                    }),
                    right: Ae(Vt, l, {
                        elements: l.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = n.definition();
                    t.references.push(e);
                    var i = Ae(fi, n, n);
                    t.orig.push(i);
                    ie(r, a, i);
                }
            }
            function oe(e) {
                var n = e.definition().redefined();
                if (n) {
                    e = e.clone();
                    e.thedef = n;
                }
                return e;
            }
            function se(e, n) {
                var t = [ H, 0 ];
                var i = [], r = [], a = [];
                for (var o = 0; o < E.body.length; o++) {
                    var s = E.body[o];
                    if (s instanceof Jn) {
                        if (Y) {
                            var f = Ae(fi, s.name, oe(s.name));
                            f.definition().orig.push(f);
                            ie(e, n, f, je(s, true));
                        } else {
                            var u = s.name.definition();
                            R.functions.set(u.name, u);
                            R.variables.set(u.name, u);
                            R.enclosed.push(u);
                            R.var_names()[u.name] = true;
                            t.push(s);
                        }
                        continue;
                    }
                    if (!(s instanceof Et)) continue;
                    for (var c = 0; c < s.definitions.length; c++) {
                        var l = s.definitions[c];
                        var f = oe(l.name);
                        ie(i, r, f, l.value);
                        if (Y && !ln(I, f.name)) {
                            var u = E.variables.get(f.name);
                            var p = Ae(vi, f, f);
                            u.references.push(p);
                            a.push(Ae(Bt, l, {
                                operator: "=",
                                left: p,
                                right: Ae(Di, f)
                            }));
                        }
                    }
                }
                [].push.apply(e, i);
                [].push.apply(n, a);
                [].push.apply(n, r);
                return t;
            }
            function fe() {
                var e = [];
                var n = [];
                if (O > 1 || $ || E.rest) {
                    ae(e, n);
                } else {
                    re(e, n);
                }
                var t = se(e, n);
                n.push(h);
                if (e.length) t.push(Ae(Et, E, {
                    definitions: e
                }));
                [].splice.apply(R.body, t);
                E.enclosed.forEach(function(e) {
                    if (R.var_names()[e.name]) return;
                    R.enclosed.push(e);
                    R.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(qt, function(e, n) {
            if (n.option("sequences")) {
                var t = Ie(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unused")) He(e, n);
            if (n.option("unsafe")) {
                var i = e.expression;
                if (ze(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return Ae(zt, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function ne(t, i, e, n) {
            if (!(n instanceof Yt)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof Bt)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof vi)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? Ae(Rt, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : Ae(Rt, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Mi(function(e) {
                    if (n) return true;
                    if (e instanceof vi && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(Ct, function(e, a) {
            var o = n();
            var s = o.length - 1;
            i();
            t();
            if (s == 0) {
                e = De(a, a.parent(), a.self(), o[0]);
                if (!(e instanceof Ct)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var i = pn(a);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(a, i);
                    if (e) {
                        b(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && Ce(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = Ae(It, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof Bt && e.operator == "=" && e.left instanceof vi && e.left.definition();
            }
            function i() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var i = o[e];
                    if (a.option("conditionals")) {
                        var r = ne(a, t, n.right, i);
                        if (r) {
                            n.right = r;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(i) === t && i.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(Ht, function(e, n) {
            if (n.option("sequences")) {
                var t = Ie(e, n);
                if (t !== e) return t.optimize(n);
            }
            return be(n, e);
        });
        var te = fn("+ -");
        var ie = fn("* / %");
        e(It, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !o(i)) {
                return le(e, [ i, Ae(Ci, e) ]).optimize(n);
            }
            if (n.option("sequences") && s()) {
                var r = Ie(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return Ae(Di, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return le(e, [ i, Ae(qi, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof It && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof Yt) {
                        e = ge(n, e, i.negate(n, pn(n)));
                    }
                    break;

                  case "typeof":
                    dn.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    var a = [ Ae(Ci, e) ];
                    if (!(i instanceof vi && Ee(i, n))) a.unshift(i);
                    return le(e, a).optimize(n);
                }
            }
            if (t == "-" && i instanceof $i) i = i.transform(n);
            if (n.option("evaluate") && i instanceof Yt && te[t] && ie[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return Ae(Yt, e, {
                    operator: i.operator,
                    left: Ae(It, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof ki || i instanceof $i) ? e : be(n, e);
            function o(e) {
                return e instanceof $i || e instanceof Ai || e instanceof bi || e instanceof Mt || e instanceof vi || e instanceof Di;
            }
            function s() {
                switch (t) {
                  case "delete":
                    return !o(i.tail_node());

                  case "typeof":
                    return !ze(i.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(Lt, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = Ie(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var i = e.expression;
                if (i instanceof Lt) return i.optimize(n);
                if (i instanceof It) {
                    if (i.expression instanceof Lt) return i.optimize(n);
                    if (i.operator == "void") return Ae(It, e, {
                        operator: "void",
                        expression: Ae(Lt, e, {
                            expression: i.expression
                        })
                    }).optimize(n);
                }
                for (var r = 0, a = e, o; o = n.parent(r++); a = o) {
                    if (In(o)) {
                        if (o.value === a) return i.optimize(n);
                    } else if (o instanceof ft) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(r++);
                            if (o instanceof gt && o.bfinally && o.bfinally !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof Mn));
                        if (s) return i.optimize(n);
                    } else if (o instanceof Ct) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(Ut, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = Ie(e, n);
                if (t !== e) return t.optimize(n);
            }
            var i = e.expression;
            if (e.nested && i.TYPE == "Call") {
                var r = i.clone().optimize(n);
                if (r.TYPE != "Call") return r;
            }
            return e;
        });
        Yt.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Mt) {
                if (!(this.left.expression instanceof Ct)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return le(this, n);
            }
            if (this.left instanceof Ct) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return le(this, n);
            }
            if (this.right instanceof Ct) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof vi;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var a = 0; a < r; a++) {
                    if (!i && n[a].has_side_effects(e)) break;
                }
                if (a == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return le(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = le(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return le(this, n);
                }
            }
            return this;
        });
        var re = fn("indexOf lastIndexOf");
        var ae = fn("== === != !== * & | ^");
        function Ye(e) {
            if (e instanceof Bt) return e.operator == "=" && Ye(e.right);
            if (e instanceof Ct) return Ye(e.tail_node());
            if (e instanceof vi) return Ye(e.fixed_value());
            return e instanceof Vt || e instanceof et || e instanceof jn || e instanceof qt || e instanceof Kt;
        }
        function oe(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof Bt) return n.operator != "=" || oe(e, n.right);
            if (n instanceof Yt) {
                return !Me[n.operator] || oe(e, n.left) && oe(e, n.right);
            }
            if (n instanceof Rt) {
                return oe(e, n.consequent) && oe(e, n.alternative);
            }
            if (n instanceof Ct) return oe(e, n.tail_node());
            if (n instanceof vi) {
                var t = n.fixed_value();
                return t && oe(e, t);
            }
            if (n instanceof yi) return !n.tag || fe(e, n.tag);
            if (n instanceof Nt) return true;
        }
        function se(e, n) {
            if (n instanceof Ft) return se(e, n.expression);
            if (n instanceof jt) {
                return se(e, n.expression) && se(e, n.property);
            }
            if (n instanceof ii) return true;
            return !n.has_side_effects(e);
        }
        e(Yt, function(i, o) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(o) && !i.right.has_side_effects(o);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = Ae(Yt, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(o);
            }
            if (ae[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof Yt && Hi[i.left.operator] >= Hi[i.operator])) {
                e();
            }
            if (o.option("sequences")) {
                var r = i.lift_sequences(o);
                if (r !== i) return r.optimize(o);
            }
            if (o.option("assignments") && Me[i.operator]) {
                var a = i.right;
                if (i.left instanceof vi && a instanceof Bt && a.operator == "=" && i.left.equivalent_to(a.left)) {
                    i.right = a.right;
                    a.right = i;
                    return a;
                }
            }
            if (o.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if (Ce(i.left, o) && i.right.is_defined(o)) {
                    dn.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return le(i, [ i.right, Ae(i.operator == "===" ? qi : Ci, i) ]).optimize(o);
                }
                var s = true;
                if (i.left.is_string(o) && i.right.is_string(o) || i.left.is_number(o) && i.right.is_number(o) || i.left.is_boolean(o) && i.right.is_boolean(o) || se(o, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && Ce(i.left, o)) {
                    i.left = Ae(Ti, i.left);
                } else if (o.option("typeofs") && i.left instanceof xi && i.left.value == "undefined" && i.right instanceof It && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof vi ? f.is_declared(o) : !(f instanceof Mt && o.option("ie"))) {
                        i.right = f;
                        i.left = Ae(Di, i.left).optimize(o);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof vi && i.right instanceof vi && i.left.definition() === i.right.definition() && Ye(i.left)) {
                    return Ae(i.operator[0] == "=" ? Ci : qi, i).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof Yt && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof Yt && u.operator == i.right.operator && (Ce(u.left, o) && i.right.left instanceof Ti || u.left instanceof Ti && Ce(i.right.left, o)) && !u.right.has_side_effects(o) && u.right.equivalent_to(i.right.right)) {
                    var c = Ae(Yt, i, {
                        operator: u.operator.slice(0, -1),
                        left: Ae(Ti, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = Ae(Yt, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = false;
            var p = o.parent();
            if (o.option("booleans")) {
                var u = i.left;
                if (Me[i.operator] && !u.has_side_effects(o)) {
                    if (u.equivalent_to(i.right)) {
                        return De(o, p, o.self(), u).optimize(o);
                    }
                    U(o, u);
                }
                l = o.in_boolean_context();
            }
            if (l) switch (i.operator) {
              case "+":
                var d = i.left.evaluate(o);
                var v = i.right.evaluate(o);
                if (d && typeof d == "string") {
                    dn.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return le(i, [ i.right, Ae(Ci, i) ]).optimize(o);
                }
                if (v && typeof v == "string") {
                    dn.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return le(i, [ i.left, Ae(Ci, i) ]).optimize(o);
                }
                break;

              case "==":
                if (i.left instanceof xi && i.left.value == "" && i.right.is_string(o)) {
                    return Ae(It, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (i.left instanceof xi && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                break;
            }
            if (o.option("comparisons") && i.is_boolean(o)) {
                if (!(p instanceof Yt) || p instanceof Bt) {
                    var h = ge(o, i, Ae(It, i, {
                        operator: "!",
                        expression: i.negate(o, pn(o))
                    }));
                    if (h !== i) return h;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (o.option("conditionals") && Me[i.operator] && i.right instanceof Yt && i.operator == i.right.operator) {
                n();
            }
            if (o.option("strings") && i.operator == "+") {
                if (i.right instanceof xi && i.right.value == "" && i.left.is_string(o)) {
                    return i.left.optimize(o);
                }
                if (i.left instanceof xi && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                if (i.left instanceof Yt && i.left.operator == "+" && i.left.left instanceof xi && i.left.left.value == "" && i.right.is_string(o)) {
                    i.left = i.left.right;
                    return i.optimize(o);
                }
                if (i.right instanceof Yt && i.operator == i.right.operator && (i.left.is_string(o) && i.right.is_string(o) || i.right.left.is_string(o) && (i.left.is_constant() || !i.right.right.has_side_effects(o)))) {
                    n();
                }
            }
            if (o.option("evaluate")) {
                var m = true;
                switch (i.operator) {
                  case "&&":
                    var d = L(o, i.left);
                    if (!d) {
                        dn.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return De(o, p, o.self(), i.left).optimize(o);
                    } else if (!(d instanceof dn)) {
                        dn.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return le(i, [ i.left, i.right ]).optimize(o);
                    }
                    var v = i.right.evaluate(o);
                    if (!v) {
                        if (l) {
                            dn.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return le(i, [ i.left, Ae(qi, i) ]).optimize(o);
                        } else i.falsy = true;
                    } else if (!(v instanceof dn)) {
                        if (l || p.operator == "&&" && p.left === o.self()) {
                            dn.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    }
                    if (i.left.operator == "||") {
                        var _ = L(o, i.left.right);
                        if (!_) return Ae(Rt, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(o);
                    }
                    break;

                  case "??":
                    var g = true;

                  case "||":
                    var d = L(o, i.left, g);
                    if (g ? d == null : !d) {
                        dn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: i.operator,
                            value: g ? "nulish" : "false",
                            file: i.start.file,
                            line: i.start.line,
                            col: i.start.col
                        });
                        return le(i, [ i.left, i.right ]).optimize(o);
                    } else if (!(d instanceof dn)) {
                        dn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: i.operator,
                            value: g ? "defined" : "true",
                            file: i.start.file,
                            line: i.start.line,
                            col: i.start.col
                        });
                        return De(o, p, o.self(), i.left).optimize(o);
                    }
                    var v = i.right.evaluate(o);
                    if (!v) {
                        if (l || p.operator == "||" && p.left === o.self()) {
                            dn.warn("Dropping side-effect-free {operator} [{file}:{line},{col}]", {
                                operator: i.operator,
                                file: i.start.file,
                                line: i.start.line,
                                col: i.start.col
                            });
                            return i.left.optimize(o);
                        }
                    } else if (!g && !(v instanceof dn)) {
                        if (l) {
                            dn.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return le(i, [ i.left, Ae(Ci, i) ]).optimize(o);
                        } else i.truthy = true;
                    }
                    if (!g && i.left.operator == "&&") {
                        var _ = L(o, i.left.right);
                        if (_ && !(_ instanceof dn)) return Ae(Rt, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (i.left instanceof wi && i.right instanceof Yt && i.right.operator == "+" && i.right.left instanceof wi && i.right.is_string(o)) {
                        i = Ae(Yt, i, {
                            operator: "+",
                            left: Ae(xi, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof wi && i.left instanceof Yt && i.left.operator == "+" && i.left.right instanceof wi && i.left.is_string(o)) {
                        i = Ae(Yt, i, {
                            operator: "+",
                            left: i.left.left,
                            right: Ae(xi, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof It && i.right.operator == "-" && i.left.is_number(o)) {
                        i = Ae(Yt, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof It && i.left.operator == "-" && t() && i.right.is_number(o)) {
                        i = Ae(Yt, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && i.left instanceof Yt && Hi[i.left.operator] == Hi[i.operator] && i.right.is_constant() && (i.right.is_boolean(o) || i.right.is_number(o)) && i.left.is_number(o) && !i.left.right.is_constant() && (i.left.left.is_boolean(o) || i.left.left.is_number(o))) {
                        i = Ae(Yt, i, {
                            operator: i.left.operator,
                            left: Ae(Yt, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof It && i.right.operator == "-" && i.left.is_number(o) && i.right.expression.is_number(o)) {
                        i = Ae(Yt, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    m = o.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof It && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(o) || i.left.is_number(o)) && (i.right.is_boolean(o) || i.right.is_number(o)) && t() && !(i.left instanceof Yt && i.left.operator != i.operator && Hi[i.left.operator] >= Hi[i.operator])) {
                        var b = Ae(Yt, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof wi && !(i.left instanceof wi)) {
                            i = ge(o, b, i);
                        } else {
                            i = ge(o, i, b);
                        }
                    }
                    if (!m || !i.is_number(o)) break;
                    if (i.right instanceof Yt && i.right.operator != "%" && Hi[i.right.operator] == Hi[i.operator] && i.right.is_number(o) && (i.operator != "+" || i.right.left.is_boolean(o) || i.right.left.is_number(o)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(o)) && !S(i.right.right)) {
                        i = Ae(Yt, i, {
                            operator: T(i.operator, i.right.operator),
                            left: Ae(Yt, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(o) && !i.right.is_number(o)) {
                            i.right = Ae(It, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof wi && i.left instanceof Yt && i.left.operator != "%" && Hi[i.left.operator] == Hi[i.operator] && i.left.is_number(o)) {
                        if (i.left.left instanceof wi) {
                            var u = A(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = A(i, i.left.operator, be(o, u), i.left.right);
                        } else if (i.left.right instanceof wi) {
                            var y = T(i.left.operator, i.operator);
                            var w = be(o, A(i.left, y, i.left.right, i.right));
                            if (w.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +w.value == 0 && i.left.left.is_negative_zero())) {
                                i = A(i, i.left.operator, i.left.left, w);
                            }
                        }
                    }
                    break;
                }
                if (!(p instanceof It && p.operator == "delete")) {
                    if (i.left instanceof ki && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(o)) return Ae(It, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                            if (i.right.is_number(o) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(o) ? i.right : Ae(It, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (i.right instanceof ki && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(o)) return Ae(It, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                            if (i.left.is_number(o) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(o) ? i.left : Ae(It, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(o) ? i.left : Ae(It, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (i.operator) {
              case "&&":
                B(i.left, i.right, null);
                break;

              case "||":
                B(i.left, null, i.right);
                break;
            }
            if (o.option("unsafe")) {
                var x = D(i.right);
                if (l && x && (i.operator == "==" || i.operator == "!=") && i.left instanceof ki && i.left.value == 0) {
                    return (i.operator == "==" ? Ae(It, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(o);
                }
                var k = D(i.left);
                if (o.option("comparisons") && O()) {
                    var E = Ae(It, i, {
                        operator: "!",
                        expression: Ae(It, i, {
                            operator: "~",
                            expression: k ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (k) break;

                      case "<=":
                      case "!=":
                        E = Ae(It, i, {
                            operator: "!",
                            expression: E
                        });
                        break;
                    }
                    return E.optimize(o);
                }
            }
            return be(o, i);
            function S(e) {
                var n = false;
                e.walk(new Mi(function(e) {
                    if (n) return true;
                    if (e instanceof Bt) {
                        if (e.left instanceof Mt) return n = true;
                    } else if (e instanceof Nt) {
                        if (Ri[e.operator] && e.expression instanceof Mt) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function T(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function A(e, n, t, i, r, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = Ae(It, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(o) && !i.is_number(o)) {
                        i = Ae(It, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return Ae(Yt, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: a
                });
            }
            function D(e) {
                return e.TYPE == "Call" && e.expression instanceof Ft && re[e.expression.property];
            }
            function O() {
                switch (i.operator) {
                  case "<=":
                    return x && i.left instanceof ki && i.left.value == 0;

                  case "<":
                    if (k && i.right instanceof ki && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!x) return false;
                    return i.left instanceof ki && i.left.value == -1 || i.left instanceof It && i.left.operator == "-" && i.left.expression instanceof ki && i.left.expression.value == 1;
                }
            }
        });
        e(hi, function(e) {
            return e;
        });
        function Re(e, n, t) {
            var i = 0, r = e.self();
            do {
                if (r === t) return r;
                if (A(r) && r.name && r.name.definition() === n) return r;
            } while (r = e.parent(i++));
        }
        function Be(e) {
            var n = e.scope.resolve();
            return un(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(vi, function(e, n) {
            if (!n.option("ie") && ze(e) && !(e.scope.resolve().uses_with && n.find_parent(Cn))) {
                switch (e.name) {
                  case "undefined":
                    return Ae(Di, e).optimize(n);

                  case "NaN":
                    return Ae(Ai, e).optimize(n);

                  case "Infinity":
                    return Ae($i, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && Bi(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var a = i.single_use && !(t instanceof zt && t.is_expr_pure(n));
                if (a) {
                    if (A(r)) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            a = false;
                        } else if (Re(n, i, r)) {
                            a = false;
                        } else if (r.name && r.name.definition() !== i) {
                            a = false;
                        } else if (r.parent_scope !== e.scope || ke(i)) {
                            a = r.is_constant_expression(e.scope);
                            if (a == "f") {
                                var o = e.scope;
                                do {
                                    if (o instanceof Jn || o instanceof Nn) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (r.name && (r.name.name == "await" && Hn(r) || r.name.name == "yield" && Yn(r))) {
                            a = false;
                        } else if (r.has_side_effects(n)) {
                            a = false;
                        } else if (n.option("ie") && r instanceof et) {
                            a = false;
                        }
                        if (a) r.parent_scope = e.scope;
                    } else if (!r || i.recursive_refs > 0 || !r.is_constant_expression() || r.drop_side_effect_free(n)) {
                        a = false;
                    }
                }
                if (a) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof nt) r = Z(r);
                    if (r instanceof Jn) r = je(r);
                    if (A(r)) {
                        var o = e.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (o.var_names()[e.name]) return;
                            o.enclosed.push(e);
                            o.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        var l, p;
                        if (s instanceof et) {
                            l = "def_function";
                            p = pi;
                        } else {
                            l = "def_variable";
                            p = li;
                        }
                        if (!(c instanceof p)) {
                            c = Ae(p, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s[l](c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new Mi(function(e) {
                            if (e instanceof ri) {
                                if (e !== c) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof vi)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!A(t)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s[l](t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        if (r instanceof Mn) {
                            n.push(r);
                            s = r.optimize(n);
                            n.pop();
                        } else {
                            s = r.optimize(n);
                        }
                        s = s.transform(new Fi(function(e, n) {
                            if (e instanceof Mn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var d = e.fixed !== i.fixed;
                if (r && (d || i.should_replace !== false)) {
                    var v, h;
                    if (r instanceof gi) {
                        if (!ke(i) && Be(i)) h = r;
                    } else if ((v = r.evaluate(n, true)) !== r && typeof v != "function" && (v === null || typeof v != "object" || n.option("unsafe_regexp") && v instanceof RegExp && !i.cross_loop && Be(i))) {
                        h = pe(v, r);
                    }
                    if (h) {
                        if (!d && i.should_replace === undefined) {
                            var m = h.optimize(n).print_to_string().length;
                            if (!y(r)) {
                                m = Math.min(m, r.print_to_string().length);
                            }
                            var _ = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var g = i.references.length - i.replaced;
                                _ += (_ + 2 + m) / (g - i.assignments);
                            }
                            var b = m - Math.floor(_);
                            i.should_replace = b < n.eval_threshold;
                        }
                        if (d || i.should_replace) {
                            var s;
                            if (y(r)) {
                                s = h.optimize(n);
                                if (s === h) s = s.clone(true);
                            } else {
                                s = _e(h.optimize(n), r);
                                if (s === h || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function y(e) {
                var n;
                e.walk(new Mi(function(e) {
                    if (e instanceof vi) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function fe(e, n) {
            return e.option("unsafe") && n instanceof Ft && n.property == "raw" && ze(n.expression) && n.expression.name == "String";
        }
        e(yi, function(e, n) {
            if (!n.option("templates")) return e;
            var t = e.tag;
            if (!t || fe(n, t)) {
                var i = e.expressions.slice();
                var r = e.strings.slice();
                var a = false;
                for (var o = i.length; --o >= 0; ) {
                    var s = i[o];
                    var f = s.evaluate(n);
                    if (f === s) continue;
                    if (t && /\r|\\|`/.test(f)) continue;
                    f = ("" + f).replace(/\r|\\|`/g, function(e) {
                        return "\\" + (e == "\r" ? "r" : e);
                    });
                    if (f.length > s.print_to_string().length + 3) continue;
                    var u = r[o] + f + r[o + 1];
                    if (typeof Ae(yi, e, {
                        expressions: [],
                        strings: [ u ],
                        tag: t
                    }).evaluate(n) != typeof Ae(yi, e, {
                        expressions: [ s ],
                        strings: r.slice(o, o + 2),
                        tag: t
                    }).evaluate(n)) continue;
                    i.splice(o, 1);
                    r.splice(o, 2, u);
                    a = true;
                }
                if (a) {
                    e.expressions = i;
                    e.strings = r;
                }
            }
            return be(n, e);
        });
        function Le(e, n) {
            return e instanceof vi || e.TYPE === n.TYPE;
        }
        e(Di, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = ue(n).find_variable("undefined");
                if (t) {
                    var i = Ae(vi, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = Bi(n.self(), n.parent());
            if (r && Le(r, e)) return e;
            return Ae(It, e, {
                operator: "void",
                expression: Ae(ki, e, {
                    value: 0
                })
            });
        });
        e($i, function(e, n) {
            var t = Bi(n.self(), n.parent());
            if (t && Le(t, e)) return e;
            if (n.option("keep_infinity") && !t && !ue(n).find_variable("Infinity")) {
                return e;
            }
            return Ae(Yt, e, {
                operator: "/",
                left: Ae(ki, e, {
                    value: 1
                }),
                right: Ae(ki, e, {
                    value: 0
                })
            });
        });
        e(Ai, function(e, n) {
            var t = Bi(n.self(), n.parent());
            if (t && Le(t, e)) return e;
            if (!t && !ue(n).find_variable("NaN")) return e;
            return Ae(Yt, e, {
                operator: "/",
                left: Ae(ki, e, {
                    value: 0
                }),
                right: Ae(ki, e, {
                    value: 0
                })
            });
        });
        function Ue(t, n) {
            var i = false;
            var r = new Mi(function(e) {
                if (i) return true;
                if (e instanceof vi && Xe(e.definition(), n)) {
                    return i = true;
                }
            });
            var a = new Mi(function(e) {
                if (i) return true;
                if (e instanceof jn && e !== t) {
                    if (!(e.name || Hn(e) || Yn(e))) {
                        var n = a.parent();
                        if (n instanceof zt && n.expression === e) return;
                    }
                    e.walk(r);
                    return true;
                }
            });
            t.walk(a);
            return i;
        }
        var Ve = fn("+ - * / % >> << >>> | ^ &");
        var We = fn("* | ^ &");
        e(Bt, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof Mt) {
                    if (a.operator == "=") {
                        if (a.__drop) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof jt) e.push(a.left.property);
                            e.push(a.right);
                            return le(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof jn || !o.has_directive("use strict") && n instanceof wi && !n.may_throw_on_access(o)) {
                            return a.left instanceof Ft ? a.right : le(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof vi && Ee(a.left, o)) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof It && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return _();
                    var i = a.left.definition();
                    var s = i.scope.resolve();
                    var r = s === o.find_parent(jn);
                    var f = 0, u;
                    t = o.self();
                    do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Bt) {
                            var c = false;
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Mt) return true;
                                if (!c && e instanceof vi && e.definition() === i) {
                                    if (m(f, t)) return true;
                                    c = true;
                                }
                            })) break;
                            if (!c) continue;
                            return _(i);
                        }
                        if (t instanceof st) {
                            if (!r) break;
                            if (m(f, t)) break;
                            if (Ue(s, [ i ])) break;
                            return _(i);
                        }
                        if (t instanceof bn) {
                            if (!r) break;
                            if (Ue(s, [ i ])) break;
                            var l;
                            do {
                                l = t;
                                t = o.parent(f++);
                                if (t === s && M(t.body, l)) return _(i);
                            } while (h(l, t));
                            break;
                        }
                        if (t instanceof St) {
                            if (!(t.name instanceof ri)) continue;
                            if (t.name.definition() !== i) continue;
                            if (m(f, t)) break;
                            return _(i);
                        }
                    } while (v(u, t));
                }
            }
            if (o.option("sequences")) {
                var p = a.lift_sequences(o);
                if (p !== a) return p.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof vi && a.right instanceof Yt) {
                    if (a.right.left instanceof vi && a.right.left.name == a.left.name && Ve[a.right.operator]) {
                        return Ae(Bt, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if (a.right.right instanceof vi && a.right.right.name == a.left.name && We[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        return Ae(Bt, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof ki && a.right.value == 1) {
                    var d = a.operator.slice(0, -1);
                    return Ae(It, a, {
                        operator: d + d,
                        expression: a.left
                    });
                }
            }
            return be(o, a);
            function v(e, n) {
                if (n instanceof Yt) {
                    return n.right === e || n.right.is_constant_expression(s);
                }
                if (n instanceof Rt) {
                    return n.condition !== e || n.consequent.is_constant_expression(s) && n.alternative.is_constant_expression(s);
                }
                if (n instanceof Ct) {
                    var t = n.expressions;
                    var i = t.indexOf(e);
                    if (i < 0) return false;
                    for (var r = t.length; --r > i; ) {
                        if (!t[r].is_constant_expression(s)) return false;
                    }
                    return true;
                }
                if (n instanceof It) return true;
            }
            function h(e, n) {
                if (n instanceof kn) return M(n.body, e);
                if (n instanceof bt) return M(n.body, e);
                if (n instanceof yt) return M(n.body, e);
                if (n instanceof dt) return n.body === e || n.alternative === e;
                if (n instanceof gt) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function m(e, n) {
                var t = a.right;
                a.right = Ae(Ti, t);
                var i = n.may_throw(o);
                a.right = t;
                for (var r; r = o.parent(e++); n = r) {
                    if (r === s) return false;
                    if (r instanceof gt) {
                        if (r.bfinally && r.bfinally !== n) return true;
                        if (i && r.bcatch && r.bcatch !== n) return true;
                    }
                }
            }
            function _(e) {
                if (e) e.fixed = false;
                return (a.operator != "=" ? Ae(Yt, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : De(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Rt, function(r, n) {
            if (n.option("sequences") && r.condition instanceof Ct) {
                var e = r.condition.expressions.slice();
                r.condition = e.pop();
                e.push(r);
                return le(r, e);
            }
            if (!n.option("conditionals")) return r;
            var a = r.condition;
            if (n.option("booleans") && !a.has_side_effects(n)) {
                U(n, a);
            }
            a = L(n, a);
            if (!a) {
                dn.warn("Condition always false [{file}:{line},{col}]", r.start);
                return le(r, [ r.condition, r.alternative ]).optimize(n);
            } else if (!(a instanceof dn)) {
                dn.warn("Condition always true [{file}:{line},{col}]", r.start);
                return le(r, [ r.condition, r.consequent ]).optimize(n);
            }
            var t = a.negate(n, pn(n));
            if (ge(n, a, t) === t) {
                r = Ae(Rt, r, {
                    condition: t,
                    consequent: r.alternative,
                    alternative: r.consequent
                });
                t = a;
                a = r.condition;
            }
            var i = r.consequent;
            var o = r.alternative;
            if (se(n, a)) {
                if (a.equivalent_to(i)) return Ae(Yt, r, {
                    operator: "||",
                    left: a,
                    right: o
                }).optimize(n);
                if (a.equivalent_to(o)) return Ae(Yt, r, {
                    operator: "&&",
                    left: a,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof Bt) {
                var f = s.operator == "=";
                var u = f ? o.tail_node() : o;
                if ((f || i === s) && u instanceof Bt && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof vi || !a.has_side_effects(n) && w(i) && w(o))) {
                    return Ae(Bt, r, {
                        operator: s.operator,
                        left: s.left,
                        right: Ae(Rt, r, {
                            condition: a,
                            consequent: x(i),
                            alternative: x(o)
                        })
                    });
                }
            }
            if (i.equivalent_to(o)) return le(r, [ a, i ]).optimize(n);
            var c = y(i, o, true);
            if (c) return c;
            var l;
            if (i instanceof zt && o.TYPE == i.TYPE && (l = g(i, o)) >= 0 && i.expression.equivalent_to(o.expression) && !a.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                var d = i.args[l];
                p.args[l] = d instanceof Pt ? Ae(Pt, r, {
                    expression: Ae(Rt, r, {
                        condition: a,
                        consequent: d.expression,
                        alternative: o.args[l].expression
                    })
                }) : Ae(Rt, r, {
                    condition: a,
                    consequent: d,
                    alternative: o.args[l]
                });
                return p;
            }
            if (i instanceof Rt && i.alternative.equivalent_to(o)) {
                return Ae(Rt, r, {
                    condition: Ae(Yt, r, {
                        left: a,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: o
                });
            }
            if (i instanceof Rt && i.consequent.equivalent_to(o)) {
                return Ae(Rt, r, {
                    condition: Ae(Yt, r, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: o,
                    alternative: i.alternative
                });
            }
            if (o instanceof Rt && i.equivalent_to(o.consequent)) {
                return Ae(Rt, r, {
                    condition: Ae(Yt, r, {
                        left: a,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: i,
                    alternative: o.alternative
                });
            }
            if (o instanceof Rt && i.equivalent_to(o.alternative)) {
                return Ae(Rt, r, {
                    condition: Ae(Yt, r, {
                        left: t,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: i
                });
            }
            if ((i instanceof Ct || o instanceof Ct) && i.tail_node().equivalent_to(o.tail_node())) {
                return le(r, [ Ae(Rt, r, {
                    condition: a,
                    consequent: k(i),
                    alternative: k(o)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof Yt && i.operator == "&&" && i.right.equivalent_to(o)) {
                return Ae(Yt, r, {
                    operator: "&&",
                    left: Ae(Yt, r, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (i instanceof Yt && i.operator == "||" && i.right.equivalent_to(o)) {
                return Ae(Yt, r, {
                    operator: "||",
                    left: Ae(Yt, r, {
                        operator: "&&",
                        left: a,
                        right: i.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (o instanceof Yt && o.operator == "&&" && o.right.equivalent_to(i)) {
                return Ae(Yt, r, {
                    operator: "&&",
                    left: Ae(Yt, r, {
                        operator: "||",
                        left: a,
                        right: o.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (o instanceof Yt && o.operator == "||" && o.right.equivalent_to(i)) {
                return Ae(Yt, r, {
                    operator: "||",
                    left: Ae(Yt, r, {
                        operator: "&&",
                        left: t,
                        right: o.left
                    }),
                    right: i
                }).optimize(n);
            }
            var v = n.option("booleans") && n.in_boolean_context();
            if (m(i)) {
                if (_(o)) {
                    return h(a);
                }
                return Ae(Yt, r, {
                    operator: "||",
                    left: h(a),
                    right: o
                });
            }
            if (_(i)) {
                if (m(o)) {
                    return h(a.negate(n));
                }
                return Ae(Yt, r, {
                    operator: "&&",
                    left: h(a.negate(n)),
                    right: o
                });
            }
            if (m(o)) {
                return Ae(Yt, r, {
                    operator: "||",
                    left: h(a.negate(n)),
                    right: i
                });
            }
            if (_(o)) {
                return Ae(Yt, r, {
                    operator: "&&",
                    left: h(a),
                    right: i
                });
            }
            if (n.option("typeofs")) B(a, i, o);
            return r;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return Ae(It, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Ci || v && e instanceof wi && e.value || e instanceof It && e.operator == "!" && e.expression instanceof wi && !e.expression.value;
            }
            function _(e) {
                return e instanceof qi || v && (e instanceof wi && !e.value || e instanceof It && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof It && e.operator == "!" && e.expression instanceof wi && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var a = 0; a < r; a++) {
                    if (!t[a].equivalent_to(i[a])) {
                        if (t[a] instanceof Pt !== i[a] instanceof Pt) return -3;
                        for (var o = a + 1; o < r; o++) {
                            if (!t[o].equivalent_to(i[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof zt) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Mt || n.expression instanceof Mt) || b(e.expression, n.expression);
                }
                if (!(e instanceof Mt)) return;
                var t = e.property;
                var i = n.property;
                return (t instanceof dn ? t.equivalent_to(i) : t == i) && !(e.expression instanceof _i || n.expression instanceof _i);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && Ae(Rt, r, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var i = e.clone();
                i.expression = y(e.expression, n.expression);
                return i;
            }
            function w(e) {
                return e === e.tail_node() || un(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof Ct)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return le(e, n);
            }
            function k(e) {
                if (!(e instanceof Ct)) return Ae(ki, e, {
                    value: 0
                });
                return le(e, e.expressions.slice(0, -1));
            }
        });
        e(zi, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return Ae(ki, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Yt && (t.operator == "==" || t.operator == "!=")) {
                dn.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return Ae(ki, e, {
                    value: +e.value
                });
            }
            return Ae(It, e, {
                operator: "!",
                expression: Ae(ki, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Pt, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof Vt && !(n.parent() instanceof Kt)) {
                return rn.splice(t.elements.map(function(e) {
                    return e instanceof Oi ? Ae(Di, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function Ge(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof vi) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof jn && !e.contains_this();
        }
        e(jt, function(e, t) {
            var n = e.expression;
            var i = e.property;
            var r = Ne(e, t);
            if (r) return r;
            if (t.option("properties")) {
                var a = i.evaluate(t);
                if (a !== i) {
                    if (typeof a == "string") {
                        if (a == "undefined") {
                            a = undefined;
                        } else {
                            var o = parseFloat(a);
                            if (o.toString() == a) {
                                a = o;
                            }
                        }
                    }
                    i = e.property = _e(i, pe(a, i).transform(t));
                    var s = "" + a;
                    if (ji(s) && s.length <= i.print_to_string().length + 1) {
                        return Ae(Ft, e, {
                            optional: e.optional,
                            expression: n,
                            property: s
                        }).optimize(t);
                    }
                }
            }
            var f = t.parent();
            var u = Bi(t.self(), f);
            var c, l, p, d;
            if (t.option("arguments") && n instanceof vi && xe(c = n.definition()) && !n.in_arg && i instanceof ki && Math.floor(d = i.value) == d && (l = c.scope) === S() && l.uses_arguments < (u ? 2 : 3)) {
                if (f instanceof It && f.operator == "delete") {
                    if (!c.deleted) c.deleted = [];
                    c.deleted[d] = true;
                }
                var v = l.argnames[d];
                if (c.deleted && c.deleted[d]) {
                    v = null;
                } else if (v) {
                    var h;
                    if (!(v instanceof ui) || v.name == "await" || n.scope.find_variable(v.name) !== (h = v.definition())) {
                        v = null;
                    } else if (t.has_directive("use strict") || l.name || l.rest || !(p instanceof zt && d < p.args.length && un(p.args.slice(0, d + 1), function(e) {
                        return !(e instanceof Pt);
                    })) || !un(l.argnames, function(e) {
                        return e instanceof ui;
                    })) {
                        if (T() || h.assignments || h.orig.length > 1) v = null;
                    }
                } else if ((u || !T()) && d < l.argnames.length + 5 && t.drop_fargs(l, p) && !l.rest) {
                    while (d >= l.argnames.length) {
                        v = l.make_var(ui, l, "argument_" + l.argnames.length);
                        l.argnames.push(v);
                    }
                }
                if (v && Ke(function(e) {
                    return e.name === v.name;
                }, l.argnames) === v) {
                    if (u) c.reassigned--;
                    var m = Ae(vi, e, v);
                    m.reference();
                    delete v.__unused;
                    return m;
                }
            }
            if (u) return e;
            if (t.option("sequences") && f.TYPE != "Call" && !(f instanceof $n && f.init === e)) {
                var _ = Ie(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (a !== i) {
                var g = e.flatten_object(s, t);
                if (g) {
                    n = e.expression = g.expression;
                    i = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && i instanceof ki && n instanceof Vt && un(b = n.elements, function(e) {
                return !(e instanceof Pt);
            })) {
                var d = i.value;
                var y = b[d];
                if (Ge(y, t)) {
                    var w = y instanceof Oi;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > d; ) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                            if (x && o.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                        } else if (w) {
                            k.unshift(Ae(Oi, b[E]));
                        } else {
                            d--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return le(e, k).optimize(t);
                    } else return Ae(jt, e, {
                        expression: Ae(Vt, n, {
                            elements: k
                        }),
                        property: Ae(ki, i, {
                            value: d
                        })
                    });
                }
            }
            return be(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof jn) {
                        if (n instanceof Pn) return;
                        if (In(n)) continue;
                        p = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || c.reassigned;
            }
        });
        Bn.DEFMETHOD("contains_super", Ze);
        Ln.DEFMETHOD("contains_super", Ze);
        jn.DEFMETHOD("contains_super", function() {
            var n;
            var t = this;
            t.walk(new Mi(function(e) {
                if (n) return true;
                if (e instanceof _i) return n = true;
                if (e !== t && e instanceof Mn && !In(e)) return true;
            }));
            return n;
        });
        Jn.DEFMETHOD("contains_super", Ze);
        Mn.DEFMETHOD("contains_super", Ze);
        Bn.DEFMETHOD("contains_this", Ze);
        Ln.DEFMETHOD("contains_this", Ze);
        dn.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new Mi(function(e) {
                if (n) return true;
                if (e instanceof gi) return n = true;
                if (e !== t && e instanceof Mn && !In(e)) return true;
            }));
            return n;
        });
        function Je(e) {
            return e instanceof Zt && typeof e.key == "string" && !(e instanceof ei && e.value.contains_super());
        }
        Mt.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this.expression;
            if (t instanceof Kt) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a.key !== e) continue;
                    if (!un(i, Je)) break;
                    if (!Ge(a.value, n)) break;
                    i = i.map(function(e) {
                        return e.value;
                    });
                    if (a instanceof ei && a.value instanceof Wn && !(n.parent() instanceof zt)) {
                        if (a.value.uses_arguments) break;
                        i[r] = Ae(Bn, a.value, a.value);
                    }
                    return Ae(jt, this, {
                        expression: Ae(Vt, t, {
                            elements: i
                        }),
                        property: Ae(ki, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(Ft, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                dn.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (Bi(n.self(), t)) return e;
            var i = Ne(e, n);
            if (i) return i;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof $n && t.init === e)) {
                var r = Ie(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Ft && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (ze(a)) switch (a.name) {
                  case "Array":
                    e.expression = Ae(Vt, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = Ae(Wn, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = Ae(ki, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = Ae(Kt, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = Ae(Si, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = Ae(xi, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return be(n, e);
        });
        e(Gt, function(e, n) {
            if (n.option("rests") && e.rest instanceof Gt) {
                e.elements = e.elements.concat(e.rest.elements);
                e.rest = e.rest.rest;
            }
            return e;
        });
        e(Jt, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof dn) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(Kt, function(t, i) {
            if (!i.option("objects")) return t;
            var r = false;
            var a = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = new cn();
            var u = [];
            t.properties.forEach(function(e) {
                if (!(e instanceof Pt)) return l(e);
                a = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof Kt && un(n.properties, function(e) {
                    if (e instanceof ti) return false;
                    if (e instanceof Pt) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof ni) return true;
                    return !e.value.has_side_effects(i);
                })) {
                    r = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof ni;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = pe(n, e);
                        }
                        l(t ? Ae(Zt, e, {
                            key: n,
                            value: Ae(Di, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!r) return t;
            if (a && o && u.length == 1) {
                var e = u[0];
                if (e instanceof Qt && e.key instanceof ki) {
                    e.key = "" + e.key.value;
                }
            }
            return Ae(Kt, t, {
                properties: u
            });
            function c() {
                f.each(function(e) {
                    if (e.length == 1) return u.push(e[0]);
                    r = true;
                    var n = s && !o && e.pop();
                    u.push(e.length == 1 ? e[0] : Ae(Zt, t, {
                        key: e[0].key,
                        value: le(t, e.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (n) u.push(n);
                });
                f = new cn();
            }
            function l(e) {
                var n = e.key;
                if (n instanceof dn) {
                    a = true;
                    n = n.evaluate(i);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (Je(e)) {
                    if (e.value.has_side_effects(i)) c();
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (a && !o && typeof n == "string" && D.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = Ae(ki, e, {
                        value: +n
                    });
                }
            }
        });
        e(ft, function(e, n) {
            if (n.option("side_effects") && e.value && Ce(e.value, n) && !g(n.find_parent(Mn))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function re(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function Ui(f) {
        f = ge(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = Ze;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = re;
            } else {
                u = en;
            }
        }
        var a = 0;
        var o = 1;
        var c = 0;
        var t = f.indent_start;
        var s;
        var r = 0;
        var l = true;
        var p = f.source_map && [];
        var d;
        var v;
        var h;
        var m;
        var _ = false;
        var g = false;
        var b = -1;
        var i;
        var y;
        function w() {
            s = "";
            h = false;
            m = false;
            i = [];
            var e = y;
            y = "";
            return e;
        }
        w();
        var x = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (ne(r)) {
                    if (te(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!te(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function k(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function E(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var S = [ null, k, E, function(e, n) {
            return n == "'" ? k(e) : E(e);
        } ][f.quote_style] || function(e, n, t, i) {
            return t > i ? k(e) : E(e);
        };
        function T(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return S(x(t), e, i, r);
        }
        var A = p ? function(n, t) {
            p.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Qe;
        var D = p ? function() {
            p.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            p = [];
        } : Qe;
        function O(e) {
            var n = y.lastIndexOf("\n");
            if (r < n) r = n;
            var t = y.slice(0, r);
            var i = y.slice(r);
            A(e, i.length - a);
            o += e;
            c += e;
            a = i.length;
            y = t;
            while (e--) y += "\n";
            y += i;
        }
        var $ = f.max_line_len ? function() {
            if (l) {
                if (a > f.max_line_len) {
                    dn.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (a > f.max_line_len) O(1);
            l = true;
            D();
        } : Qe;
        var z = fn("( [ + * / - , .");
        var q = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (_ && n) {
                _ = false;
                if (n != "\n") {
                    q("\n");
                    M();
                }
            }
            if (g && n) {
                g = false;
                if (!/[\s;})]/.test(n)) {
                    C();
                }
            }
            b = -1;
            var t = s.slice(-1);
            if (m) {
                m = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        y += ";";
                        a++;
                        c++;
                    } else {
                        $();
                        y += "\n";
                        c++;
                        o++;
                        a = 0;
                        if (/^\s+$/.test(e)) {
                            m = true;
                        }
                    }
                    if (!f.beautify) h = false;
                }
            }
            if (h) {
                if (ie(t) && (ie(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == s || e == "--" && s == "!" || e == "in" && t == "/" || s == "--" && n == ">") {
                    y += " ";
                    a++;
                    c++;
                }
                if (t != "<" || e != "!") h = false;
            }
            if (v) {
                p.push({
                    token: v,
                    name: d,
                    line: o,
                    col: a
                });
                v = false;
                if (l) D();
            }
            y += e;
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            o += r;
            a += i[0].length;
            if (r > 0) {
                $();
                a = i[r].length;
            }
            s = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = s.slice(-1);
            if (m) {
                m = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    y += ";";
                    h = false;
                }
            }
            if (h) {
                if (ie(t) && (ie(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == s || e == "--" && s == "!" || e == "in" && t == "/" || s == "--" && n == ">") {
                    y += " ";
                }
                if (t != "<" || e != "!") h = false;
            }
            y += e;
            s = e;
        };
        var C = f.beautify ? function() {
            q(" ");
        } : function() {
            h = true;
        };
        var M = f.beautify ? function(e) {
            if (_) q("\n");
            q(Z(" ", e ? t - (f.indent_level >> 1) : t));
        } : Qe;
        var F = f.beautify ? function(e) {
            var n = t;
            t += f.indent_level;
            e();
            t = n;
        } : function(e) {
            e();
        };
        var j = f.max_line_len || f.preserve_line ? function() {
            $();
            r = y.length;
            l = false;
        } : Qe;
        var P = f.beautify ? function() {
            if (b < 0) return q("\n");
            if (y[b] != "\n") {
                y = y.slice(0, b) + "\n" + y.slice(b);
                c++;
                o++;
            }
            b++;
        } : j;
        var N = f.beautify ? function() {
            q(";");
        } : function() {
            m = true;
        };
        function I() {
            if (m) q(";");
            q(";");
        }
        function H(e) {
            q("{");
            P();
            F(e);
            M();
            q("}");
        }
        function Y(e) {
            q("(");
            j();
            e();
            j();
            q(")");
        }
        function R(e) {
            q("[");
            j();
            e();
            j();
            q("]");
        }
        function B() {
            j();
            q(",");
            j();
            C();
        }
        function L() {
            q(":");
            C();
        }
        var U = p ? function(e, n) {
            v = e;
            d = n;
        } : Qe;
        function V() {
            if (!l) $();
            return y;
        }
        function W() {
            var e = y.lastIndexOf("\n");
            return /^ *$/.test(y.slice(e + 1));
        }
        function G(e, n) {
            if (_) return;
            if (e.nlb && (n || !W())) {
                _ = true;
            } else if (n) {
                g = true;
            }
        }
        function J(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                q("//" + n);
                _ = true;
            } else if (e.type == "comment2") {
                q("/*" + n + "*/");
            }
            return true;
        }
        function X(e, n) {
            if (n instanceof Yt) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof Rt) return n.condition === e;
            if (n instanceof Ft) return n.expression === e;
            if (n instanceof st) return true;
            if (n instanceof Ct) return n.expressions[0] === e;
            if (n instanceof jt) return n.expression === e;
            if (n instanceof Ht) return true;
            if (n instanceof Ut) return true;
        }
        function K(e) {
            var i = this;
            var r;
            if (e instanceof st) {
                r = e.value;
            } else if (e instanceof Ut) {
                r = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (r) {
                var a = new Mi(function(e) {
                    if (!X(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                r.walk(a);
            }
            if (c == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    q("#!" + t.shift().value + "\n");
                    M();
                }
                var n = f.preamble;
                if (n) {
                    q(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            t = t.filter(u, e);
            var o = false;
            t.forEach(function(e, n) {
                G(e, n);
                if (J(e)) o = true;
            });
            if (o) G(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new ee();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function Q(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof vn || un(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var a = y.length;
            r.filter(u, e).forEach(function(e, n) {
                G(e, n || !t);
                J(e);
            });
            if (y.length > a) b = a;
        }
        return {
            get: V,
            reset: w,
            indent: M,
            should_break: f.width ? function() {
                return a - t >= f.width;
            } : Ze,
            has_parens: function() {
                return s.slice(-1) == "(";
            },
            newline: P,
            print: q,
            space: C,
            comma: B,
            colon: L,
            last: function() {
                return s;
            },
            semicolon: N,
            force_semicolon: I,
            to_utf8: x,
            print_name: function(e) {
                q(x(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = T(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                q(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                q(T(e, n));
            },
            with_indent: F,
            with_block: H,
            with_parens: Y,
            with_square: R,
            add_mapping: U,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? K : Qe,
            append_comments: f.comments ? Q : Qe,
            push_node: function(e) {
                i.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = i.pop();
                if (e.start && e.start.line > o) {
                    O(e.start.line - o);
                }
            } : function() {
                i.pop();
            },
            parent: function(e) {
                return i[i.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        dn.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var t = Ui({
            inline_script: false,
            shebang: false,
            width: false
        });
        dn.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = Ui(e);
                this.print(n);
                return n.get();
            }
            this.print(t);
            return t.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(dn, Ze);
        function i(e) {
            var n = e.parent();
            if (!e.has_parens() && pn(e, false, true)) {
                return this.name || !(n instanceof At);
            }
            if (e.option("webkit") && n instanceof Mt && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof zt && n.expression === this) return true;
        }
        n(Un, i);
        n(Vn, i);
        n(tt, i);
        n(Wn, i);
        n(Gn, i);
        function r(e) {
            return !e.has_parens() && pn(e, true);
        }
        n(Kt, r);
        function a(e) {
            var n = e.parent();
            if (n instanceof Yt) return n.operator == "**" && n.left === this;
            if (n instanceof zt) return n.expression === this;
            if (n instanceof et) return true;
            if (n instanceof Mt) return n.expression === this;
            if (n instanceof yi) return n.tag === this;
        }
        n(Lt, a);
        n(Nt, a);
        n(Ct, function(e) {
            var n = e.parent();
            return n instanceof Vt || In(n) && n.value === this || n instanceof Lt || n instanceof Yt || n instanceof zt || n instanceof et || n instanceof it || n instanceof Rt || n instanceof $t || n instanceof Jt || n instanceof At || n instanceof be || n instanceof Qt || n instanceof Mt && n.expression === this || n instanceof Pt || n instanceof yi && n.tag === this || n instanceof Nt || n instanceof St || n instanceof Ut;
        });
        n(Yt, function(e) {
            var n = e.parent();
            if (n instanceof Lt) return true;
            if (n instanceof Yt) {
                var t = n.operator, i = Hi[t];
                var r = this.operator, a = Hi[r];
                return i > a || t == "??" && (r == "&&" || r == "||") || i == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof zt) return n.expression === this;
            if (n instanceof et) return true;
            if (n instanceof Mt) return n.expression === this;
            if (n instanceof yi) return n.tag === this;
            if (n instanceof Nt) return true;
        });
        function o(e, n) {
            var t = n.parent();
            if (t instanceof Mt && t.expression === e && Bi(t, n.parent(1))) {
                do {
                    if (e.optional) return true;
                    e = e.expression;
                } while (e.TYPE == "Call" || e instanceof Mt);
            }
        }
        n(Mt, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof qt) {
                if (t.expression !== n) return false;
                do {
                    n = n.expression;
                } while (n instanceof Mt);
                return n.TYPE == "Call";
            }
            return o(n, e);
        });
        n(zt, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof qt) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof Wn && t instanceof Mt && t.expression === n) {
                var i = e.parent(1);
                if (i instanceof Bt && i.left === t) return true;
            }
            return o(n, e);
        });
        n(qt, function(e) {
            if (q(this, e)) return false;
            var n = e.parent();
            if (n instanceof zt) return n.expression === this;
            if (n instanceof Mt) return true;
            if (n instanceof yi) return n.tag === this;
        });
        n(ki, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof Mt && n.expression === this && /^0/.test(M(this.value));
        });
        function f(e, n) {
            var t = n.parent();
            if (t instanceof Lt) return true;
            if (t instanceof Yt) return !(t instanceof Bt);
            if (t instanceof zt) return t.expression === e;
            if (t instanceof et) return true;
            if (t instanceof Rt) return t.condition === e;
            if (t instanceof Mt) return t.expression === e;
            if (t instanceof yi) return t.tag === e;
            if (t instanceof Nt) return true;
        }
        n(Bn, function(e) {
            return f(this, e);
        });
        n(Bt, function(e) {
            if (f(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Wt;
            if (this.left instanceof Xt) return r(e);
        });
        n(Ln, function(e) {
            return f(this, e);
        });
        n(Rt, function(e) {
            return f(this, e);
        });
        n(Ut, function(e) {
            return f(this, e);
        });
        e(mn, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(hn, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function u(e, t, i, n) {
            var r = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof mn) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof _n)) {
                        if (e instanceof bn && e.body instanceof xi) {
                            i.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof _n) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = o;
        }
        e(Fn, function(e) {
            u(this.body, true, e, true);
            e.print("");
        });
        e(En, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(bn, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function c(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function l(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    u(e.body, false, n, t);
                });
            } else c(e, n);
        }
        e(kn, function(e) {
            l(this, e);
        });
        e(_n, function(e) {
            e.semicolon();
        });
        e(An, function(e) {
            var n = this;
            e.print("do");
            F(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(Dn, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            z(n.body, e);
        });
        e(On, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof wt) {
                        n.init.print(e);
                    } else {
                        E(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            z(n.body, e);
        });
        function p(t, i) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(i);
                    e.space();
                    n.object.print(e);
                });
                z(n.body, e);
            };
        }
        e(qn, p("for await", "of"));
        e(zn, p("for", "in"));
        e(be, p("for", "of"));
        e(Cn, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            z(n.body, e);
        });
        e(Tt, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(At, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof tt) {
                if (!n.name) return;
            }
            if (n instanceof nt) return;
            if (n instanceof Jn) return;
            if (n instanceof Nn) {
                if (!n.name && !In(n)) return;
            }
            e.semicolon();
        });
        e(xe, function(i) {
            var r = this;
            i.print("export");
            i.space();
            var n = r.keys.length;
            if (n == 0) {
                c(r, i);
            } else if (r.keys[0] == "*") {
                t(0);
            } else i.with_block(function() {
                i.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    i.print(",");
                    i.newline();
                    i.indent();
                    t(e);
                }
                i.newline();
            });
            i.space();
            i.print("from");
            i.space();
            i.print_string(r.path, r.quote);
            i.semicolon();
            function t(e) {
                var n = r.aliases[e];
                var t = r.keys[e];
                i.print_name(t);
                if (n != t) {
                    i.space();
                    i.print("as");
                    i.space();
                    i.print_name(n);
                }
            }
        });
        e(Dt, function(e) {
            var n = this;
            e.print("export");
            e.space();
            A(n, e);
            e.semicolon();
        });
        e(Ot, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                A(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            e.print_string(n.path, n.quote);
            e.semicolon();
        });
        function d(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function v(e, n) {
            if (e.argnames.length == 1 && e.argnames[0] instanceof ui && !e.rest) {
                e.argnames[0].print(n);
            } else {
                d(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                l(e, n, true);
            }
        }
        e(Bn, function(e) {
            v(this, e);
        });
        e(Ln, function(e) {
            e.print("async");
            e.space();
            v(this, e);
        });
        function h(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            d(e, n);
            n.space();
            l(e, n, true);
        }
        e(jn, function(e) {
            e.print("function");
            h(this, e);
        });
        function m(e) {
            e.print("async");
            e.space();
            e.print("function");
            h(this, e);
        }
        e(Xn, m);
        e(Un, m);
        function _(e) {
            e.print("async");
            e.space();
            e.print("function*");
            h(this, e);
        }
        e(Kn, _);
        e(Vn, _);
        function g(e) {
            e.print("function*");
            h(this, e);
        }
        e(Zn, g);
        e(Gn, g);
        e(et, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            A(n, e, true);
        });
        e(rt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            D(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(ye, O("get"));
        e(we, O("set"));
        function b(e, n) {
            var t = e.value;
            if (Hn(t)) {
                n.print("async");
                n.space();
            }
            if (Yn(t)) n.print("*");
            D(e, n);
            h(e.value, n);
        }
        e(at, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            b(n, e);
        });
        function y(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(ft, y("return", "value"));
        e(ut, y("throw", "value"));
        e(lt, y("break", "label"));
        e(pt, y("continue", "label"));
        function w(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof xt || t instanceof kt) || n.option("ie") && t instanceof An) return F(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof dt) {
                    if (!t.alternative) {
                        F(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof P) {
                    t = t.body;
                } else break;
            }
            z(e.body, n);
        }
        e(dt, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                w(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof dt) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    z(n.alternative, e);
                }
            } else {
                z(n.body, e);
            }
        });
        e(vt, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) c(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function x(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(mt, function(e) {
            e.print("default:");
            x(this, e);
        });
        e(_t, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            x(n, e);
        });
        e(gt, function(e) {
            var n = this;
            e.print("try");
            e.space();
            l(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(bt, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            l(n, e);
        });
        e(yt, function(e) {
            e.print("finally");
            e.space();
            l(this, e);
        });
        function k(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof Sn && n.init === e)) t.semicolon();
            };
        }
        e(xt, k("const"));
        e(kt, k("let"));
        e(Et, k("var"));
        function E(e, n, t) {
            var i = false;
            if (t) e.walk(new Mi(function(e) {
                if (i) return true;
                if (e instanceof Yt && e.operator == "in") return i = true;
                if (e instanceof Mn && !(In(e) && e.value)) return true;
            }));
            e.print(n, i);
        }
        e(St, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof On || t instanceof $n;
                E(n.value, e, i);
            }
        });
        e($t, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function S(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, i = e, r;
            do {
                r = i;
                i = n.parent(t++);
                if (i instanceof zt && i.expression === r) return;
            } while (i instanceof Mt && i.expression === r);
            n.print(typeof e.pure == "string" ? "/*" + e.pure + "*/" : "/*@__PURE__*/");
        }
        function T(e, t) {
            if (e.expression instanceof zt || e.expression instanceof jn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(zt, function(e) {
            var n = this;
            S(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            T(n, e);
        });
        e(qt, function(e) {
            var n = this;
            S(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (q(n, e)) T(n, e);
        });
        e(Ct, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Ft, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie") && N[i]) {
                e.print(n.optional ? "?.[" : "[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof ki && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(jt, function(e) {
            var n = this;
            n.expression.print(e);
            e.print(n.optional ? "?.[" : "[");
            n.property.print(e);
            e.print("]");
        });
        e(Pt, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(It, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof It && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(Ht, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(Yt, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Rt, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Lt, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(Ut, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(Vt, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof Oi) t.comma();
                });
                t.space();
            } : Qe);
        });
        e(Gt, function(t) {
            var e = this.elements, n = e.length, i = this.rest;
            t.with_square(n || i ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (i) {
                    if (n) t.comma();
                    t.print("...");
                    i.print(t);
                } else if (e[n - 1] instanceof Oi) {
                    t.comma();
                }
                t.space();
            } : Qe);
        });
        e(Jt, function(e) {
            var n = this;
            var t = D(n, e);
            var i = n.value;
            if (t) {
                if (i instanceof $t) {
                    if (i.name instanceof ii && t == $(i.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        i.value.print(e);
                        return;
                    }
                } else if (i instanceof ii) {
                    if (t == $(i)) return;
                }
            }
            e.colon();
            i.print(e);
        });
        e(Xt, function(t) {
            var e = this.properties, n = e.length, i = this.rest;
            if (n || i) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (i) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    i.print(t);
                }
                t.newline();
            }); else c(this, t);
        });
        function A(e, t, i) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!i) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else c(e, t);
        }
        e(Kt, function(e) {
            A(this, e);
        });
        function D(e, n) {
            var t = e.key;
            if (t instanceof dn) return n.with_square(function() {
                t.print(n);
            });
            var i = e.start && e.start.quote;
            if (n.option("quote_keys") || i && n.option("keep_quoted_props")) {
                n.print_string(t, i);
            } else if ("" + +t == t && t >= 0) {
                n.print(M(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (N[t] ? !n.option("ie") : ji(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, i);
            }
        }
        e(Zt, function(e) {
            var n = this;
            D(n, e);
            e.colon();
            n.value.print(e);
        });
        e(ei, function(e) {
            b(this, e);
        });
        function O(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                D(n, e);
                h(n.value, e);
            };
        }
        e(ti, O("get"));
        e(ni, O("set"));
        function $(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(ii, function(e) {
            e.print_name($(this));
        });
        e(hi, function(e) {
            var n = this;
            var t = $(n);
            e.print_name(t);
            var i = n.alias;
            if (i != t) {
                e.space();
                e.print("as");
                e.space();
                e.print_name(i);
            }
        });
        e(oi, function(e) {
            var n = this;
            var t = $(n);
            var i = n.key;
            if (i && i != t) {
                e.print_name(i);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Oi, Qe);
        e(yi, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(wi, function(e) {
            e.print("" + this.value);
        });
        e(xi, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(ki, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(M(this.value));
            }
        });
        e(Si, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof Yt && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function z(e, n) {
            if (n.option("braces") && !(e instanceof xt || e instanceof kt)) {
                F(e, n);
            } else if (e instanceof _n) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function q(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function C(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function M(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, a;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                a = n.slice(r);
                t.push(a + "e-" + (a.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return C(t);
        }
        function F(e, n) {
            n.space();
            if (e instanceof _n) {
                c(e, n);
            } else if (e instanceof kn) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function j(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        j([ dn, En ], Qe);
        j([ Vt, kn, bt, wi, hn, wt, Wt, yt, ot, jn, qt, Kt, P, ii, vt, ht, gt ], function(e) {
            e.add_mapping(this.start);
        });
        j([ it, Jt, Qt ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var S = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var T = S.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, a = 0; r < n.length; r++) {
            var o = T[n[r]];
            t += (o & 31) << i;
            if (o & 32) {
                i += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return a;
    }
    function D(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += S[t];
        } while (e);
        return n;
    }
    function O() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!ln(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function $(l) {
        var f = O();
        var a = l.includeSources && Object.create(null);
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) a[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var v = 0;
        var h = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, i, r, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!(e in a)) {
                    a[e] = n;
                }
            } : Qe,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                v = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += D(t - v);
            v = t;
            if (e == null) return;
            var o = f.index(e);
            c += D(o - h);
            h = o;
            c += D(i - m);
            m = i;
            c += D(r - _);
            _ = r;
            if (l.names && a != null) {
                var s = u.index(a);
                c += D(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var i = {
            Program: function(e) {
                return new Fn({
                    start: s(e),
                    end: f(e),
                    body: a(e.body.map(l))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                var i = new (e.async ? Ln : Bn)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var r = l(e.body);
                if (r instanceof kn) {
                    i.body = a(r.body);
                    i.value = null;
                } else {
                    i.body = [];
                    i.value = r;
                }
                return i;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Kn : Xn;
                } else {
                    n = e.generator ? Zn : Qn;
                }
                var t = [], i = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        i = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: i,
                    body: a(l(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Vn : Un;
                } else {
                    n = e.generator ? Gn : Wn;
                }
                var t = [], i = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        i = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: i,
                    body: a(l(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new nt({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            ClassExpression: function(e) {
                return new tt({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                var i = at, r = l(e.value);
                switch (e.kind) {
                  case "get":
                    i = ye;
                    r = new Pn(r);
                    break;

                  case "set":
                    i = we;
                    r = new Pn(r);
                    break;
                }
                return new i({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: r
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                return new rt({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: l(e.value)
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? qn : be)({
                    start: s(e),
                    end: f(e),
                    init: l(e.left),
                    object: l(e.right),
                    body: l(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new gt({
                    start: s(e),
                    end: f(e),
                    body: l(e.block).body,
                    bcatch: l(n[0]),
                    bfinally: e.finalizer ? new yt(l(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? l(e.key) : o(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: l(e.value)
                };
                if (e.kind == "init") return new (e.method ? ei : Zt)(t);
                t.value = new Pn(t.value);
                if (e.kind == "get") return new ti(t);
                if (e.kind == "set") return new ni(t);
            },
            ArrayExpression: function(e) {
                return new Vt({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Oi() : l(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Oi());
                    } else if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                return new Gt({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(new Jt(l(e)));
                    }
                });
                return new Xt({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? jt : Ft)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: l(e.object),
                    property: e.computed ? l(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = l(e.meta);
                var t = o(e.property);
                if (n.name == "new" && t == "target") return new bi({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new Ft({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? _t : mt)({
                    start: s(e),
                    end: f(e),
                    expression: l(e.test),
                    body: e.consequent.map(l)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = e.exported ? o(e.exported) : "*";
                return new xe({
                    start: s(e),
                    end: f(e),
                    aliases: [ n ],
                    keys: [ "*" ],
                    path: e.source.value
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = l(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case Xn:
                    n = new Un(n);
                    break;

                  case Kn:
                    n = new Vn(n);
                    break;

                  case nt:
                    n = new tt(n);
                    break;

                  case Qn:
                    n = new Wn(n);
                    break;

                  case Zn:
                    n = new Gn(n);
                    break;
                }
                return new At({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new Tt({
                    start: s(e),
                    end: f(e),
                    body: l(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(o(e.exported));
                        t.push(o(e.local));
                    });
                    return new xe({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: e.source.value
                    });
                }
                return new Dt({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new hi(l(e.local));
                        n.alias = o(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = null, i = null, r = null;
                e.specifiers.forEach(function(e) {
                    var n = new oi(l(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        i = n;
                        i.key = "";
                        break;

                      case "ImportNamespaceSpecifier":
                        t = n;
                        t.key = "*";
                        break;

                      default:
                        n.key = e.imported.name || syn.name;
                        if (!r) r = [];
                        r.push(n);
                        break;
                    }
                });
                return new Ot({
                    start: s(e),
                    end: f(e),
                    all: t,
                    default: i,
                    properties: r,
                    path: e.source.value
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = l(e.source);
                return new zt({
                    start: n,
                    end: f(e),
                    expression: new vi({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: xt,
                    let: kt
                }[e.kind] || Et)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(l)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new Ei(n);
                }
                var t = e.value;
                if (t === null) return new Ti(n);
                var i = e.regex;
                if (i && i.pattern) {
                    n.value = new RegExp(i.pattern, i.flags);
                    n.value.raw_source = i.pattern;
                    return new Si(n);
                } else if (i) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new Si(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new xi(n);

                  case "number":
                    if (isNaN(t)) return new Ai(n);
                    var r, a;
                    if (isFinite(t)) {
                        r = 1 / t < 0;
                        n.value = r ? -t : t;
                        a = new ki(n);
                    } else {
                        r = t < 0;
                        a = new $i(n);
                    }
                    return r ? new It({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Ci : qi)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new yi({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(l),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = l(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = l(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = c.length - 1;
                do {
                    n = c[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === c[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === c[t + 1] || n.type == "VariableDeclarator" && n.id === c[t + 1]);
                var i = vi;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== c[t + 1]) i = ui;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    i = Se;
                    break;

                  case "CatchClause":
                    i = di;
                    break;

                  case "ClassDeclaration":
                    if (n.id === c[t + 1]) i = ke;
                    break;

                  case "ClassExpression":
                    if (n.id === c[t + 1]) i = pi;
                    break;

                  case "FunctionDeclaration":
                    i = n.id === c[t + 1] ? ci : ui;
                    break;

                  case "FunctionExpression":
                    i = n.id === c[t + 1] ? li : ui;
                    break;

                  case "LabeledStatement":
                    i = Ee;
                    break;

                  case "VariableDeclaration":
                    i = {
                        const: ai,
                        let: si
                    }[n.kind] || fi;
                    break;
                }
                return new i({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new _i({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new gi({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = l(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                return l(e.expression);
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? It : Ht)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: l(n.argument)
            });
        };
        u("EmptyStatement", _n);
        u("ExpressionStatement", bn, "expression>body");
        u("BlockStatement", kn, "body@body");
        u("IfStatement", dt, "test>condition, consequent>body, alternate>alternative");
        u("LabeledStatement", En, "label>label, body>body");
        u("BreakStatement", lt, "label>label");
        u("ContinueStatement", pt, "label>label");
        u("WithStatement", Cn, "object>expression, body>body");
        u("SwitchStatement", vt, "discriminant>expression, cases@body");
        u("ReturnStatement", ft, "argument>value");
        u("ThrowStatement", ut, "argument>value");
        u("WhileStatement", Dn, "test>condition, body>body");
        u("DoWhileStatement", An, "test>condition, body>body");
        u("ForStatement", On, "init>init, test>condition, update>step, body>body");
        u("ForInStatement", zn, "left>init, right>object, body>body");
        u("DebuggerStatement", hn);
        u("VariableDeclarator", St, "id>name, init>value");
        u("CatchClause", bt, "param>argname, body%body");
        u("BinaryExpression", Yt, "operator=operator, left>left, right>right");
        u("LogicalExpression", Yt, "operator=operator, left>left, right>right");
        u("AssignmentExpression", Bt, "operator=operator, left>left, right>right");
        u("AssignmentPattern", $t, "left>name, right>value");
        u("ConditionalExpression", Rt, "test>condition, consequent>consequent, alternate>alternative");
        u("NewExpression", qt, "callee>expression, arguments@args, pure=pure");
        u("CallExpression", zt, "callee>expression, arguments@args, optional=optional, pure=pure");
        u("SequenceExpression", Ct, "expressions@expressions");
        u("SpreadElement", Pt, "argument>expression");
        u("ObjectExpression", Kt, "properties@properties");
        u("AwaitExpression", Lt, "argument>expression");
        u("YieldExpression", Ut, "argument>expression, delegate=nested");
        d(Fn, function e(n) {
            return m("Program", n);
        });
        d(Jn, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: v(n.name),
                async: Hn(n),
                generator: Yn(n),
                params: t,
                body: m("BlockStatement", n)
            };
        });
        d(jn, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            if (In(n)) return {
                type: "ArrowFunctionExpression",
                async: Hn(n),
                params: t,
                body: n.value ? v(n.value) : m("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: v(n.name),
                async: Hn(n),
                generator: Yn(n),
                params: t,
                body: m("BlockStatement", n)
            };
        });
        d(nt, function e(n) {
            return {
                type: "ClassDeclaration",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        d(tt, function e(n) {
            return {
                type: "ClassExpression",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        function e(i) {
            return function(e) {
                var n = e.key instanceof dn;
                var t = n ? v(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: i,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: v(e.value)
                };
            };
        }
        d(ye, e("get"));
        d(we, e("set"));
        d(at, e("method"));
        d(rt, function e(n) {
            var t = n.key instanceof dn;
            var i = t ? v(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: i,
                static: n.static,
                value: v(n.value)
            };
        });
        function n(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: v(e.init),
                    right: v(e.object),
                    body: v(e.body)
                };
            };
        }
        d(qn, n(true));
        d(be, n(false));
        d(mn, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: p(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        d(ht, function e(n) {
            return {
                type: "SwitchCase",
                test: v(n.expression),
                consequent: n.body.map(v)
            };
        });
        d(gt, function e(n) {
            return {
                type: "TryStatement",
                block: h(n),
                handler: v(n.bcatch),
                guardedHandlers: [],
                finalizer: v(n.bfinally)
            };
        });
        d(bt, function e(n) {
            return {
                type: "CatchClause",
                param: v(n.argname),
                guard: null,
                body: h(n)
            };
        });
        d(Tt, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: v(n.body)
            };
        });
        d(At, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: v(n.body)
            };
        });
        d(xe, function e(n) {
            if (n.keys[0] == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0] == "*" ? null : {
                    type: "Identifier",
                    name: n.aliases[0]
                },
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
            var t = [];
            for (var i = 0; i < n.aliases.length; i++) {
                t.push({
                    type: "ExportSpecifier",
                    exported: {
                        type: "Identifier",
                        name: n.aliases[i]
                    },
                    local: {
                        type: "Identifier",
                        name: n.keys[i]
                    }
                });
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        d(Dt, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return {
                        type: "ExportSpecifier",
                        local: v(e),
                        exported: {
                            type: "Identifier",
                            name: e.alias
                        }
                    };
                })
            };
        });
        d(Ot, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return {
                    type: "ImportSpecifier",
                    local: v(e),
                    imported: {
                        type: "Identifier",
                        name: e.key
                    }
                };
            }) : [];
            if (n.all) t.unshift({
                type: "ImportNamespaceSpecifier",
                local: v(n.all)
            });
            if (n.default) t.unshift({
                type: "ImportDefaultSpecifier",
                local: v(n.default)
            });
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        d(wt, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(v)
            };
        });
        d(Mt, function e(n) {
            var t = n instanceof jt;
            return {
                type: "MemberExpression",
                object: v(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? v(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        d(Nt, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof It,
                argument: v(n.expression)
            };
        });
        d(Yt, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: v(n.left),
                operator: n.operator,
                right: v(n.right)
            };
        });
        d(Vt, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(v)
            };
        });
        d(Gt, function e(n) {
            var t = n.elements.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        d(Jt, function e(n) {
            var t = n.key instanceof dn;
            var i = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: i,
                value: v(n.value)
            };
        });
        d(Xt, function e(n) {
            var t = n.properties.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        d(Qt, function e(n) {
            var t = n.key instanceof dn;
            var i = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            var r;
            if (n instanceof Zt) {
                r = "init";
            } else if (n instanceof ti) {
                r = "get";
            } else if (n instanceof ni) {
                r = "set";
            }
            return {
                type: "Property",
                kind: r,
                computed: t,
                method: n instanceof ei,
                key: i,
                value: v(n.value)
            };
        });
        d(ii, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        d(_i, function e() {
            return {
                type: "Super"
            };
        });
        d(gi, function e() {
            return {
                type: "ThisExpression"
            };
        });
        d(bi, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        d(Si, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        d(Ei, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function t(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        d(zi, t);
        d(wi, t);
        d(Ti, t);
        d(g, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        d(yi, function e(n) {
            var t = n.strings.length - 1;
            var i = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(v),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return i;
            return {
                type: "TaggedTemplateExpression",
                tag: v(n.tag),
                quasi: i
            };
        });
        xn.DEFMETHOD("to_mozilla_ast", kn.prototype.to_mozilla_ast);
        Oi.DEFMETHOD("to_mozilla_ast", tn);
        dn.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function a(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof bn)) break;
                var i = t.body;
                if (!(i instanceof xi)) break;
                if (t.start.pos !== i.start.pos) break;
                e[n] = new mn(i);
            }
            return e;
        }
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new ee({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new ee({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function o(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function u(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                switch (i) {
                  case "@":
                    a.push(r + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + r + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(r + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + r + ")");
                    break;

                  case "=":
                    a.push(r + ": M." + t);
                    o.push(t + ": M." + r);
                    break;

                  case "%":
                    a.push(r + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            i[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(_, s, f, l);
            d(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(v, h, m));
        }
        var c = null;
        function l(e) {
            c.push(e);
            var n = null;
            if (e) {
                if (!ln(i, e.type)) throw new Error("Unsupported type: " + e.type);
                n = i[e.type](e);
            }
            c.pop();
            return n;
        }
        dn.from_mozilla_ast = function(e) {
            var n = c;
            c = [];
            var t = l(e);
            c = n;
            t.walk(new Mi(function(e) {
                if (e instanceof Se) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Mn) break;
                        if (t instanceof En && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        De("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function p(e, n) {
            var t = e.start;
            var i = e.end;
            if (t.pos != null && i.endpos != null) {
                n.range = [ t.pos, i.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: i.endline ? {
                        line: i.endline,
                        column: i.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function d(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return p(this, n(this));
            });
        }
        function v(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function h(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(v)
            };
        }
        function m(e, n) {
            var t = n.body.map(v);
            if (n.body[0] instanceof bn && n.body[0].body instanceof xi) {
                t.unshift(v(new _n(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var z = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return fn(n);
        function t(e) {
            n.push(e);
        }
    }();
    function q(e, n) {
        e.walk(new Mi(function(e) {
            if (e instanceof it) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Qt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof jt) {
                W(e.property, t);
            }
        }));
        function t(e) {
            an(n, e);
        }
    }
    function W(e, n) {
        if (e instanceof Rt) {
            W(e.consequent, n);
            W(e.alternative, n);
        } else if (e instanceof Ct) {
            W(e.tail_node(), n);
        } else if (e instanceof xi) {
            n(e.value);
        }
    }
    function G(e, t) {
        t = ge(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : z);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new cn();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new Mi(function(e) {
            if (e instanceof Yt) {
                if (e.operator == "in") W(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Ft) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof vi)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    W(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    W(e.args[0], p);
                    break;
                }
            } else if (e instanceof it) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Ft) {
                p(e.property);
            } else if (e instanceof Qt) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof jt) {
                W(e.property, p);
            }
        }));
        e.walk(new Mi(function(e) {
            if (e instanceof Yt) {
                if (e.operator == "in") v(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Ft) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof vi)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    v(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    v(e.args[0]);
                    break;
                }
            } else if (e instanceof it) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Ft) {
                e.property = d(e.property);
            } else if (e instanceof Qt) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof jt) {
                if (!t.keep_quoted) v(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (a && !a.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) return e;
            var n = r.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = E(++i);
                } while (!c(n));
                if (/^#/.test(e)) n = "#" + n;
                r.set(e, n);
            }
            return n;
        }
        function v(e) {
            if (e instanceof Ct) {
                v(e.expressions.tail_node());
            } else if (e instanceof xi) {
                e.value = d(e.value);
            } else if (e instanceof Rt) {
                v(e.consequent);
                v(e.alternative);
            }
        }
    }
    "use strict";
    var J, X;
    if (typeof Buffer == "undefined") {
        J = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        J = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        J = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(a[2]);
                if (!a) break;
                return J(a[2]);
            }
        }
        dn.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function Q(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function ae(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function oe(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new cn();
        } else if (!(e.props instanceof cn)) {
            e.props = cn.fromObject(e.props);
        }
    }
    function se(e) {
        return {
            props: e.props.toObject()
        };
    }
    function fe(i, r) {
        try {
            r = ge(r, {
                annotations: undefined,
                compress: {},
                enclose: false,
                ie: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) dn.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) r.rename = r.compress && r.mangle;
            if (r.annotations !== undefined) ae("annotations", r, [ "compress", "output" ]);
            if (r.ie8) r.ie = r.ie || r.ie8;
            if (r.ie) ae("ie", r, [ "compress", "mangle", "output" ]);
            if (r.keep_fnames) ae("keep_fnames", r, [ "compress", "mangle" ]);
            if (r.toplevel) ae("toplevel", r, [ "compress", "mangle" ]);
            if (r.v8) ae("v8", r, [ "mangle", "output" ]);
            if (r.webkit) ae("webkit", r, [ "compress", "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = ge(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                oe(r.mangle.cache);
                oe(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = ge(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) dn.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (i instanceof Fn) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var o = r.sourceMap && r.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = Q(o);
                }
                if (o) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (ln(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = a = Yi(i[s], r.parse);
                    if (o == "inline") {
                        var f = K(s, a);
                        if (f) {
                            r.sourceMap.orig[s] = Q(f);
                        }
                    } else if (o) {
                        r.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                q(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (r.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                a = new Li(r.compress).compress(a);
                if (r.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) G(a, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            var c = ge(r.output, {
                ast: false,
                code: true
            });
            if (c.ast) u.ast = a;
            if (c.code) {
                if (r.sourceMap) {
                    c.source_map = $(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof Fn) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (ln(i, s)) {
                            c.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete c.ast;
                delete c.code;
                var l = Ui(c);
                a.print(l);
                u.code = l.get();
                if (r.sourceMap) {
                    u.map = c.source_map.toString();
                    var p = r.sourceMap.url;
                    if (p) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = se(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = se(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            dn.log_function();
            dn.disable_validation();
        }
    }
    _["Dictionary"] = cn;
    _["is_statement"] = gn;
    _["List"] = rn;
    _["minify"] = fe;
    _["parse"] = Yi;
    _["push_uniq"] = an;
    _["TreeTransformer"] = Fi;
    _["TreeWalker"] = Mi;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
